// chrome/browser/media/kaleidoscope/mojom/kaleidoscope.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_SHARED_H_
#define CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/browser/media/kaleidoscope/mojom/kaleidoscope.mojom-shared-internal.h"
#include "chrome/browser/media/feeds/media_feeds_store.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"






namespace media {
namespace mojom {
class CredentialsDataView;



}  // namespace mojom
}  // namespace media

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::media::mojom::CredentialsDataView> {
  using Data = ::media::mojom::internal::Credentials_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace media {
namespace mojom {
// Interface base classes. They are used for type safety check.
class KaleidoscopeDataProviderInterfaceBase {};

using KaleidoscopeDataProviderPtrDataView =
    mojo::InterfacePtrDataView<KaleidoscopeDataProviderInterfaceBase>;
using KaleidoscopeDataProviderRequestDataView =
    mojo::InterfaceRequestDataView<KaleidoscopeDataProviderInterfaceBase>;
using KaleidoscopeDataProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<KaleidoscopeDataProviderInterfaceBase>;
using KaleidoscopeDataProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<KaleidoscopeDataProviderInterfaceBase>;
class CredentialsDataView {
 public:
  CredentialsDataView() {}

  CredentialsDataView(
      internal::Credentials_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetApiKeyDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadApiKey(UserType* output) {
    auto* pointer = data_->api_key.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetAccessTokenDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccessToken(UserType* output) {
    auto* pointer = data_->access_token.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Credentials_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace media

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media::mojom::CredentialsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media::mojom::CredentialsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media::mojom::internal::Credentials_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::api_key(input)) in_api_key = Traits::api_key(input);
    typename decltype((*output)->api_key)::BaseType::BufferWriter
        api_key_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_api_key, buffer, &api_key_writer, context);
    (*output)->api_key.Set(
        api_key_writer.is_null() ? nullptr : api_key_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->api_key.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null api_key in Credentials struct");
    decltype(Traits::access_token(input)) in_access_token = Traits::access_token(input);
    typename decltype((*output)->access_token)::BaseType::BufferWriter
        access_token_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_access_token, buffer, &access_token_writer, context);
    (*output)->access_token.Set(
        access_token_writer.is_null() ? nullptr : access_token_writer.data());
  }

  static bool Deserialize(::media::mojom::internal::Credentials_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media::mojom::CredentialsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace media {
namespace mojom {

inline void CredentialsDataView::GetApiKeyDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->api_key.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void CredentialsDataView::GetAccessTokenDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->access_token.Get();
  *output = mojo::StringDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace media

#endif  // CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_SHARED_H_