// chrome/browser/media/kaleidoscope/mojom/kaleidoscope.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_H_
#define CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/media/kaleidoscope/mojom/kaleidoscope.mojom-shared.h"
#include "chrome/browser/media/kaleidoscope/mojom/kaleidoscope.mojom-forward.h"
#include "chrome/browser/media/feeds/media_feeds_store.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace media {
namespace mojom {

class KaleidoscopeDataProviderProxy;

template <typename ImplRefTraits>
class KaleidoscopeDataProviderStub;

class KaleidoscopeDataProviderRequestValidator;
class KaleidoscopeDataProviderResponseValidator;


class  KaleidoscopeDataProvider
    : public KaleidoscopeDataProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = KaleidoscopeDataProviderInterfaceBase;
  using Proxy_ = KaleidoscopeDataProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = KaleidoscopeDataProviderStub<ImplRefTraits>;

  using RequestValidator_ = KaleidoscopeDataProviderRequestValidator;
  using ResponseValidator_ = KaleidoscopeDataProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetTopMediaFeedsMinVersion = 0,
    kGetMediaFeedContentsMinVersion = 0,
    kGetCredentialsMinVersion = 0,
  };
  virtual ~KaleidoscopeDataProvider() {}


  using GetTopMediaFeedsCallback = base::OnceCallback<void(std::vector<::media_feeds::mojom::MediaFeedPtr>)>;
  
  virtual void GetTopMediaFeeds(GetTopMediaFeedsCallback callback) = 0;


  using GetMediaFeedContentsCallback = base::OnceCallback<void(std::vector<::media_feeds::mojom::MediaFeedItemPtr>)>;
  
  virtual void GetMediaFeedContents(int64_t feed_id, GetMediaFeedContentsCallback callback) = 0;


  using GetCredentialsCallback = base::OnceCallback<void(CredentialsPtr)>;
  
  virtual void GetCredentials(GetCredentialsCallback callback) = 0;
};



class  KaleidoscopeDataProviderProxy
    : public KaleidoscopeDataProvider {
 public:
  using InterfaceType = KaleidoscopeDataProvider;

  explicit KaleidoscopeDataProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetTopMediaFeeds(GetTopMediaFeedsCallback callback) final;
  
  void GetMediaFeedContents(int64_t feed_id, GetMediaFeedContentsCallback callback) final;
  
  void GetCredentials(GetCredentialsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  KaleidoscopeDataProviderStubDispatch {
 public:
  static bool Accept(KaleidoscopeDataProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      KaleidoscopeDataProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<KaleidoscopeDataProvider>>
class KaleidoscopeDataProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  KaleidoscopeDataProviderStub() {}
  ~KaleidoscopeDataProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return KaleidoscopeDataProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return KaleidoscopeDataProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  KaleidoscopeDataProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  KaleidoscopeDataProviderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  Credentials {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Credentials, T>::value>;
  using DataView = CredentialsDataView;
  using Data_ = internal::Credentials_Data;

  template <typename... Args>
  static CredentialsPtr New(Args&&... args) {
    return CredentialsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CredentialsPtr From(const U& u) {
    return mojo::TypeConverter<CredentialsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Credentials>::Convert(*this);
  }


  Credentials();

  Credentials(
      const std::string& api_key,
      const base::Optional<std::string>& access_token);

  ~Credentials();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CredentialsPtr>
  CredentialsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Credentials::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Credentials::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Credentials::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Credentials_UnserializedMessageContext<
            UserType, Credentials::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Credentials::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Credentials::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Credentials_UnserializedMessageContext<
            UserType, Credentials::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Credentials::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string api_key;
  
  base::Optional<std::string> access_token;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Credentials::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Credentials::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Credentials::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Credentials::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
CredentialsPtr Credentials::Clone() const {
  return New(
      mojo::Clone(api_key),
      mojo::Clone(access_token)
  );
}

template <typename T, Credentials::EnableIfSame<T>*>
bool Credentials::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->api_key, other_struct.api_key))
    return false;
  if (!mojo::Equals(this->access_token, other_struct.access_token))
    return false;
  return true;
}

template <typename T, Credentials::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.api_key < rhs.api_key)
    return true;
  if (rhs.api_key < lhs.api_key)
    return false;
  if (lhs.access_token < rhs.access_token)
    return true;
  if (rhs.access_token < lhs.access_token)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace media

namespace mojo {


template <>
struct  StructTraits<::media::mojom::Credentials::DataView,
                                         ::media::mojom::CredentialsPtr> {
  static bool IsNull(const ::media::mojom::CredentialsPtr& input) { return !input; }
  static void SetToNull(::media::mojom::CredentialsPtr* output) { output->reset(); }

  static const decltype(::media::mojom::Credentials::api_key)& api_key(
      const ::media::mojom::CredentialsPtr& input) {
    return input->api_key;
  }

  static const decltype(::media::mojom::Credentials::access_token)& access_token(
      const ::media::mojom::CredentialsPtr& input) {
    return input->access_token;
  }

  static bool Read(::media::mojom::Credentials::DataView input, ::media::mojom::CredentialsPtr* output);
};

}  // namespace mojo

#endif  // CHROME_BROWSER_MEDIA_KALEIDOSCOPE_MOJOM_KALEIDOSCOPE_MOJOM_H_