// chrome/browser/ui/webui/internals/web_app/web_app_internals.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_INTERNALS_WEB_APP_WEB_APP_INTERNALS_MOJOM_H_
#define CHROME_BROWSER_UI_WEBUI_INTERNALS_WEB_APP_WEB_APP_INTERNALS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/ui/webui/internals/web_app/web_app_internals.mojom-shared.h"
#include "chrome/browser/ui/webui/internals/web_app/web_app_internals.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace mojom {
namespace web_app_internals {

class WebAppInternalsPageHandlerProxy;

template <typename ImplRefTraits>
class WebAppInternalsPageHandlerStub;

class WebAppInternalsPageHandlerRequestValidator;
class WebAppInternalsPageHandlerResponseValidator;


class  WebAppInternalsPageHandler
    : public WebAppInternalsPageHandlerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = WebAppInternalsPageHandlerInterfaceBase;
  using Proxy_ = WebAppInternalsPageHandlerProxy;

  template <typename ImplRefTraits>
  using Stub_ = WebAppInternalsPageHandlerStub<ImplRefTraits>;

  using RequestValidator_ = WebAppInternalsPageHandlerRequestValidator;
  using ResponseValidator_ = WebAppInternalsPageHandlerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kIsBmoEnabledMinVersion = 0,
    kGetWebAppsMinVersion = 0,
    kGetExternallyInstalledWebAppPrefsMinVersion = 0,
  };
  virtual ~WebAppInternalsPageHandler() {}


  using IsBmoEnabledCallback = base::OnceCallback<void(bool)>;
  
  virtual void IsBmoEnabled(IsBmoEnabledCallback callback) = 0;


  using GetWebAppsCallback = base::OnceCallback<void(std::vector<WebAppPtr>)>;
  
  virtual void GetWebApps(GetWebAppsCallback callback) = 0;


  using GetExternallyInstalledWebAppPrefsCallback = base::OnceCallback<void(const std::string&)>;
  
  virtual void GetExternallyInstalledWebAppPrefs(GetExternallyInstalledWebAppPrefsCallback callback) = 0;
};



class  WebAppInternalsPageHandlerProxy
    : public WebAppInternalsPageHandler {
 public:
  using InterfaceType = WebAppInternalsPageHandler;

  explicit WebAppInternalsPageHandlerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void IsBmoEnabled(IsBmoEnabledCallback callback) final;
  
  void GetWebApps(GetWebAppsCallback callback) final;
  
  void GetExternallyInstalledWebAppPrefs(GetExternallyInstalledWebAppPrefsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  WebAppInternalsPageHandlerStubDispatch {
 public:
  static bool Accept(WebAppInternalsPageHandler* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      WebAppInternalsPageHandler* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<WebAppInternalsPageHandler>>
class WebAppInternalsPageHandlerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  WebAppInternalsPageHandlerStub() {}
  ~WebAppInternalsPageHandlerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebAppInternalsPageHandlerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return WebAppInternalsPageHandlerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  WebAppInternalsPageHandlerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  WebAppInternalsPageHandlerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  WebApp {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WebApp, T>::value>;
  using DataView = WebAppDataView;
  using Data_ = internal::WebApp_Data;

  template <typename... Args>
  static WebAppPtr New(Args&&... args) {
    return WebAppPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WebAppPtr From(const U& u) {
    return mojo::TypeConverter<WebAppPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WebApp>::Convert(*this);
  }


  WebApp();

  WebApp(
      const std::string& id,
      const std::string& name,
      const std::string& debug_info);

  ~WebApp();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WebAppPtr>
  WebAppPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WebApp::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WebApp::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WebApp::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WebApp_UnserializedMessageContext<
            UserType, WebApp::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<WebApp::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return WebApp::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WebApp_UnserializedMessageContext<
            UserType, WebApp::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WebApp::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string id;
  
  std::string name;
  
  std::string debug_info;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WebApp::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WebApp::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WebApp::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WebApp::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
WebAppPtr WebApp::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(name),
      mojo::Clone(debug_info)
  );
}

template <typename T, WebApp::EnableIfSame<T>*>
bool WebApp::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->debug_info, other_struct.debug_info))
    return false;
  return true;
}

template <typename T, WebApp::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.debug_info < rhs.debug_info)
    return true;
  if (rhs.debug_info < lhs.debug_info)
    return false;
  return false;
}


}  // namespace web_app_internals
}  // namespace mojom

namespace mojo {


template <>
struct  StructTraits<::mojom::web_app_internals::WebApp::DataView,
                                         ::mojom::web_app_internals::WebAppPtr> {
  static bool IsNull(const ::mojom::web_app_internals::WebAppPtr& input) { return !input; }
  static void SetToNull(::mojom::web_app_internals::WebAppPtr* output) { output->reset(); }

  static const decltype(::mojom::web_app_internals::WebApp::id)& id(
      const ::mojom::web_app_internals::WebAppPtr& input) {
    return input->id;
  }

  static const decltype(::mojom::web_app_internals::WebApp::name)& name(
      const ::mojom::web_app_internals::WebAppPtr& input) {
    return input->name;
  }

  static const decltype(::mojom::web_app_internals::WebApp::debug_info)& debug_info(
      const ::mojom::web_app_internals::WebAppPtr& input) {
    return input->debug_info;
  }

  static bool Read(::mojom::web_app_internals::WebApp::DataView input, ::mojom::web_app_internals::WebAppPtr* output);
};

}  // namespace mojo

#endif  // CHROME_BROWSER_UI_WEBUI_INTERNALS_WEB_APP_WEB_APP_INTERNALS_MOJOM_H_