// chrome/browser/ui/webui/tab_search/tab_search.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_TAB_SEARCH_TAB_SEARCH_MOJOM_SHARED_H_
#define CHROME_BROWSER_UI_WEBUI_TAB_SEARCH_TAB_SEARCH_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/browser/ui/webui/tab_search/tab_search.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"






namespace tab_search {
namespace mojom {
class ProfileTabsDataView;

class WindowTabsDataView;

class TabDataView;

class TabGroupsDataView;

class TabGroupDataView;

class SwitchToTabInfoDataView;



}  // namespace mojom
}  // namespace tab_search

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::tab_search::mojom::ProfileTabsDataView> {
  using Data = ::tab_search::mojom::internal::ProfileTabs_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::tab_search::mojom::WindowTabsDataView> {
  using Data = ::tab_search::mojom::internal::WindowTabs_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::tab_search::mojom::TabDataView> {
  using Data = ::tab_search::mojom::internal::Tab_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::tab_search::mojom::TabGroupsDataView> {
  using Data = ::tab_search::mojom::internal::TabGroups_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::tab_search::mojom::TabGroupDataView> {
  using Data = ::tab_search::mojom::internal::TabGroup_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::tab_search::mojom::SwitchToTabInfoDataView> {
  using Data = ::tab_search::mojom::internal::SwitchToTabInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace tab_search {
namespace mojom {
// Interface base classes. They are used for type safety check.
class PageHandlerFactoryInterfaceBase {};

using PageHandlerFactoryPtrDataView =
    mojo::InterfacePtrDataView<PageHandlerFactoryInterfaceBase>;
using PageHandlerFactoryRequestDataView =
    mojo::InterfaceRequestDataView<PageHandlerFactoryInterfaceBase>;
using PageHandlerFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PageHandlerFactoryInterfaceBase>;
using PageHandlerFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PageHandlerFactoryInterfaceBase>;
class PageHandlerInterfaceBase {};

using PageHandlerPtrDataView =
    mojo::InterfacePtrDataView<PageHandlerInterfaceBase>;
using PageHandlerRequestDataView =
    mojo::InterfaceRequestDataView<PageHandlerInterfaceBase>;
using PageHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PageHandlerInterfaceBase>;
using PageHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PageHandlerInterfaceBase>;
class PageInterfaceBase {};

using PagePtrDataView =
    mojo::InterfacePtrDataView<PageInterfaceBase>;
using PageRequestDataView =
    mojo::InterfaceRequestDataView<PageInterfaceBase>;
using PageAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PageInterfaceBase>;
using PageAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PageInterfaceBase>;
class ProfileTabsDataView {
 public:
  ProfileTabsDataView() {}

  ProfileTabsDataView(
      internal::ProfileTabs_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWindowsDataView(
      mojo::ArrayDataView<WindowTabsDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWindows(UserType* output) {
    auto* pointer = data_->windows.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::tab_search::mojom::WindowTabsDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ProfileTabs_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WindowTabsDataView {
 public:
  WindowTabsDataView() {}

  WindowTabsDataView(
      internal::WindowTabs_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool active() const {
    return data_->active;
  }
  inline void GetTabsDataView(
      mojo::ArrayDataView<TabDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTabs(UserType* output) {
    auto* pointer = data_->tabs.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::tab_search::mojom::TabDataView>>(
        pointer, output, context_);
  }
 private:
  internal::WindowTabs_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TabDataView {
 public:
  TabDataView() {}

  TabDataView(
      internal::Tab_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool active() const {
    return data_->active;
  }
  int32_t index() const {
    return data_->index;
  }
  int32_t tab_id() const {
    return data_->tab_id;
  }
  inline void GetGroupIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGroupId(UserType* output) {
    auto* pointer = data_->group_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool pinned() const {
    return data_->pinned;
  }
  inline void GetTitleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTitle(UserType* output) {
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetFavIconUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFavIconUrl(UserType* output) {
    auto* pointer = data_->fav_icon_url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool is_default_favicon() const {
    return data_->is_default_favicon;
  }
  bool show_icon() const {
    return data_->show_icon;
  }
 private:
  internal::Tab_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TabGroupsDataView {
 public:
  TabGroupsDataView() {}

  TabGroupsDataView(
      internal::TabGroups_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetGroupsDataView(
      mojo::MapDataView<mojo::StringDataView, TabGroupDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGroups(UserType* output) {
    auto* pointer = data_->groups.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<mojo::StringDataView, ::tab_search::mojom::TabGroupDataView>>(
        pointer, output, context_);
  }
 private:
  internal::TabGroups_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TabGroupDataView {
 public:
  TabGroupDataView() {}

  TabGroupDataView(
      internal::TabGroup_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetColorDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadColor(UserType* output) {
    auto* pointer = data_->color.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetTextColorDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTextColor(UserType* output) {
    auto* pointer = data_->text_color.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetTitleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTitle(UserType* output) {
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::TabGroup_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SwitchToTabInfoDataView {
 public:
  SwitchToTabInfoDataView() {}

  SwitchToTabInfoDataView(
      internal::SwitchToTabInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tab_id() const {
    return data_->tab_id;
  }
 private:
  internal::SwitchToTabInfo_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace tab_search

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::ProfileTabsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::ProfileTabsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::ProfileTabs_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::windows(input)) in_windows = Traits::windows(input);
    typename decltype((*output)->windows)::BaseType::BufferWriter
        windows_writer;
    const mojo::internal::ContainerValidateParams windows_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::tab_search::mojom::WindowTabsDataView>>(
        in_windows, buffer, &windows_writer, &windows_validate_params,
        context);
    (*output)->windows.Set(
        windows_writer.is_null() ? nullptr : windows_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->windows.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null windows in ProfileTabs struct");
  }

  static bool Deserialize(::tab_search::mojom::internal::ProfileTabs_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::ProfileTabsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::WindowTabsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::WindowTabsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::WindowTabs_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->active = Traits::active(input);
    decltype(Traits::tabs(input)) in_tabs = Traits::tabs(input);
    typename decltype((*output)->tabs)::BaseType::BufferWriter
        tabs_writer;
    const mojo::internal::ContainerValidateParams tabs_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::tab_search::mojom::TabDataView>>(
        in_tabs, buffer, &tabs_writer, &tabs_validate_params,
        context);
    (*output)->tabs.Set(
        tabs_writer.is_null() ? nullptr : tabs_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->tabs.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tabs in WindowTabs struct");
  }

  static bool Deserialize(::tab_search::mojom::internal::WindowTabs_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::WindowTabsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::TabDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::TabDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::Tab_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->active = Traits::active(input);
    (*output)->index = Traits::index(input);
    (*output)->tab_id = Traits::tab_id(input);
    decltype(Traits::group_id(input)) in_group_id = Traits::group_id(input);
    typename decltype((*output)->group_id)::BaseType::BufferWriter
        group_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_group_id, buffer, &group_id_writer, context);
    (*output)->group_id.Set(
        group_id_writer.is_null() ? nullptr : group_id_writer.data());
    (*output)->pinned = Traits::pinned(input);
    decltype(Traits::title(input)) in_title = Traits::title(input);
    typename decltype((*output)->title)::BaseType::BufferWriter
        title_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_title, buffer, &title_writer, context);
    (*output)->title.Set(
        title_writer.is_null() ? nullptr : title_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in Tab struct");
    decltype(Traits::url(input)) in_url = Traits::url(input);
    typename decltype((*output)->url)::BaseType::BufferWriter
        url_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_url, buffer, &url_writer, context);
    (*output)->url.Set(
        url_writer.is_null() ? nullptr : url_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in Tab struct");
    decltype(Traits::fav_icon_url(input)) in_fav_icon_url = Traits::fav_icon_url(input);
    typename decltype((*output)->fav_icon_url)::BaseType::BufferWriter
        fav_icon_url_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_fav_icon_url, buffer, &fav_icon_url_writer, context);
    (*output)->fav_icon_url.Set(
        fav_icon_url_writer.is_null() ? nullptr : fav_icon_url_writer.data());
    (*output)->is_default_favicon = Traits::is_default_favicon(input);
    (*output)->show_icon = Traits::show_icon(input);
  }

  static bool Deserialize(::tab_search::mojom::internal::Tab_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::TabDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::TabGroupsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::TabGroupsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::TabGroups_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::groups(input)) in_groups = Traits::groups(input);
    typename decltype((*output)->groups)::BaseType::BufferWriter
        groups_writer;
    const mojo::internal::ContainerValidateParams groups_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr)), new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, ::tab_search::mojom::TabGroupDataView>>(
        in_groups, buffer, &groups_writer, &groups_validate_params,
        context);
    (*output)->groups.Set(
        groups_writer.is_null() ? nullptr : groups_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->groups.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null groups in TabGroups struct");
  }

  static bool Deserialize(::tab_search::mojom::internal::TabGroups_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::TabGroupsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::TabGroupDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::TabGroupDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::TabGroup_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::color(input)) in_color = Traits::color(input);
    typename decltype((*output)->color)::BaseType::BufferWriter
        color_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_color, buffer, &color_writer, context);
    (*output)->color.Set(
        color_writer.is_null() ? nullptr : color_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->color.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null color in TabGroup struct");
    decltype(Traits::text_color(input)) in_text_color = Traits::text_color(input);
    typename decltype((*output)->text_color)::BaseType::BufferWriter
        text_color_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_text_color, buffer, &text_color_writer, context);
    (*output)->text_color.Set(
        text_color_writer.is_null() ? nullptr : text_color_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->text_color.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null text_color in TabGroup struct");
    decltype(Traits::title(input)) in_title = Traits::title(input);
    typename decltype((*output)->title)::BaseType::BufferWriter
        title_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_title, buffer, &title_writer, context);
    (*output)->title.Set(
        title_writer.is_null() ? nullptr : title_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in TabGroup struct");
  }

  static bool Deserialize(::tab_search::mojom::internal::TabGroup_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::TabGroupDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::tab_search::mojom::SwitchToTabInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::tab_search::mojom::SwitchToTabInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::tab_search::mojom::internal::SwitchToTabInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->tab_id = Traits::tab_id(input);
  }

  static bool Deserialize(::tab_search::mojom::internal::SwitchToTabInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::tab_search::mojom::SwitchToTabInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace tab_search {
namespace mojom {

inline void ProfileTabsDataView::GetWindowsDataView(
    mojo::ArrayDataView<WindowTabsDataView>* output) {
  auto pointer = data_->windows.Get();
  *output = mojo::ArrayDataView<WindowTabsDataView>(pointer, context_);
}


inline void WindowTabsDataView::GetTabsDataView(
    mojo::ArrayDataView<TabDataView>* output) {
  auto pointer = data_->tabs.Get();
  *output = mojo::ArrayDataView<TabDataView>(pointer, context_);
}


inline void TabDataView::GetGroupIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->group_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabDataView::GetTitleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->title.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabDataView::GetUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->url.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabDataView::GetFavIconUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->fav_icon_url.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void TabGroupsDataView::GetGroupsDataView(
    mojo::MapDataView<mojo::StringDataView, TabGroupDataView>* output) {
  auto pointer = data_->groups.Get();
  *output = mojo::MapDataView<mojo::StringDataView, TabGroupDataView>(pointer, context_);
}


inline void TabGroupDataView::GetColorDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->color.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabGroupDataView::GetTextColorDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->text_color.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabGroupDataView::GetTitleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->title.Get();
  *output = mojo::StringDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace tab_search

#endif  // CHROME_BROWSER_UI_WEBUI_TAB_SEARCH_TAB_SEARCH_MOJOM_SHARED_H_