// chrome/browser/ui/webui/tab_search/tab_search.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/browser/ui/webui/tab_search/tab_search.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/ui/webui/tab_search/tab_search.mojom-params-data.h"
#include "chrome/browser/ui/webui/tab_search/tab_search.mojom-shared-message-ids.h"

#include "chrome/browser/ui/webui/tab_search/tab_search.mojom-import-headers.h"


#ifndef CHROME_BROWSER_UI_WEBUI_TAB_SEARCH_TAB_SEARCH_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_TAB_SEARCH_TAB_SEARCH_MOJOM_JUMBO_H_
#endif
namespace tab_search {
namespace mojom {
ProfileTabs::ProfileTabs()
    : windows() {}

ProfileTabs::ProfileTabs(
    std::vector<WindowTabsPtr> windows_in)
    : windows(std::move(windows_in)) {}

ProfileTabs::~ProfileTabs() = default;

bool ProfileTabs::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
WindowTabs::WindowTabs()
    : active(),
      tabs() {}

WindowTabs::WindowTabs(
    bool active_in,
    std::vector<TabPtr> tabs_in)
    : active(std::move(active_in)),
      tabs(std::move(tabs_in)) {}

WindowTabs::~WindowTabs() = default;

bool WindowTabs::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Tab::Tab()
    : active(),
      index(),
      tab_id(),
      group_id(),
      pinned(),
      title(),
      url(),
      fav_icon_url(),
      is_default_favicon(),
      show_icon() {}

Tab::Tab(
    bool active_in,
    int32_t index_in,
    int32_t tab_id_in,
    const base::Optional<std::string>& group_id_in,
    bool pinned_in,
    const std::string& title_in,
    const std::string& url_in,
    const base::Optional<std::string>& fav_icon_url_in,
    bool is_default_favicon_in,
    bool show_icon_in)
    : active(std::move(active_in)),
      index(std::move(index_in)),
      tab_id(std::move(tab_id_in)),
      group_id(std::move(group_id_in)),
      pinned(std::move(pinned_in)),
      title(std::move(title_in)),
      url(std::move(url_in)),
      fav_icon_url(std::move(fav_icon_url_in)),
      is_default_favicon(std::move(is_default_favicon_in)),
      show_icon(std::move(show_icon_in)) {}

Tab::~Tab() = default;

bool Tab::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TabGroups::TabGroups()
    : groups() {}

TabGroups::TabGroups(
    base::flat_map<std::string, TabGroupPtr> groups_in)
    : groups(std::move(groups_in)) {}

TabGroups::~TabGroups() = default;

bool TabGroups::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TabGroup::TabGroup()
    : color(),
      text_color(),
      title() {}

TabGroup::TabGroup(
    const std::string& color_in,
    const std::string& text_color_in,
    const std::string& title_in)
    : color(std::move(color_in)),
      text_color(std::move(text_color_in)),
      title(std::move(title_in)) {}

TabGroup::~TabGroup() = default;
size_t TabGroup::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->color);
  seed = mojo::internal::Hash(seed, this->text_color);
  seed = mojo::internal::Hash(seed, this->title);
  return seed;
}

bool TabGroup::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SwitchToTabInfo::SwitchToTabInfo()
    : tab_id() {}

SwitchToTabInfo::SwitchToTabInfo(
    int32_t tab_id_in)
    : tab_id(std::move(tab_id_in)) {}

SwitchToTabInfo::~SwitchToTabInfo() = default;
size_t SwitchToTabInfo::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->tab_id);
  return seed;
}

bool SwitchToTabInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char PageHandlerFactory::Name_[] = "tab_search.mojom.PageHandlerFactory";

PageHandlerFactoryProxy::PageHandlerFactoryProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageHandlerFactoryProxy::CreatePageHandler(
    ::mojo::PendingRemote<Page> in_page, ::mojo::PendingReceiver<PageHandler> in_handler) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "tab_search::mojom::PageHandlerFactory::CreatePageHandler");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandlerFactory_CreatePageHandler_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandlerFactory_CreatePageHandler_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::tab_search::mojom::PageInterfaceBase>>(
      in_page, &params->page, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->page),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid page in PageHandlerFactory.CreatePageHandler request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::tab_search::mojom::PageHandlerInterfaceBase>>(
      in_handler, &params->handler, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->handler),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid handler in PageHandlerFactory.CreatePageHandler request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandlerFactory::Name_);
  message.set_method_name("CreatePageHandler");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PageHandlerFactoryStubDispatch::Accept(
    PageHandlerFactory* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPageHandlerFactory_CreatePageHandler_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)tab_search::mojom::PageHandlerFactory::CreatePageHandler",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)tab_search::mojom::PageHandlerFactory::CreatePageHandler");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandlerFactory_CreatePageHandler_Params_Data* params =
          reinterpret_cast<internal::PageHandlerFactory_CreatePageHandler_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::mojo::PendingRemote<Page> p_page{};
      ::mojo::PendingReceiver<PageHandler> p_handler{};
      PageHandlerFactory_CreatePageHandler_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success) {
        p_page =
            input_data_view.TakePage<decltype(p_page)>();
      }
      if (success) {
        p_handler =
            input_data_view.TakeHandler<decltype(p_handler)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandlerFactory::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreatePageHandler(
std::move(p_page), 
std::move(p_handler));
      return true;
    }
  }
  return false;
}

// static
bool PageHandlerFactoryStubDispatch::AcceptWithResponder(
    PageHandlerFactory* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPageHandlerFactory_CreatePageHandler_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageHandlerFactoryValidationInfo[] = {
    {internal::kPageHandlerFactory_CreatePageHandler_Name,
     {&internal::PageHandlerFactory_CreatePageHandler_Params_Data::Validate,
      nullptr /* no response */}},
};

bool PageHandlerFactoryRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::tab_search::mojom::PageHandlerFactory::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageHandlerFactoryValidationInfo);
}

const char PageHandler::Name_[] = "tab_search.mojom.PageHandler";

class PageHandler_GetProfileTabs_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_GetProfileTabs_ForwardToCallback(
      PageHandler::GetProfileTabsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::GetProfileTabsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetProfileTabs_ForwardToCallback);
};

class PageHandler_GetTabGroups_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PageHandler_GetTabGroups_ForwardToCallback(
      PageHandler::GetTabGroupsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PageHandler::GetTabGroupsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetTabGroups_ForwardToCallback);
};

PageHandlerProxy::PageHandlerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PageHandlerProxy::GetProfileTabs(
    GetProfileTabsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "tab_search::mojom::PageHandler::GetProfileTabs");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetProfileTabs_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandler_GetProfileTabs_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetProfileTabs");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_GetProfileTabs_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PageHandlerProxy::GetTabGroups(
    GetTabGroupsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "tab_search::mojom::PageHandler::GetTabGroups");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetTabGroups_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandler_GetTabGroups_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetTabGroups");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PageHandler_GetTabGroups_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PageHandlerProxy::SwitchToTab(
    SwitchToTabInfoPtr in_switch_to_tab_info) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "tab_search::mojom::PageHandler::SwitchToTab");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_SwitchToTab_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandler_SwitchToTab_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->switch_to_tab_info)::BaseType::BufferWriter
      switch_to_tab_info_writer;
  mojo::internal::Serialize<::tab_search::mojom::SwitchToTabInfoDataView>(
      in_switch_to_tab_info, buffer, &switch_to_tab_info_writer, &serialization_context);
  params->switch_to_tab_info.Set(
      switch_to_tab_info_writer.is_null() ? nullptr : switch_to_tab_info_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->switch_to_tab_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null switch_to_tab_info in PageHandler.SwitchToTab request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("SwitchToTab");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class PageHandler_GetProfileTabs_ProxyToResponder {
 public:
  static PageHandler::GetProfileTabsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<PageHandler_GetProfileTabs_ProxyToResponder> proxy(
        new PageHandler_GetProfileTabs_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&PageHandler_GetProfileTabs_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_GetProfileTabs_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PageHandler_GetProfileTabs_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::GetProfileTabsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ProfileTabsPtr in_profile_tabs);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetProfileTabs_ProxyToResponder);
};

bool PageHandler_GetProfileTabs_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "tab_search::mojom::PageHandler::GetProfileTabsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PageHandler_GetProfileTabs_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_GetProfileTabs_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  ProfileTabsPtr p_profile_tabs{};
  PageHandler_GetProfileTabs_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadProfileTabs(&p_profile_tabs))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_profile_tabs));
  return true;
}

void PageHandler_GetProfileTabs_ProxyToResponder::Run(
    ProfileTabsPtr in_profile_tabs) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetProfileTabs_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandler_GetProfileTabs_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->profile_tabs)::BaseType::BufferWriter
      profile_tabs_writer;
  mojo::internal::Serialize<::tab_search::mojom::ProfileTabsDataView>(
      in_profile_tabs, buffer, &profile_tabs_writer, &serialization_context);
  params->profile_tabs.Set(
      profile_tabs_writer.is_null() ? nullptr : profile_tabs_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->profile_tabs.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null profile_tabs in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)tab_search::mojom::PageHandler::GetProfileTabsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetProfileTabs");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PageHandler_GetTabGroups_ProxyToResponder {
 public:
  static PageHandler::GetTabGroupsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder) {
    std::unique_ptr<PageHandler_GetTabGroups_ProxyToResponder> proxy(
        new PageHandler_GetTabGroups_ProxyToResponder(
            request_id, is_sync, responder));
    return base::BindOnce(&PageHandler_GetTabGroups_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PageHandler_GetTabGroups_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PageHandler_GetTabGroups_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus>* responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(*responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PageHandler::GetTabGroupsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      TabGroupsPtr in_tab_groups);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PageHandler_GetTabGroups_ProxyToResponder);
};

bool PageHandler_GetTabGroups_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "tab_search::mojom::PageHandler::GetTabGroupsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PageHandler_GetTabGroups_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PageHandler_GetTabGroups_ResponseParams_Data*>(
              message->mutable_payload());
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  
  bool success = true;
  TabGroupsPtr p_tab_groups{};
  PageHandler_GetTabGroups_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadTabGroups(&p_tab_groups))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        PageHandler::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_tab_groups));
  return true;
}

void PageHandler_GetTabGroups_ProxyToResponder::Run(
    TabGroupsPtr in_tab_groups) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPageHandler_GetTabGroups_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::tab_search::mojom::internal::PageHandler_GetTabGroups_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->tab_groups)::BaseType::BufferWriter
      tab_groups_writer;
  mojo::internal::Serialize<::tab_search::mojom::TabGroupsDataView>(
      in_tab_groups, buffer, &tab_groups_writer, &serialization_context);
  params->tab_groups.Set(
      tab_groups_writer.is_null() ? nullptr : tab_groups_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->tab_groups.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tab_groups in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)tab_search::mojom::PageHandler::GetTabGroupsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PageHandler::Name_);
  message.set_method_name("GetTabGroups");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PageHandlerStubDispatch::Accept(
    PageHandler* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPageHandler_GetProfileTabs_Name: {
      break;
    }
    case internal::kPageHandler_GetTabGroups_Name: {
      break;
    }
    case internal::kPageHandler_SwitchToTab_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)tab_search::mojom::PageHandler::SwitchToTab",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)tab_search::mojom::PageHandler::SwitchToTab");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PageHandler_SwitchToTab_Params_Data* params =
          reinterpret_cast<internal::PageHandler_SwitchToTab_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      SwitchToTabInfoPtr p_switch_to_tab_info{};
      PageHandler_SwitchToTab_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadSwitchToTabInfo(&p_switch_to_tab_info))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SwitchToTab(
std::move(p_switch_to_tab_info));
      return true;
    }
  }
  return false;
}

// static
bool PageHandlerStubDispatch::AcceptWithResponder(
    PageHandler* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPageHandler_GetProfileTabs_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)tab_search::mojom::PageHandler::GetProfileTabs",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)tab_search::mojom::PageHandler::GetProfileTabs");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::PageHandler_GetProfileTabs_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_GetProfileTabs_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      PageHandler_GetProfileTabs_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 0, false);
        return false;
      }
      PageHandler::GetProfileTabsCallback callback =
          PageHandler_GetProfileTabs_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetProfileTabs(std::move(callback));
      return true;
    }
    case internal::kPageHandler_GetTabGroups_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)tab_search::mojom::PageHandler::GetTabGroups",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)tab_search::mojom::PageHandler::GetTabGroups");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      internal::PageHandler_GetTabGroups_Params_Data* params =
          reinterpret_cast<
              internal::PageHandler_GetTabGroups_Params_Data*>(
                  message->mutable_payload());
      
      bool success = true;
      PageHandler_GetTabGroups_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PageHandler::Name_, 1, false);
        return false;
      }
      PageHandler::GetTabGroupsCallback callback =
          PageHandler_GetTabGroups_ProxyToResponder::CreateCallback(
              message->request_id(), message_is_sync, &responder);
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetTabGroups(std::move(callback));
      return true;
    }
    case internal::kPageHandler_SwitchToTab_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kPageHandlerValidationInfo[] = {
    {internal::kPageHandler_GetProfileTabs_Name,
     {&internal::PageHandler_GetProfileTabs_Params_Data::Validate,
      &internal::PageHandler_GetProfileTabs_ResponseParams_Data::Validate}},
    {internal::kPageHandler_GetTabGroups_Name,
     {&internal::PageHandler_GetTabGroups_Params_Data::Validate,
      &internal::PageHandler_GetTabGroups_ResponseParams_Data::Validate}},
    {internal::kPageHandler_SwitchToTab_Name,
     {&internal::PageHandler_SwitchToTab_Params_Data::Validate,
      nullptr /* no response */}},
};

bool PageHandlerRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::tab_search::mojom::PageHandler::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kPageHandlerValidationInfo);
}

bool PageHandlerResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::tab_search::mojom::PageHandler::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kPageHandlerValidationInfo);

}
const char Page::Name_[] = "tab_search.mojom.Page";

PageProxy::PageProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

// static
bool PageStubDispatch::Accept(
    Page* impl,
    mojo::Message* message) {
  return false;
}

// static
bool PageStubDispatch::AcceptWithResponder(
    Page* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  return false;
}



bool PageRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::tab_search::mojom::Page::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, {});
}

}  // namespace mojom
}  // namespace tab_search

namespace mojo {


// static
bool StructTraits<::tab_search::mojom::ProfileTabs::DataView, ::tab_search::mojom::ProfileTabsPtr>::Read(
    ::tab_search::mojom::ProfileTabs::DataView input,
    ::tab_search::mojom::ProfileTabsPtr* output) {
  bool success = true;
  ::tab_search::mojom::ProfileTabsPtr result(::tab_search::mojom::ProfileTabs::New());
  
      if (success && !input.ReadWindows(&result->windows))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::tab_search::mojom::WindowTabs::DataView, ::tab_search::mojom::WindowTabsPtr>::Read(
    ::tab_search::mojom::WindowTabs::DataView input,
    ::tab_search::mojom::WindowTabsPtr* output) {
  bool success = true;
  ::tab_search::mojom::WindowTabsPtr result(::tab_search::mojom::WindowTabs::New());
  
      if (success)
        result->active = input.active();
      if (success && !input.ReadTabs(&result->tabs))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::tab_search::mojom::Tab::DataView, ::tab_search::mojom::TabPtr>::Read(
    ::tab_search::mojom::Tab::DataView input,
    ::tab_search::mojom::TabPtr* output) {
  bool success = true;
  ::tab_search::mojom::TabPtr result(::tab_search::mojom::Tab::New());
  
      if (success)
        result->active = input.active();
      if (success)
        result->index = input.index();
      if (success)
        result->tab_id = input.tab_id();
      if (success && !input.ReadGroupId(&result->group_id))
        success = false;
      if (success)
        result->pinned = input.pinned();
      if (success && !input.ReadTitle(&result->title))
        success = false;
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadFavIconUrl(&result->fav_icon_url))
        success = false;
      if (success)
        result->is_default_favicon = input.is_default_favicon();
      if (success)
        result->show_icon = input.show_icon();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::tab_search::mojom::TabGroups::DataView, ::tab_search::mojom::TabGroupsPtr>::Read(
    ::tab_search::mojom::TabGroups::DataView input,
    ::tab_search::mojom::TabGroupsPtr* output) {
  bool success = true;
  ::tab_search::mojom::TabGroupsPtr result(::tab_search::mojom::TabGroups::New());
  
      if (success && !input.ReadGroups(&result->groups))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::tab_search::mojom::TabGroup::DataView, ::tab_search::mojom::TabGroupPtr>::Read(
    ::tab_search::mojom::TabGroup::DataView input,
    ::tab_search::mojom::TabGroupPtr* output) {
  bool success = true;
  ::tab_search::mojom::TabGroupPtr result(::tab_search::mojom::TabGroup::New());
  
      if (success && !input.ReadColor(&result->color))
        success = false;
      if (success && !input.ReadTextColor(&result->text_color))
        success = false;
      if (success && !input.ReadTitle(&result->title))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::tab_search::mojom::SwitchToTabInfo::DataView, ::tab_search::mojom::SwitchToTabInfoPtr>::Read(
    ::tab_search::mojom::SwitchToTabInfo::DataView input,
    ::tab_search::mojom::SwitchToTabInfoPtr* output) {
  bool success = true;
  ::tab_search::mojom::SwitchToTabInfoPtr result(::tab_search::mojom::SwitchToTabInfo::New());
  
      if (success)
        result->tab_id = input.tab_id();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif