// chrome/common/caption.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CAPTION_MOJOM_SHARED_H_
#define CHROME_COMMON_CAPTION_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/common/caption.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"






namespace chrome {
namespace mojom {
class TranscriptionResultDataView;



}  // namespace mojom
}  // namespace chrome

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::chrome::mojom::TranscriptionResultDataView> {
  using Data = ::chrome::mojom::internal::TranscriptionResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace chrome {
namespace mojom {
// Interface base classes. They are used for type safety check.
class CaptionHostInterfaceBase {};

using CaptionHostPtrDataView =
    mojo::InterfacePtrDataView<CaptionHostInterfaceBase>;
using CaptionHostRequestDataView =
    mojo::InterfaceRequestDataView<CaptionHostInterfaceBase>;
using CaptionHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<CaptionHostInterfaceBase>;
using CaptionHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<CaptionHostInterfaceBase>;
class TranscriptionResultDataView {
 public:
  TranscriptionResultDataView() {}

  TranscriptionResultDataView(
      internal::TranscriptionResult_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTranscriptionDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTranscription(UserType* output) {
    auto* pointer = data_->transcription.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool is_final() const {
    return data_->is_final;
  }
 private:
  internal::TranscriptionResult_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace chrome

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::chrome::mojom::TranscriptionResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::chrome::mojom::TranscriptionResultDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::chrome::mojom::internal::TranscriptionResult_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::transcription(input)) in_transcription = Traits::transcription(input);
    typename decltype((*output)->transcription)::BaseType::BufferWriter
        transcription_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_transcription, buffer, &transcription_writer, context);
    (*output)->transcription.Set(
        transcription_writer.is_null() ? nullptr : transcription_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->transcription.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null transcription in TranscriptionResult struct");
    (*output)->is_final = Traits::is_final(input);
  }

  static bool Deserialize(::chrome::mojom::internal::TranscriptionResult_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::chrome::mojom::TranscriptionResultDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace chrome {
namespace mojom {

inline void TranscriptionResultDataView::GetTranscriptionDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->transcription.Get();
  *output = mojo::StringDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_CAPTION_MOJOM_SHARED_H_