// chrome/common/caption.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CAPTION_MOJOM_H_
#define CHROME_COMMON_CAPTION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/caption.mojom-shared.h"
#include "chrome/common/caption.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace chrome {
namespace mojom {

class CaptionHostProxy;

template <typename ImplRefTraits>
class CaptionHostStub;

class CaptionHostRequestValidator;
class CaptionHostResponseValidator;


class  CaptionHost
    : public CaptionHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = CaptionHostInterfaceBase;
  using Proxy_ = CaptionHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = CaptionHostStub<ImplRefTraits>;

  using RequestValidator_ = CaptionHostRequestValidator;
  using ResponseValidator_ = CaptionHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnTranscriptionMinVersion = 0,
  };
  virtual ~CaptionHost() {}


  using OnTranscriptionCallback = base::OnceCallback<void(bool)>;
  
  virtual void OnTranscription(TranscriptionResultPtr transcription_result, OnTranscriptionCallback callback) = 0;
};



class  CaptionHostProxy
    : public CaptionHost {
 public:
  using InterfaceType = CaptionHost;

  explicit CaptionHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OnTranscription(TranscriptionResultPtr transcription_result, OnTranscriptionCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  CaptionHostStubDispatch {
 public:
  static bool Accept(CaptionHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      CaptionHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<CaptionHost>>
class CaptionHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CaptionHostStub() {}
  ~CaptionHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CaptionHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CaptionHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  CaptionHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  CaptionHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  TranscriptionResult {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TranscriptionResult, T>::value>;
  using DataView = TranscriptionResultDataView;
  using Data_ = internal::TranscriptionResult_Data;

  template <typename... Args>
  static TranscriptionResultPtr New(Args&&... args) {
    return TranscriptionResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TranscriptionResultPtr From(const U& u) {
    return mojo::TypeConverter<TranscriptionResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TranscriptionResult>::Convert(*this);
  }


  TranscriptionResult();

  TranscriptionResult(
      const std::string& transcription,
      bool is_final);

  ~TranscriptionResult();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TranscriptionResultPtr>
  TranscriptionResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TranscriptionResult::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TranscriptionResult::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TranscriptionResult::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TranscriptionResult_UnserializedMessageContext<
            UserType, TranscriptionResult::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TranscriptionResult::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TranscriptionResult::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TranscriptionResult_UnserializedMessageContext<
            UserType, TranscriptionResult::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TranscriptionResult::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string transcription;
  
  bool is_final;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TranscriptionResult::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TranscriptionResult::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TranscriptionResult::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TranscriptionResult::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
TranscriptionResultPtr TranscriptionResult::Clone() const {
  return New(
      mojo::Clone(transcription),
      mojo::Clone(is_final)
  );
}

template <typename T, TranscriptionResult::EnableIfSame<T>*>
bool TranscriptionResult::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->transcription, other_struct.transcription))
    return false;
  if (!mojo::Equals(this->is_final, other_struct.is_final))
    return false;
  return true;
}

template <typename T, TranscriptionResult::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.transcription < rhs.transcription)
    return true;
  if (rhs.transcription < lhs.transcription)
    return false;
  if (lhs.is_final < rhs.is_final)
    return true;
  if (rhs.is_final < lhs.is_final)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace chrome

namespace mojo {


template <>
struct  StructTraits<::chrome::mojom::TranscriptionResult::DataView,
                                         ::chrome::mojom::TranscriptionResultPtr> {
  static bool IsNull(const ::chrome::mojom::TranscriptionResultPtr& input) { return !input; }
  static void SetToNull(::chrome::mojom::TranscriptionResultPtr* output) { output->reset(); }

  static const decltype(::chrome::mojom::TranscriptionResult::transcription)& transcription(
      const ::chrome::mojom::TranscriptionResultPtr& input) {
    return input->transcription;
  }

  static decltype(::chrome::mojom::TranscriptionResult::is_final) is_final(
      const ::chrome::mojom::TranscriptionResultPtr& input) {
    return input->is_final;
  }

  static bool Read(::chrome::mojom::TranscriptionResult::DataView input, ::chrome::mojom::TranscriptionResultPtr* output);
};

}  // namespace mojo

#endif  // CHROME_COMMON_CAPTION_MOJOM_H_