// chrome/services/sharing/public/mojom/nearby_connections.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/nearby_connections.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/nearby_connections.mojom-forward.h"
#include "chrome/services/sharing/public/mojom/nearby_connections_types.mojom-forward.h"
#include "device/bluetooth/public/mojom/adapter.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace location {
namespace nearby {
namespace connections {
namespace mojom {

class NearbyConnectionsProxy;

template <typename ImplRefTraits>
class NearbyConnectionsStub;

class NearbyConnectionsRequestValidator;


class  NearbyConnections
    : public NearbyConnectionsInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = NearbyConnectionsInterfaceBase;
  using Proxy_ = NearbyConnectionsProxy;

  template <typename ImplRefTraits>
  using Stub_ = NearbyConnectionsStub<ImplRefTraits>;

  using RequestValidator_ = NearbyConnectionsRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
  };
  virtual ~NearbyConnections() {}
};

class NearbyConnectionsHostProxy;

template <typename ImplRefTraits>
class NearbyConnectionsHostStub;

class NearbyConnectionsHostRequestValidator;
class NearbyConnectionsHostResponseValidator;


class  NearbyConnectionsHost
    : public NearbyConnectionsHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = NearbyConnectionsHostInterfaceBase;
  using Proxy_ = NearbyConnectionsHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = NearbyConnectionsHostStub<ImplRefTraits>;

  using RequestValidator_ = NearbyConnectionsHostRequestValidator;
  using ResponseValidator_ = NearbyConnectionsHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetBluetoothAdapterMinVersion = 0,
  };
  virtual ~NearbyConnectionsHost() {}


  using GetBluetoothAdapterCallback = base::OnceCallback<void(::mojo::PendingRemote<::bluetooth::mojom::Adapter>)>;
  
  virtual void GetBluetoothAdapter(GetBluetoothAdapterCallback callback) = 0;
};



class  NearbyConnectionsProxy
    : public NearbyConnections {
 public:
  using InterfaceType = NearbyConnections;

  explicit NearbyConnectionsProxy(mojo::MessageReceiverWithResponder* receiver);

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  NearbyConnectionsHostProxy
    : public NearbyConnectionsHost {
 public:
  using InterfaceType = NearbyConnectionsHost;

  explicit NearbyConnectionsHostProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetBluetoothAdapter(GetBluetoothAdapterCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  NearbyConnectionsStubDispatch {
 public:
  static bool Accept(NearbyConnections* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NearbyConnections* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NearbyConnections>>
class NearbyConnectionsStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NearbyConnectionsStub() {}
  ~NearbyConnectionsStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbyConnectionsStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbyConnectionsStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  NearbyConnectionsHostStubDispatch {
 public:
  static bool Accept(NearbyConnectionsHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NearbyConnectionsHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NearbyConnectionsHost>>
class NearbyConnectionsHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NearbyConnectionsHostStub() {}
  ~NearbyConnectionsHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbyConnectionsHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbyConnectionsHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  NearbyConnectionsRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  NearbyConnectionsHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  NearbyConnectionsHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace connections
}  // namespace nearby
}  // namespace location

namespace mojo {

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_MOJOM_H_