// chrome/services/sharing/public/mojom/nearby_connections_types.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_TYPES_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_TYPES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/nearby_connections_types.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/nearby_connections_types.mojom-forward.h"
#include "mojo/public/mojom/base/file.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace location {
namespace nearby {
namespace connections {
namespace mojom {







class  AdvertisingOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AdvertisingOptions, T>::value>;
  using DataView = AdvertisingOptionsDataView;
  using Data_ = internal::AdvertisingOptions_Data;

  template <typename... Args>
  static AdvertisingOptionsPtr New(Args&&... args) {
    return AdvertisingOptionsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AdvertisingOptionsPtr From(const U& u) {
    return mojo::TypeConverter<AdvertisingOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AdvertisingOptions>::Convert(*this);
  }


  AdvertisingOptions();

  AdvertisingOptions(
      Strategy strategy,
      bool auto_upgrade_bandwidth,
      bool enforce_topology_constraints);

  ~AdvertisingOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AdvertisingOptionsPtr>
  AdvertisingOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AdvertisingOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AdvertisingOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AdvertisingOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AdvertisingOptions_UnserializedMessageContext<
            UserType, AdvertisingOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AdvertisingOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AdvertisingOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AdvertisingOptions_UnserializedMessageContext<
            UserType, AdvertisingOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AdvertisingOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  Strategy strategy;
  
  bool auto_upgrade_bandwidth;
  
  bool enforce_topology_constraints;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AdvertisingOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AdvertisingOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AdvertisingOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AdvertisingOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  DiscoveryOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DiscoveryOptions, T>::value>;
  using DataView = DiscoveryOptionsDataView;
  using Data_ = internal::DiscoveryOptions_Data;

  template <typename... Args>
  static DiscoveryOptionsPtr New(Args&&... args) {
    return DiscoveryOptionsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DiscoveryOptionsPtr From(const U& u) {
    return mojo::TypeConverter<DiscoveryOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DiscoveryOptions>::Convert(*this);
  }


  DiscoveryOptions();

  explicit DiscoveryOptions(
      Strategy strategy);

  ~DiscoveryOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DiscoveryOptionsPtr>
  DiscoveryOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DiscoveryOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DiscoveryOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DiscoveryOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DiscoveryOptions_UnserializedMessageContext<
            UserType, DiscoveryOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<DiscoveryOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DiscoveryOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DiscoveryOptions_UnserializedMessageContext<
            UserType, DiscoveryOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DiscoveryOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  Strategy strategy;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DiscoveryOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DiscoveryOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DiscoveryOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DiscoveryOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class  PayloadTransferUpdate {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PayloadTransferUpdate, T>::value>;
  using DataView = PayloadTransferUpdateDataView;
  using Data_ = internal::PayloadTransferUpdate_Data;

  template <typename... Args>
  static PayloadTransferUpdatePtr New(Args&&... args) {
    return PayloadTransferUpdatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PayloadTransferUpdatePtr From(const U& u) {
    return mojo::TypeConverter<PayloadTransferUpdatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PayloadTransferUpdate>::Convert(*this);
  }


  PayloadTransferUpdate();

  PayloadTransferUpdate(
      int64_t payload_id,
      PayloadStatus status,
      uint64_t total_bytes,
      uint64_t bytes_transferred);

  ~PayloadTransferUpdate();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PayloadTransferUpdatePtr>
  PayloadTransferUpdatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PayloadTransferUpdate::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PayloadTransferUpdate::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PayloadTransferUpdate::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PayloadTransferUpdate_UnserializedMessageContext<
            UserType, PayloadTransferUpdate::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PayloadTransferUpdate::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PayloadTransferUpdate::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PayloadTransferUpdate_UnserializedMessageContext<
            UserType, PayloadTransferUpdate::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PayloadTransferUpdate::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int64_t payload_id;
  
  PayloadStatus status;
  
  uint64_t total_bytes;
  
  uint64_t bytes_transferred;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PayloadTransferUpdate::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PayloadTransferUpdate::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PayloadTransferUpdate::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PayloadTransferUpdate::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  PayloadContent {
 public:
  using DataView = PayloadContentDataView;
  using Data_ = internal::PayloadContent_Data;
  using Tag = Data_::PayloadContent_Tag;

  static PayloadContentPtr New() {
    return PayloadContentPtr(base::in_place);
  }
  // Construct an instance holding |bytes|.
  static PayloadContentPtr
  NewBytes(
      BytesPayloadPtr bytes) {
    auto result = PayloadContentPtr(base::in_place);
    result->set_bytes(std::move(bytes));
    return result;
  }
  // Construct an instance holding |file|.
  static PayloadContentPtr
  NewFile(
      FilePayloadPtr file) {
    auto result = PayloadContentPtr(base::in_place);
    result->set_file(std::move(file));
    return result;
  }

  template <typename U>
  static PayloadContentPtr From(const U& u) {
    return mojo::TypeConverter<PayloadContentPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PayloadContent>::Convert(*this);
  }

  PayloadContent();
  ~PayloadContent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = PayloadContentPtr>
  PayloadContentPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PayloadContent>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_bytes() const { return tag_ == Tag::BYTES; }

  
  BytesPayloadPtr& get_bytes() const {
    DCHECK(tag_ == Tag::BYTES);
    return *(data_.bytes);
  }

  
  void set_bytes(
      BytesPayloadPtr bytes);
  
  bool is_file() const { return tag_ == Tag::FILE; }

  
  FilePayloadPtr& get_file() const {
    DCHECK(tag_ == Tag::FILE);
    return *(data_.file);
  }

  
  void set_file(
      FilePayloadPtr file);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PayloadContent::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<PayloadContent::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    BytesPayloadPtr* bytes;
    FilePayloadPtr* file;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  ConnectionInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConnectionInfo, T>::value>;
  using DataView = ConnectionInfoDataView;
  using Data_ = internal::ConnectionInfo_Data;

  template <typename... Args>
  static ConnectionInfoPtr New(Args&&... args) {
    return ConnectionInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConnectionInfoPtr From(const U& u) {
    return mojo::TypeConverter<ConnectionInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConnectionInfo>::Convert(*this);
  }


  ConnectionInfo();

  ConnectionInfo(
      const std::string& remote_endpoint_name,
      const std::string& authentication_token,
      std::vector<uint8_t> raw_authentication_token,
      bool is_incoming_connection,
      std::vector<uint8_t> endpoint_info);

  ~ConnectionInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConnectionInfoPtr>
  ConnectionInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConnectionInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConnectionInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConnectionInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConnectionInfo_UnserializedMessageContext<
            UserType, ConnectionInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ConnectionInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ConnectionInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConnectionInfo_UnserializedMessageContext<
            UserType, ConnectionInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConnectionInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string remote_endpoint_name;
  
  std::string authentication_token;
  
  std::vector<uint8_t> raw_authentication_token;
  
  bool is_incoming_connection;
  
  std::vector<uint8_t> endpoint_info;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConnectionInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConnectionInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConnectionInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConnectionInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  DiscoveredEndpointInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DiscoveredEndpointInfo, T>::value>;
  using DataView = DiscoveredEndpointInfoDataView;
  using Data_ = internal::DiscoveredEndpointInfo_Data;

  template <typename... Args>
  static DiscoveredEndpointInfoPtr New(Args&&... args) {
    return DiscoveredEndpointInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DiscoveredEndpointInfoPtr From(const U& u) {
    return mojo::TypeConverter<DiscoveredEndpointInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DiscoveredEndpointInfo>::Convert(*this);
  }


  DiscoveredEndpointInfo();

  DiscoveredEndpointInfo(
      const std::string& service_id,
      const std::string& endpoint_name,
      std::vector<uint8_t> endpoint_info);

  ~DiscoveredEndpointInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DiscoveredEndpointInfoPtr>
  DiscoveredEndpointInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DiscoveredEndpointInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DiscoveredEndpointInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DiscoveredEndpointInfo_UnserializedMessageContext<
            UserType, DiscoveredEndpointInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<DiscoveredEndpointInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DiscoveredEndpointInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DiscoveredEndpointInfo_UnserializedMessageContext<
            UserType, DiscoveredEndpointInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DiscoveredEndpointInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string service_id;
  
  std::string endpoint_name;
  
  std::vector<uint8_t> endpoint_info;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  BytesPayload {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<BytesPayload, T>::value>;
  using DataView = BytesPayloadDataView;
  using Data_ = internal::BytesPayload_Data;

  template <typename... Args>
  static BytesPayloadPtr New(Args&&... args) {
    return BytesPayloadPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BytesPayloadPtr From(const U& u) {
    return mojo::TypeConverter<BytesPayloadPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BytesPayload>::Convert(*this);
  }


  BytesPayload();

  explicit BytesPayload(
      std::vector<uint8_t> bytes);

  ~BytesPayload();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BytesPayloadPtr>
  BytesPayloadPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, BytesPayload::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BytesPayload::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BytesPayload::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BytesPayload_UnserializedMessageContext<
            UserType, BytesPayload::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BytesPayload::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BytesPayload::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BytesPayload_UnserializedMessageContext<
            UserType, BytesPayload::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BytesPayload::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<uint8_t> bytes;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, BytesPayload::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, BytesPayload::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, BytesPayload::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, BytesPayload::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FilePayload {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilePayload, T>::value>;
  using DataView = FilePayloadDataView;
  using Data_ = internal::FilePayload_Data;

  template <typename... Args>
  static FilePayloadPtr New(Args&&... args) {
    return FilePayloadPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilePayloadPtr From(const U& u) {
    return mojo::TypeConverter<FilePayloadPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilePayload>::Convert(*this);
  }


  FilePayload();

  explicit FilePayload(
      ::base::File file);

  ~FilePayload();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilePayloadPtr>
  FilePayloadPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilePayload::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilePayload::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilePayload::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilePayload_UnserializedMessageContext<
            UserType, FilePayload::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FilePayload::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FilePayload::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilePayload_UnserializedMessageContext<
            UserType, FilePayload::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilePayload::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::base::File file;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(FilePayload);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilePayload::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilePayload::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilePayload::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilePayload::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Payload {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Payload, T>::value>;
  using DataView = PayloadDataView;
  using Data_ = internal::Payload_Data;

  template <typename... Args>
  static PayloadPtr New(Args&&... args) {
    return PayloadPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PayloadPtr From(const U& u) {
    return mojo::TypeConverter<PayloadPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Payload>::Convert(*this);
  }


  Payload();

  Payload(
      int64_t id,
      PayloadContentPtr content);

  ~Payload();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PayloadPtr>
  PayloadPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Payload::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Payload::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Payload::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Payload_UnserializedMessageContext<
            UserType, Payload::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Payload::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Payload::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Payload_UnserializedMessageContext<
            UserType, Payload::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Payload::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int64_t id;
  
  PayloadContentPtr content;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Payload);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Payload::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Payload::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Payload::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Payload::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}


template <typename UnionPtrType>
PayloadContentPtr PayloadContent::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::BYTES:
      rv->set_bytes(mojo::Clone(*data_.bytes));
      break;
    case Tag::FILE:
      rv->set_file(mojo::Clone(*data_.file));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PayloadContent>::value>::type*>
bool PayloadContent::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::BYTES:
      return mojo::Equals(*(data_.bytes), *(other.data_.bytes));
    case Tag::FILE:
      return mojo::Equals(*(data_.file), *(other.data_.file));
  }

  return false;
}
template <typename StructPtrType>
ConnectionInfoPtr ConnectionInfo::Clone() const {
  return New(
      mojo::Clone(remote_endpoint_name),
      mojo::Clone(authentication_token),
      mojo::Clone(raw_authentication_token),
      mojo::Clone(is_incoming_connection),
      mojo::Clone(endpoint_info)
  );
}

template <typename T, ConnectionInfo::EnableIfSame<T>*>
bool ConnectionInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->remote_endpoint_name, other_struct.remote_endpoint_name))
    return false;
  if (!mojo::Equals(this->authentication_token, other_struct.authentication_token))
    return false;
  if (!mojo::Equals(this->raw_authentication_token, other_struct.raw_authentication_token))
    return false;
  if (!mojo::Equals(this->is_incoming_connection, other_struct.is_incoming_connection))
    return false;
  if (!mojo::Equals(this->endpoint_info, other_struct.endpoint_info))
    return false;
  return true;
}

template <typename T, ConnectionInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.remote_endpoint_name < rhs.remote_endpoint_name)
    return true;
  if (rhs.remote_endpoint_name < lhs.remote_endpoint_name)
    return false;
  if (lhs.authentication_token < rhs.authentication_token)
    return true;
  if (rhs.authentication_token < lhs.authentication_token)
    return false;
  if (lhs.raw_authentication_token < rhs.raw_authentication_token)
    return true;
  if (rhs.raw_authentication_token < lhs.raw_authentication_token)
    return false;
  if (lhs.is_incoming_connection < rhs.is_incoming_connection)
    return true;
  if (rhs.is_incoming_connection < lhs.is_incoming_connection)
    return false;
  if (lhs.endpoint_info < rhs.endpoint_info)
    return true;
  if (rhs.endpoint_info < lhs.endpoint_info)
    return false;
  return false;
}
template <typename StructPtrType>
DiscoveredEndpointInfoPtr DiscoveredEndpointInfo::Clone() const {
  return New(
      mojo::Clone(service_id),
      mojo::Clone(endpoint_name),
      mojo::Clone(endpoint_info)
  );
}

template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>*>
bool DiscoveredEndpointInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->service_id, other_struct.service_id))
    return false;
  if (!mojo::Equals(this->endpoint_name, other_struct.endpoint_name))
    return false;
  if (!mojo::Equals(this->endpoint_info, other_struct.endpoint_info))
    return false;
  return true;
}

template <typename T, DiscoveredEndpointInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.service_id < rhs.service_id)
    return true;
  if (rhs.service_id < lhs.service_id)
    return false;
  if (lhs.endpoint_name < rhs.endpoint_name)
    return true;
  if (rhs.endpoint_name < lhs.endpoint_name)
    return false;
  if (lhs.endpoint_info < rhs.endpoint_info)
    return true;
  if (rhs.endpoint_info < lhs.endpoint_info)
    return false;
  return false;
}
template <typename StructPtrType>
AdvertisingOptionsPtr AdvertisingOptions::Clone() const {
  return New(
      mojo::Clone(strategy),
      mojo::Clone(auto_upgrade_bandwidth),
      mojo::Clone(enforce_topology_constraints)
  );
}

template <typename T, AdvertisingOptions::EnableIfSame<T>*>
bool AdvertisingOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->strategy, other_struct.strategy))
    return false;
  if (!mojo::Equals(this->auto_upgrade_bandwidth, other_struct.auto_upgrade_bandwidth))
    return false;
  if (!mojo::Equals(this->enforce_topology_constraints, other_struct.enforce_topology_constraints))
    return false;
  return true;
}

template <typename T, AdvertisingOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.strategy < rhs.strategy)
    return true;
  if (rhs.strategy < lhs.strategy)
    return false;
  if (lhs.auto_upgrade_bandwidth < rhs.auto_upgrade_bandwidth)
    return true;
  if (rhs.auto_upgrade_bandwidth < lhs.auto_upgrade_bandwidth)
    return false;
  if (lhs.enforce_topology_constraints < rhs.enforce_topology_constraints)
    return true;
  if (rhs.enforce_topology_constraints < lhs.enforce_topology_constraints)
    return false;
  return false;
}
template <typename StructPtrType>
DiscoveryOptionsPtr DiscoveryOptions::Clone() const {
  return New(
      mojo::Clone(strategy)
  );
}

template <typename T, DiscoveryOptions::EnableIfSame<T>*>
bool DiscoveryOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->strategy, other_struct.strategy))
    return false;
  return true;
}

template <typename T, DiscoveryOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.strategy < rhs.strategy)
    return true;
  if (rhs.strategy < lhs.strategy)
    return false;
  return false;
}
template <typename StructPtrType>
BytesPayloadPtr BytesPayload::Clone() const {
  return New(
      mojo::Clone(bytes)
  );
}

template <typename T, BytesPayload::EnableIfSame<T>*>
bool BytesPayload::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->bytes, other_struct.bytes))
    return false;
  return true;
}

template <typename T, BytesPayload::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.bytes < rhs.bytes)
    return true;
  if (rhs.bytes < lhs.bytes)
    return false;
  return false;
}
template <typename StructPtrType>
FilePayloadPtr FilePayload::Clone() const {
  return New(
      mojo::Clone(file)
  );
}

template <typename T, FilePayload::EnableIfSame<T>*>
bool FilePayload::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->file, other_struct.file))
    return false;
  return true;
}

template <typename T, FilePayload::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.file < rhs.file)
    return true;
  if (rhs.file < lhs.file)
    return false;
  return false;
}
template <typename StructPtrType>
PayloadPtr Payload::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(content)
  );
}

template <typename T, Payload::EnableIfSame<T>*>
bool Payload::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->content, other_struct.content))
    return false;
  return true;
}

template <typename T, Payload::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.content < rhs.content)
    return true;
  if (rhs.content < lhs.content)
    return false;
  return false;
}
template <typename StructPtrType>
PayloadTransferUpdatePtr PayloadTransferUpdate::Clone() const {
  return New(
      mojo::Clone(payload_id),
      mojo::Clone(status),
      mojo::Clone(total_bytes),
      mojo::Clone(bytes_transferred)
  );
}

template <typename T, PayloadTransferUpdate::EnableIfSame<T>*>
bool PayloadTransferUpdate::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->payload_id, other_struct.payload_id))
    return false;
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  if (!mojo::Equals(this->total_bytes, other_struct.total_bytes))
    return false;
  if (!mojo::Equals(this->bytes_transferred, other_struct.bytes_transferred))
    return false;
  return true;
}

template <typename T, PayloadTransferUpdate::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.payload_id < rhs.payload_id)
    return true;
  if (rhs.payload_id < lhs.payload_id)
    return false;
  if (lhs.status < rhs.status)
    return true;
  if (rhs.status < lhs.status)
    return false;
  if (lhs.total_bytes < rhs.total_bytes)
    return true;
  if (rhs.total_bytes < lhs.total_bytes)
    return false;
  if (lhs.bytes_transferred < rhs.bytes_transferred)
    return true;
  if (rhs.bytes_transferred < lhs.bytes_transferred)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace connections
}  // namespace nearby
}  // namespace location

namespace mojo {


template <>
struct  StructTraits<::location::nearby::connections::mojom::ConnectionInfo::DataView,
                                         ::location::nearby::connections::mojom::ConnectionInfoPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::ConnectionInfoPtr* output) { output->reset(); }

  static const decltype(::location::nearby::connections::mojom::ConnectionInfo::remote_endpoint_name)& remote_endpoint_name(
      const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) {
    return input->remote_endpoint_name;
  }

  static const decltype(::location::nearby::connections::mojom::ConnectionInfo::authentication_token)& authentication_token(
      const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) {
    return input->authentication_token;
  }

  static const decltype(::location::nearby::connections::mojom::ConnectionInfo::raw_authentication_token)& raw_authentication_token(
      const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) {
    return input->raw_authentication_token;
  }

  static decltype(::location::nearby::connections::mojom::ConnectionInfo::is_incoming_connection) is_incoming_connection(
      const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) {
    return input->is_incoming_connection;
  }

  static const decltype(::location::nearby::connections::mojom::ConnectionInfo::endpoint_info)& endpoint_info(
      const ::location::nearby::connections::mojom::ConnectionInfoPtr& input) {
    return input->endpoint_info;
  }

  static bool Read(::location::nearby::connections::mojom::ConnectionInfo::DataView input, ::location::nearby::connections::mojom::ConnectionInfoPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::DiscoveredEndpointInfo::DataView,
                                         ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr* output) { output->reset(); }

  static const decltype(::location::nearby::connections::mojom::DiscoveredEndpointInfo::service_id)& service_id(
      const ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr& input) {
    return input->service_id;
  }

  static const decltype(::location::nearby::connections::mojom::DiscoveredEndpointInfo::endpoint_name)& endpoint_name(
      const ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr& input) {
    return input->endpoint_name;
  }

  static const decltype(::location::nearby::connections::mojom::DiscoveredEndpointInfo::endpoint_info)& endpoint_info(
      const ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr& input) {
    return input->endpoint_info;
  }

  static bool Read(::location::nearby::connections::mojom::DiscoveredEndpointInfo::DataView input, ::location::nearby::connections::mojom::DiscoveredEndpointInfoPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::AdvertisingOptions::DataView,
                                         ::location::nearby::connections::mojom::AdvertisingOptionsPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::AdvertisingOptionsPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::AdvertisingOptionsPtr* output) { output->reset(); }

  static decltype(::location::nearby::connections::mojom::AdvertisingOptions::strategy) strategy(
      const ::location::nearby::connections::mojom::AdvertisingOptionsPtr& input) {
    return input->strategy;
  }

  static decltype(::location::nearby::connections::mojom::AdvertisingOptions::auto_upgrade_bandwidth) auto_upgrade_bandwidth(
      const ::location::nearby::connections::mojom::AdvertisingOptionsPtr& input) {
    return input->auto_upgrade_bandwidth;
  }

  static decltype(::location::nearby::connections::mojom::AdvertisingOptions::enforce_topology_constraints) enforce_topology_constraints(
      const ::location::nearby::connections::mojom::AdvertisingOptionsPtr& input) {
    return input->enforce_topology_constraints;
  }

  static bool Read(::location::nearby::connections::mojom::AdvertisingOptions::DataView input, ::location::nearby::connections::mojom::AdvertisingOptionsPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::DiscoveryOptions::DataView,
                                         ::location::nearby::connections::mojom::DiscoveryOptionsPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::DiscoveryOptionsPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::DiscoveryOptionsPtr* output) { output->reset(); }

  static decltype(::location::nearby::connections::mojom::DiscoveryOptions::strategy) strategy(
      const ::location::nearby::connections::mojom::DiscoveryOptionsPtr& input) {
    return input->strategy;
  }

  static bool Read(::location::nearby::connections::mojom::DiscoveryOptions::DataView input, ::location::nearby::connections::mojom::DiscoveryOptionsPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::BytesPayload::DataView,
                                         ::location::nearby::connections::mojom::BytesPayloadPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::BytesPayloadPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::BytesPayloadPtr* output) { output->reset(); }

  static const decltype(::location::nearby::connections::mojom::BytesPayload::bytes)& bytes(
      const ::location::nearby::connections::mojom::BytesPayloadPtr& input) {
    return input->bytes;
  }

  static bool Read(::location::nearby::connections::mojom::BytesPayload::DataView input, ::location::nearby::connections::mojom::BytesPayloadPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::FilePayload::DataView,
                                         ::location::nearby::connections::mojom::FilePayloadPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::FilePayloadPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::FilePayloadPtr* output) { output->reset(); }

  static  decltype(::location::nearby::connections::mojom::FilePayload::file)& file(
       ::location::nearby::connections::mojom::FilePayloadPtr& input) {
    return input->file;
  }

  static bool Read(::location::nearby::connections::mojom::FilePayload::DataView input, ::location::nearby::connections::mojom::FilePayloadPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::Payload::DataView,
                                         ::location::nearby::connections::mojom::PayloadPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::PayloadPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::PayloadPtr* output) { output->reset(); }

  static decltype(::location::nearby::connections::mojom::Payload::id) id(
      const ::location::nearby::connections::mojom::PayloadPtr& input) {
    return input->id;
  }

  static  decltype(::location::nearby::connections::mojom::Payload::content)& content(
       ::location::nearby::connections::mojom::PayloadPtr& input) {
    return input->content;
  }

  static bool Read(::location::nearby::connections::mojom::Payload::DataView input, ::location::nearby::connections::mojom::PayloadPtr* output);
};


template <>
struct  StructTraits<::location::nearby::connections::mojom::PayloadTransferUpdate::DataView,
                                         ::location::nearby::connections::mojom::PayloadTransferUpdatePtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::PayloadTransferUpdatePtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::PayloadTransferUpdatePtr* output) { output->reset(); }

  static decltype(::location::nearby::connections::mojom::PayloadTransferUpdate::payload_id) payload_id(
      const ::location::nearby::connections::mojom::PayloadTransferUpdatePtr& input) {
    return input->payload_id;
  }

  static decltype(::location::nearby::connections::mojom::PayloadTransferUpdate::status) status(
      const ::location::nearby::connections::mojom::PayloadTransferUpdatePtr& input) {
    return input->status;
  }

  static decltype(::location::nearby::connections::mojom::PayloadTransferUpdate::total_bytes) total_bytes(
      const ::location::nearby::connections::mojom::PayloadTransferUpdatePtr& input) {
    return input->total_bytes;
  }

  static decltype(::location::nearby::connections::mojom::PayloadTransferUpdate::bytes_transferred) bytes_transferred(
      const ::location::nearby::connections::mojom::PayloadTransferUpdatePtr& input) {
    return input->bytes_transferred;
  }

  static bool Read(::location::nearby::connections::mojom::PayloadTransferUpdate::DataView input, ::location::nearby::connections::mojom::PayloadTransferUpdatePtr* output);
};


template <>
struct  UnionTraits<::location::nearby::connections::mojom::PayloadContent::DataView,
                                        ::location::nearby::connections::mojom::PayloadContentPtr> {
  static bool IsNull(const ::location::nearby::connections::mojom::PayloadContentPtr& input) { return !input; }
  static void SetToNull(::location::nearby::connections::mojom::PayloadContentPtr* output) { output->reset(); }

  static ::location::nearby::connections::mojom::PayloadContent::Tag GetTag(const ::location::nearby::connections::mojom::PayloadContentPtr& input) {
    return input->which();
  }

  static const ::location::nearby::connections::mojom::BytesPayloadPtr& bytes(const ::location::nearby::connections::mojom::PayloadContentPtr& input) {
    return input->get_bytes();
  }

  static  ::location::nearby::connections::mojom::FilePayloadPtr& file( ::location::nearby::connections::mojom::PayloadContentPtr& input) {
    return input->get_file();
  }

  static bool Read(::location::nearby::connections::mojom::PayloadContent::DataView input, ::location::nearby::connections::mojom::PayloadContentPtr* output);
};

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_CONNECTIONS_TYPES_MOJOM_H_