// chrome/services/sharing/public/mojom/nearby_decoder.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder.mojom-forward.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace sharing {
namespace mojom {

class NearbySharingDecoderProxy;

template <typename ImplRefTraits>
class NearbySharingDecoderStub;

class NearbySharingDecoderRequestValidator;
class NearbySharingDecoderResponseValidator;


class  NearbySharingDecoder
    : public NearbySharingDecoderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = NearbySharingDecoderInterfaceBase;
  using Proxy_ = NearbySharingDecoderProxy;

  template <typename ImplRefTraits>
  using Stub_ = NearbySharingDecoderStub<ImplRefTraits>;

  using RequestValidator_ = NearbySharingDecoderRequestValidator;
  using ResponseValidator_ = NearbySharingDecoderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kDecodeAdvertisementMinVersion = 0,
    kDecodeFrameMinVersion = 0,
  };
  virtual ~NearbySharingDecoder() {}


  using DecodeAdvertisementCallback = base::OnceCallback<void(::sharing::mojom::AdvertisementPtr)>;
  
  virtual void DecodeAdvertisement(const std::vector<uint8_t>& data, DecodeAdvertisementCallback callback) = 0;


  using DecodeFrameCallback = base::OnceCallback<void(::sharing::mojom::FramePtr)>;
  
  virtual void DecodeFrame(const std::vector<uint8_t>& data, DecodeFrameCallback callback) = 0;
};



class  NearbySharingDecoderProxy
    : public NearbySharingDecoder {
 public:
  using InterfaceType = NearbySharingDecoder;

  explicit NearbySharingDecoderProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void DecodeAdvertisement(const std::vector<uint8_t>& data, DecodeAdvertisementCallback callback) final;
  
  void DecodeFrame(const std::vector<uint8_t>& data, DecodeFrameCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  NearbySharingDecoderStubDispatch {
 public:
  static bool Accept(NearbySharingDecoder* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      NearbySharingDecoder* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<NearbySharingDecoder>>
class NearbySharingDecoderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  NearbySharingDecoderStub() {}
  ~NearbySharingDecoderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbySharingDecoderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return NearbySharingDecoderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  NearbySharingDecoderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  NearbySharingDecoderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace sharing

namespace mojo {

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_MOJOM_H_