// chrome/services/sharing/public/mojom/nearby_decoder_types.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-params-data.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-shared-message-ids.h"

#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-import-headers.h"


#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_TYPES_MOJOM_JUMBO_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_TYPES_MOJOM_JUMBO_H_
#endif
namespace sharing {
namespace mojom {
Advertisement::Advertisement()
    : salt(),
      encrypted_metadata(),
      device_name() {}

Advertisement::Advertisement(
    std::vector<uint8_t> salt_in,
    std::vector<uint8_t> encrypted_metadata_in,
    const base::Optional<std::string>& device_name_in)
    : salt(std::move(salt_in)),
      encrypted_metadata(std::move(encrypted_metadata_in)),
      device_name(std::move(device_name_in)) {}

Advertisement::~Advertisement() = default;

bool Advertisement::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
IntroductionFrame::IntroductionFrame()
    : file_metadata(),
      text_metadata(),
      required_package(),
      wifi_credentials_metadata() {}

IntroductionFrame::IntroductionFrame(
    std::vector<FileMetadataPtr> file_metadata_in,
    std::vector<TextMetadataPtr> text_metadata_in,
    const base::Optional<std::string>& required_package_in,
    std::vector<WifiCredentialsMetadataPtr> wifi_credentials_metadata_in)
    : file_metadata(std::move(file_metadata_in)),
      text_metadata(std::move(text_metadata_in)),
      required_package(std::move(required_package_in)),
      wifi_credentials_metadata(std::move(wifi_credentials_metadata_in)) {}

IntroductionFrame::~IntroductionFrame() = default;

bool IntroductionFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
FileMetadata::FileMetadata()
    : name(),
      type(FileMetadata_Type::kUnknown),
      payload_id(),
      size(),
      mime_type("application/octet-stream") {}

FileMetadata::FileMetadata(
    const std::string& name_in,
    FileMetadata::Type type_in,
    int64_t payload_id_in,
    uint64_t size_in,
    const std::string& mime_type_in)
    : name(std::move(name_in)),
      type(std::move(type_in)),
      payload_id(std::move(payload_id_in)),
      size(std::move(size_in)),
      mime_type(std::move(mime_type_in)) {}

FileMetadata::~FileMetadata() = default;
size_t FileMetadata::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->name);
  seed = mojo::internal::Hash(seed, this->type);
  seed = mojo::internal::Hash(seed, this->payload_id);
  seed = mojo::internal::Hash(seed, this->size);
  seed = mojo::internal::Hash(seed, this->mime_type);
  return seed;
}

bool FileMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TextMetadata::TextMetadata()
    : text_title(),
      type(TextMetadata_Type::kUnknown),
      payload_id(),
      size() {}

TextMetadata::TextMetadata(
    const std::string& text_title_in,
    TextMetadata::Type type_in,
    int64_t payload_id_in,
    uint64_t size_in)
    : text_title(std::move(text_title_in)),
      type(std::move(type_in)),
      payload_id(std::move(payload_id_in)),
      size(std::move(size_in)) {}

TextMetadata::~TextMetadata() = default;
size_t TextMetadata::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->text_title);
  seed = mojo::internal::Hash(seed, this->type);
  seed = mojo::internal::Hash(seed, this->payload_id);
  seed = mojo::internal::Hash(seed, this->size);
  return seed;
}

bool TextMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
WifiCredentialsMetadata::WifiCredentialsMetadata()
    : ssid(),
      security_type(WifiCredentialsMetadata_SecurityType::kUnknownSecurityType),
      payload_id() {}

WifiCredentialsMetadata::WifiCredentialsMetadata(
    const std::string& ssid_in,
    WifiCredentialsMetadata::SecurityType security_type_in,
    int64_t payload_id_in)
    : ssid(std::move(ssid_in)),
      security_type(std::move(security_type_in)),
      payload_id(std::move(payload_id_in)) {}

WifiCredentialsMetadata::~WifiCredentialsMetadata() = default;
size_t WifiCredentialsMetadata::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->ssid);
  seed = mojo::internal::Hash(seed, this->security_type);
  seed = mojo::internal::Hash(seed, this->payload_id);
  return seed;
}

bool WifiCredentialsMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ConnectionResponseFrame::ConnectionResponseFrame()
    : status() {}

ConnectionResponseFrame::ConnectionResponseFrame(
    ConnectionResponseFrame::Status status_in)
    : status(std::move(status_in)) {}

ConnectionResponseFrame::~ConnectionResponseFrame() = default;
size_t ConnectionResponseFrame::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->status);
  return seed;
}

bool ConnectionResponseFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PairedKeyEncryptionFrame::PairedKeyEncryptionFrame()
    : signed_data(),
      secret_id_hash() {}

PairedKeyEncryptionFrame::PairedKeyEncryptionFrame(
    std::vector<uint8_t> signed_data_in,
    std::vector<uint8_t> secret_id_hash_in)
    : signed_data(std::move(signed_data_in)),
      secret_id_hash(std::move(secret_id_hash_in)) {}

PairedKeyEncryptionFrame::~PairedKeyEncryptionFrame() = default;

bool PairedKeyEncryptionFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PairedKeyResultFrame::PairedKeyResultFrame()
    : status() {}

PairedKeyResultFrame::PairedKeyResultFrame(
    PairedKeyResultFrame::Status status_in)
    : status(std::move(status_in)) {}

PairedKeyResultFrame::~PairedKeyResultFrame() = default;
size_t PairedKeyResultFrame::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->status);
  return seed;
}

bool PairedKeyResultFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
CertificateInfoFrame::CertificateInfoFrame()
    : public_certificate() {}

CertificateInfoFrame::CertificateInfoFrame(
    std::vector<PublicCertificatePtr> public_certificate_in)
    : public_certificate(std::move(public_certificate_in)) {}

CertificateInfoFrame::~CertificateInfoFrame() = default;

bool CertificateInfoFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PublicCertificate::PublicCertificate()
    : secret_id(),
      authenticity_key(),
      public_key(),
      start_time(),
      end_time(),
      encrypted_metadata_bytes(),
      metadata_encryption_key_tag() {}

PublicCertificate::PublicCertificate(
    std::vector<uint8_t> secret_id_in,
    std::vector<uint8_t> authenticity_key_in,
    std::vector<uint8_t> public_key_in,
    ::base::Time start_time_in,
    ::base::Time end_time_in,
    std::vector<uint8_t> encrypted_metadata_bytes_in,
    std::vector<uint8_t> metadata_encryption_key_tag_in)
    : secret_id(std::move(secret_id_in)),
      authenticity_key(std::move(authenticity_key_in)),
      public_key(std::move(public_key_in)),
      start_time(std::move(start_time_in)),
      end_time(std::move(end_time_in)),
      encrypted_metadata_bytes(std::move(encrypted_metadata_bytes_in)),
      metadata_encryption_key_tag(std::move(metadata_encryption_key_tag_in)) {}

PublicCertificate::~PublicCertificate() = default;

bool PublicCertificate::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Frame::Frame() : tag_(Tag::V1) {
  data_.v1 = new V1FramePtr;
}

Frame::~Frame() {
  DestroyActive();
}


void Frame::set_v1(
    V1FramePtr v1) {
  if (tag_ == Tag::V1) {
    *(data_.v1) = std::move(v1);
  } else {
    DestroyActive();
    tag_ = Tag::V1;
    data_.v1 = new V1FramePtr(
        std::move(v1));
  }
}

void Frame::DestroyActive() {
  switch (tag_) {

    case Tag::V1:

      delete data_.v1;
      break;
  }
}

bool Frame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
V1Frame::V1Frame() : tag_(Tag::INTRODUCTION) {
  data_.introduction = new IntroductionFramePtr;
}

V1Frame::~V1Frame() {
  DestroyActive();
}


void V1Frame::set_introduction(
    IntroductionFramePtr introduction) {
  if (tag_ == Tag::INTRODUCTION) {
    *(data_.introduction) = std::move(introduction);
  } else {
    DestroyActive();
    tag_ = Tag::INTRODUCTION;
    data_.introduction = new IntroductionFramePtr(
        std::move(introduction));
  }
}
void V1Frame::set_connection_response(
    ConnectionResponseFramePtr connection_response) {
  if (tag_ == Tag::CONNECTION_RESPONSE) {
    *(data_.connection_response) = std::move(connection_response);
  } else {
    DestroyActive();
    tag_ = Tag::CONNECTION_RESPONSE;
    data_.connection_response = new ConnectionResponseFramePtr(
        std::move(connection_response));
  }
}
void V1Frame::set_paired_key_encryption(
    PairedKeyEncryptionFramePtr paired_key_encryption) {
  if (tag_ == Tag::PAIRED_KEY_ENCRYPTION) {
    *(data_.paired_key_encryption) = std::move(paired_key_encryption);
  } else {
    DestroyActive();
    tag_ = Tag::PAIRED_KEY_ENCRYPTION;
    data_.paired_key_encryption = new PairedKeyEncryptionFramePtr(
        std::move(paired_key_encryption));
  }
}
void V1Frame::set_paired_key_result(
    PairedKeyResultFramePtr paired_key_result) {
  if (tag_ == Tag::PAIRED_KEY_RESULT) {
    *(data_.paired_key_result) = std::move(paired_key_result);
  } else {
    DestroyActive();
    tag_ = Tag::PAIRED_KEY_RESULT;
    data_.paired_key_result = new PairedKeyResultFramePtr(
        std::move(paired_key_result));
  }
}
void V1Frame::set_certificate_info(
    CertificateInfoFramePtr certificate_info) {
  if (tag_ == Tag::CERTIFICATE_INFO) {
    *(data_.certificate_info) = std::move(certificate_info);
  } else {
    DestroyActive();
    tag_ = Tag::CERTIFICATE_INFO;
    data_.certificate_info = new CertificateInfoFramePtr(
        std::move(certificate_info));
  }
}

void V1Frame::DestroyActive() {
  switch (tag_) {

    case Tag::INTRODUCTION:

      delete data_.introduction;
      break;
    case Tag::CONNECTION_RESPONSE:

      delete data_.connection_response;
      break;
    case Tag::PAIRED_KEY_ENCRYPTION:

      delete data_.paired_key_encryption;
      break;
    case Tag::PAIRED_KEY_RESULT:

      delete data_.paired_key_result;
      break;
    case Tag::CERTIFICATE_INFO:

      delete data_.certificate_info;
      break;
  }
}

bool V1Frame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
}  // namespace mojom
}  // namespace sharing

namespace mojo {


// static
bool StructTraits<::sharing::mojom::Advertisement::DataView, ::sharing::mojom::AdvertisementPtr>::Read(
    ::sharing::mojom::Advertisement::DataView input,
    ::sharing::mojom::AdvertisementPtr* output) {
  bool success = true;
  ::sharing::mojom::AdvertisementPtr result(::sharing::mojom::Advertisement::New());
  
      if (success && !input.ReadSalt(&result->salt))
        success = false;
      if (success && !input.ReadEncryptedMetadata(&result->encrypted_metadata))
        success = false;
      if (success && !input.ReadDeviceName(&result->device_name))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::IntroductionFrame::DataView, ::sharing::mojom::IntroductionFramePtr>::Read(
    ::sharing::mojom::IntroductionFrame::DataView input,
    ::sharing::mojom::IntroductionFramePtr* output) {
  bool success = true;
  ::sharing::mojom::IntroductionFramePtr result(::sharing::mojom::IntroductionFrame::New());
  
      if (success && !input.ReadFileMetadata(&result->file_metadata))
        success = false;
      if (success && !input.ReadTextMetadata(&result->text_metadata))
        success = false;
      if (success && !input.ReadRequiredPackage(&result->required_package))
        success = false;
      if (success && !input.ReadWifiCredentialsMetadata(&result->wifi_credentials_metadata))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::FileMetadata::DataView, ::sharing::mojom::FileMetadataPtr>::Read(
    ::sharing::mojom::FileMetadata::DataView input,
    ::sharing::mojom::FileMetadataPtr* output) {
  bool success = true;
  ::sharing::mojom::FileMetadataPtr result(::sharing::mojom::FileMetadata::New());
  
      if (success && !input.ReadName(&result->name))
        success = false;
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success)
        result->payload_id = input.payload_id();
      if (success)
        result->size = input.size();
      if (success && !input.ReadMimeType(&result->mime_type))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::TextMetadata::DataView, ::sharing::mojom::TextMetadataPtr>::Read(
    ::sharing::mojom::TextMetadata::DataView input,
    ::sharing::mojom::TextMetadataPtr* output) {
  bool success = true;
  ::sharing::mojom::TextMetadataPtr result(::sharing::mojom::TextMetadata::New());
  
      if (success && !input.ReadTextTitle(&result->text_title))
        success = false;
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success)
        result->payload_id = input.payload_id();
      if (success)
        result->size = input.size();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::WifiCredentialsMetadata::DataView, ::sharing::mojom::WifiCredentialsMetadataPtr>::Read(
    ::sharing::mojom::WifiCredentialsMetadata::DataView input,
    ::sharing::mojom::WifiCredentialsMetadataPtr* output) {
  bool success = true;
  ::sharing::mojom::WifiCredentialsMetadataPtr result(::sharing::mojom::WifiCredentialsMetadata::New());
  
      if (success && !input.ReadSsid(&result->ssid))
        success = false;
      if (success && !input.ReadSecurityType(&result->security_type))
        success = false;
      if (success)
        result->payload_id = input.payload_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::ConnectionResponseFrame::DataView, ::sharing::mojom::ConnectionResponseFramePtr>::Read(
    ::sharing::mojom::ConnectionResponseFrame::DataView input,
    ::sharing::mojom::ConnectionResponseFramePtr* output) {
  bool success = true;
  ::sharing::mojom::ConnectionResponseFramePtr result(::sharing::mojom::ConnectionResponseFrame::New());
  
      if (success && !input.ReadStatus(&result->status))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::PairedKeyEncryptionFrame::DataView, ::sharing::mojom::PairedKeyEncryptionFramePtr>::Read(
    ::sharing::mojom::PairedKeyEncryptionFrame::DataView input,
    ::sharing::mojom::PairedKeyEncryptionFramePtr* output) {
  bool success = true;
  ::sharing::mojom::PairedKeyEncryptionFramePtr result(::sharing::mojom::PairedKeyEncryptionFrame::New());
  
      if (success && !input.ReadSignedData(&result->signed_data))
        success = false;
      if (success && !input.ReadSecretIdHash(&result->secret_id_hash))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::PairedKeyResultFrame::DataView, ::sharing::mojom::PairedKeyResultFramePtr>::Read(
    ::sharing::mojom::PairedKeyResultFrame::DataView input,
    ::sharing::mojom::PairedKeyResultFramePtr* output) {
  bool success = true;
  ::sharing::mojom::PairedKeyResultFramePtr result(::sharing::mojom::PairedKeyResultFrame::New());
  
      if (success && !input.ReadStatus(&result->status))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::CertificateInfoFrame::DataView, ::sharing::mojom::CertificateInfoFramePtr>::Read(
    ::sharing::mojom::CertificateInfoFrame::DataView input,
    ::sharing::mojom::CertificateInfoFramePtr* output) {
  bool success = true;
  ::sharing::mojom::CertificateInfoFramePtr result(::sharing::mojom::CertificateInfoFrame::New());
  
      if (success && !input.ReadPublicCertificate(&result->public_certificate))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::PublicCertificate::DataView, ::sharing::mojom::PublicCertificatePtr>::Read(
    ::sharing::mojom::PublicCertificate::DataView input,
    ::sharing::mojom::PublicCertificatePtr* output) {
  bool success = true;
  ::sharing::mojom::PublicCertificatePtr result(::sharing::mojom::PublicCertificate::New());
  
      if (success && !input.ReadSecretId(&result->secret_id))
        success = false;
      if (success && !input.ReadAuthenticityKey(&result->authenticity_key))
        success = false;
      if (success && !input.ReadPublicKey(&result->public_key))
        success = false;
      if (success && !input.ReadStartTime(&result->start_time))
        success = false;
      if (success && !input.ReadEndTime(&result->end_time))
        success = false;
      if (success && !input.ReadEncryptedMetadataBytes(&result->encrypted_metadata_bytes))
        success = false;
      if (success && !input.ReadMetadataEncryptionKeyTag(&result->metadata_encryption_key_tag))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::sharing::mojom::Frame::DataView, ::sharing::mojom::FramePtr>::Read(
    ::sharing::mojom::Frame::DataView input,
    ::sharing::mojom::FramePtr* output) {
  using UnionType = ::sharing::mojom::Frame;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::V1: {
      ::sharing::mojom::V1FramePtr result_v1;
      if (!input.ReadV1(&result_v1))
        return false;

      *output = UnionType::NewV1(
          std::move(result_v1));
      break;
    }
    default:
      return false;
  }
  return true;
}

// static
bool UnionTraits<::sharing::mojom::V1Frame::DataView, ::sharing::mojom::V1FramePtr>::Read(
    ::sharing::mojom::V1Frame::DataView input,
    ::sharing::mojom::V1FramePtr* output) {
  using UnionType = ::sharing::mojom::V1Frame;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::INTRODUCTION: {
      ::sharing::mojom::IntroductionFramePtr result_introduction;
      if (!input.ReadIntroduction(&result_introduction))
        return false;

      *output = UnionType::NewIntroduction(
          std::move(result_introduction));
      break;
    }
    case Tag::CONNECTION_RESPONSE: {
      ::sharing::mojom::ConnectionResponseFramePtr result_connection_response;
      if (!input.ReadConnectionResponse(&result_connection_response))
        return false;

      *output = UnionType::NewConnectionResponse(
          std::move(result_connection_response));
      break;
    }
    case Tag::PAIRED_KEY_ENCRYPTION: {
      ::sharing::mojom::PairedKeyEncryptionFramePtr result_paired_key_encryption;
      if (!input.ReadPairedKeyEncryption(&result_paired_key_encryption))
        return false;

      *output = UnionType::NewPairedKeyEncryption(
          std::move(result_paired_key_encryption));
      break;
    }
    case Tag::PAIRED_KEY_RESULT: {
      ::sharing::mojom::PairedKeyResultFramePtr result_paired_key_result;
      if (!input.ReadPairedKeyResult(&result_paired_key_result))
        return false;

      *output = UnionType::NewPairedKeyResult(
          std::move(result_paired_key_result));
      break;
    }
    case Tag::CERTIFICATE_INFO: {
      ::sharing::mojom::CertificateInfoFramePtr result_certificate_info;
      if (!input.ReadCertificateInfo(&result_certificate_info))
        return false;

      *output = UnionType::NewCertificateInfo(
          std::move(result_certificate_info));
      break;
    }
    default:
      return false;
  }
  return true;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif