// chrome/services/sharing/public/mojom/nearby_decoder_types.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_TYPES_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_TYPES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/nearby_decoder_types.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include <string>
#include <vector>








namespace sharing {
namespace mojom {








class  TextMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TextMetadata, T>::value>;
  using DataView = TextMetadataDataView;
  using Data_ = internal::TextMetadata_Data;
  using Type = TextMetadata_Type;

  template <typename... Args>
  static TextMetadataPtr New(Args&&... args) {
    return TextMetadataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TextMetadataPtr From(const U& u) {
    return mojo::TypeConverter<TextMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TextMetadata>::Convert(*this);
  }


  TextMetadata();

  TextMetadata(
      const std::string& text_title,
      TextMetadata::Type type,
      int64_t payload_id,
      uint64_t size);

  ~TextMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TextMetadataPtr>
  TextMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TextMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TextMetadata::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TextMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TextMetadata_UnserializedMessageContext<
            UserType, TextMetadata::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<TextMetadata::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return TextMetadata::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TextMetadata_UnserializedMessageContext<
            UserType, TextMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TextMetadata::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string text_title;
  
  TextMetadata::Type type;
  
  int64_t payload_id;
  
  uint64_t size;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TextMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TextMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TextMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TextMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  WifiCredentialsMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<WifiCredentialsMetadata, T>::value>;
  using DataView = WifiCredentialsMetadataDataView;
  using Data_ = internal::WifiCredentialsMetadata_Data;
  using SecurityType = WifiCredentialsMetadata_SecurityType;

  template <typename... Args>
  static WifiCredentialsMetadataPtr New(Args&&... args) {
    return WifiCredentialsMetadataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static WifiCredentialsMetadataPtr From(const U& u) {
    return mojo::TypeConverter<WifiCredentialsMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, WifiCredentialsMetadata>::Convert(*this);
  }


  WifiCredentialsMetadata();

  WifiCredentialsMetadata(
      const std::string& ssid,
      WifiCredentialsMetadata::SecurityType security_type,
      int64_t payload_id);

  ~WifiCredentialsMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = WifiCredentialsMetadataPtr>
  WifiCredentialsMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, WifiCredentialsMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        WifiCredentialsMetadata::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        WifiCredentialsMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::WifiCredentialsMetadata_UnserializedMessageContext<
            UserType, WifiCredentialsMetadata::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<WifiCredentialsMetadata::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return WifiCredentialsMetadata::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::WifiCredentialsMetadata_UnserializedMessageContext<
            UserType, WifiCredentialsMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<WifiCredentialsMetadata::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string ssid;
  
  WifiCredentialsMetadata::SecurityType security_type;
  
  int64_t payload_id;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, WifiCredentialsMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, WifiCredentialsMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, WifiCredentialsMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, WifiCredentialsMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ConnectionResponseFrame {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConnectionResponseFrame, T>::value>;
  using DataView = ConnectionResponseFrameDataView;
  using Data_ = internal::ConnectionResponseFrame_Data;
  using Status = ConnectionResponseFrame_Status;

  template <typename... Args>
  static ConnectionResponseFramePtr New(Args&&... args) {
    return ConnectionResponseFramePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConnectionResponseFramePtr From(const U& u) {
    return mojo::TypeConverter<ConnectionResponseFramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConnectionResponseFrame>::Convert(*this);
  }


  ConnectionResponseFrame();

  explicit ConnectionResponseFrame(
      ConnectionResponseFrame::Status status);

  ~ConnectionResponseFrame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConnectionResponseFramePtr>
  ConnectionResponseFramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConnectionResponseFrame::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConnectionResponseFrame::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConnectionResponseFrame::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConnectionResponseFrame_UnserializedMessageContext<
            UserType, ConnectionResponseFrame::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ConnectionResponseFrame::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ConnectionResponseFrame::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConnectionResponseFrame_UnserializedMessageContext<
            UserType, ConnectionResponseFrame::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConnectionResponseFrame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ConnectionResponseFrame::Status status;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConnectionResponseFrame::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConnectionResponseFrame::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConnectionResponseFrame::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConnectionResponseFrame::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  PairedKeyResultFrame {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PairedKeyResultFrame, T>::value>;
  using DataView = PairedKeyResultFrameDataView;
  using Data_ = internal::PairedKeyResultFrame_Data;
  using Status = PairedKeyResultFrame_Status;

  template <typename... Args>
  static PairedKeyResultFramePtr New(Args&&... args) {
    return PairedKeyResultFramePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PairedKeyResultFramePtr From(const U& u) {
    return mojo::TypeConverter<PairedKeyResultFramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PairedKeyResultFrame>::Convert(*this);
  }


  PairedKeyResultFrame();

  explicit PairedKeyResultFrame(
      PairedKeyResultFrame::Status status);

  ~PairedKeyResultFrame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PairedKeyResultFramePtr>
  PairedKeyResultFramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PairedKeyResultFrame::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PairedKeyResultFrame::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PairedKeyResultFrame::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PairedKeyResultFrame_UnserializedMessageContext<
            UserType, PairedKeyResultFrame::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PairedKeyResultFrame::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PairedKeyResultFrame::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PairedKeyResultFrame_UnserializedMessageContext<
            UserType, PairedKeyResultFrame::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PairedKeyResultFrame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  PairedKeyResultFrame::Status status;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PairedKeyResultFrame::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PairedKeyResultFrame::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PairedKeyResultFrame::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PairedKeyResultFrame::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  Frame {
 public:
  using DataView = FrameDataView;
  using Data_ = internal::Frame_Data;
  using Tag = Data_::Frame_Tag;

  static FramePtr New() {
    return FramePtr(base::in_place);
  }
  // Construct an instance holding |v1|.
  static FramePtr
  NewV1(
      V1FramePtr v1) {
    auto result = FramePtr(base::in_place);
    result->set_v1(std::move(v1));
    return result;
  }

  template <typename U>
  static FramePtr From(const U& u) {
    return mojo::TypeConverter<FramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Frame>::Convert(*this);
  }

  Frame();
  ~Frame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = FramePtr>
  FramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, Frame>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_v1() const { return tag_ == Tag::V1; }

  
  V1FramePtr& get_v1() const {
    DCHECK(tag_ == Tag::V1);
    return *(data_.v1);
  }

  
  void set_v1(
      V1FramePtr v1);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Frame::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<Frame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    V1FramePtr* v1;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};



class  V1Frame {
 public:
  using DataView = V1FrameDataView;
  using Data_ = internal::V1Frame_Data;
  using Tag = Data_::V1Frame_Tag;

  static V1FramePtr New() {
    return V1FramePtr(base::in_place);
  }
  // Construct an instance holding |introduction|.
  static V1FramePtr
  NewIntroduction(
      IntroductionFramePtr introduction) {
    auto result = V1FramePtr(base::in_place);
    result->set_introduction(std::move(introduction));
    return result;
  }
  // Construct an instance holding |connection_response|.
  static V1FramePtr
  NewConnectionResponse(
      ConnectionResponseFramePtr connection_response) {
    auto result = V1FramePtr(base::in_place);
    result->set_connection_response(std::move(connection_response));
    return result;
  }
  // Construct an instance holding |paired_key_encryption|.
  static V1FramePtr
  NewPairedKeyEncryption(
      PairedKeyEncryptionFramePtr paired_key_encryption) {
    auto result = V1FramePtr(base::in_place);
    result->set_paired_key_encryption(std::move(paired_key_encryption));
    return result;
  }
  // Construct an instance holding |paired_key_result|.
  static V1FramePtr
  NewPairedKeyResult(
      PairedKeyResultFramePtr paired_key_result) {
    auto result = V1FramePtr(base::in_place);
    result->set_paired_key_result(std::move(paired_key_result));
    return result;
  }
  // Construct an instance holding |certificate_info|.
  static V1FramePtr
  NewCertificateInfo(
      CertificateInfoFramePtr certificate_info) {
    auto result = V1FramePtr(base::in_place);
    result->set_certificate_info(std::move(certificate_info));
    return result;
  }

  template <typename U>
  static V1FramePtr From(const U& u) {
    return mojo::TypeConverter<V1FramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, V1Frame>::Convert(*this);
  }

  V1Frame();
  ~V1Frame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = V1FramePtr>
  V1FramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, V1Frame>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_introduction() const { return tag_ == Tag::INTRODUCTION; }

  
  IntroductionFramePtr& get_introduction() const {
    DCHECK(tag_ == Tag::INTRODUCTION);
    return *(data_.introduction);
  }

  
  void set_introduction(
      IntroductionFramePtr introduction);
  
  bool is_connection_response() const { return tag_ == Tag::CONNECTION_RESPONSE; }

  
  ConnectionResponseFramePtr& get_connection_response() const {
    DCHECK(tag_ == Tag::CONNECTION_RESPONSE);
    return *(data_.connection_response);
  }

  
  void set_connection_response(
      ConnectionResponseFramePtr connection_response);
  
  bool is_paired_key_encryption() const { return tag_ == Tag::PAIRED_KEY_ENCRYPTION; }

  
  PairedKeyEncryptionFramePtr& get_paired_key_encryption() const {
    DCHECK(tag_ == Tag::PAIRED_KEY_ENCRYPTION);
    return *(data_.paired_key_encryption);
  }

  
  void set_paired_key_encryption(
      PairedKeyEncryptionFramePtr paired_key_encryption);
  
  bool is_paired_key_result() const { return tag_ == Tag::PAIRED_KEY_RESULT; }

  
  PairedKeyResultFramePtr& get_paired_key_result() const {
    DCHECK(tag_ == Tag::PAIRED_KEY_RESULT);
    return *(data_.paired_key_result);
  }

  
  void set_paired_key_result(
      PairedKeyResultFramePtr paired_key_result);
  
  bool is_certificate_info() const { return tag_ == Tag::CERTIFICATE_INFO; }

  
  CertificateInfoFramePtr& get_certificate_info() const {
    DCHECK(tag_ == Tag::CERTIFICATE_INFO);
    return *(data_.certificate_info);
  }

  
  void set_certificate_info(
      CertificateInfoFramePtr certificate_info);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        V1Frame::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<V1Frame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    IntroductionFramePtr* introduction;
    ConnectionResponseFramePtr* connection_response;
    PairedKeyEncryptionFramePtr* paired_key_encryption;
    PairedKeyResultFramePtr* paired_key_result;
    CertificateInfoFramePtr* certificate_info;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};





class  Advertisement {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Advertisement, T>::value>;
  using DataView = AdvertisementDataView;
  using Data_ = internal::Advertisement_Data;

  template <typename... Args>
  static AdvertisementPtr New(Args&&... args) {
    return AdvertisementPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AdvertisementPtr From(const U& u) {
    return mojo::TypeConverter<AdvertisementPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Advertisement>::Convert(*this);
  }


  Advertisement();

  Advertisement(
      std::vector<uint8_t> salt,
      std::vector<uint8_t> encrypted_metadata,
      const base::Optional<std::string>& device_name);

  ~Advertisement();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AdvertisementPtr>
  AdvertisementPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Advertisement::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Advertisement::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Advertisement::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Advertisement_UnserializedMessageContext<
            UserType, Advertisement::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Advertisement::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Advertisement::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Advertisement_UnserializedMessageContext<
            UserType, Advertisement::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Advertisement::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<uint8_t> salt;
  
  std::vector<uint8_t> encrypted_metadata;
  
  base::Optional<std::string> device_name;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Advertisement::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Advertisement::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Advertisement::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Advertisement::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  IntroductionFrame {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IntroductionFrame, T>::value>;
  using DataView = IntroductionFrameDataView;
  using Data_ = internal::IntroductionFrame_Data;

  template <typename... Args>
  static IntroductionFramePtr New(Args&&... args) {
    return IntroductionFramePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IntroductionFramePtr From(const U& u) {
    return mojo::TypeConverter<IntroductionFramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IntroductionFrame>::Convert(*this);
  }


  IntroductionFrame();

  IntroductionFrame(
      std::vector<FileMetadataPtr> file_metadata,
      std::vector<TextMetadataPtr> text_metadata,
      const base::Optional<std::string>& required_package,
      std::vector<WifiCredentialsMetadataPtr> wifi_credentials_metadata);

  ~IntroductionFrame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IntroductionFramePtr>
  IntroductionFramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IntroductionFrame::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IntroductionFrame::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IntroductionFrame::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IntroductionFrame_UnserializedMessageContext<
            UserType, IntroductionFrame::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IntroductionFrame::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IntroductionFrame::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IntroductionFrame_UnserializedMessageContext<
            UserType, IntroductionFrame::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IntroductionFrame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<FileMetadataPtr> file_metadata;
  
  std::vector<TextMetadataPtr> text_metadata;
  
  base::Optional<std::string> required_package;
  
  std::vector<WifiCredentialsMetadataPtr> wifi_credentials_metadata;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(IntroductionFrame);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IntroductionFrame::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IntroductionFrame::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IntroductionFrame::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IntroductionFrame::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  FileMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FileMetadata, T>::value>;
  using DataView = FileMetadataDataView;
  using Data_ = internal::FileMetadata_Data;
  using Type = FileMetadata_Type;

  template <typename... Args>
  static FileMetadataPtr New(Args&&... args) {
    return FileMetadataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FileMetadataPtr From(const U& u) {
    return mojo::TypeConverter<FileMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FileMetadata>::Convert(*this);
  }


  FileMetadata();

  FileMetadata(
      const std::string& name,
      FileMetadata::Type type,
      int64_t payload_id,
      uint64_t size,
      const std::string& mime_type);

  ~FileMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FileMetadataPtr>
  FileMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FileMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FileMetadata::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FileMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FileMetadata_UnserializedMessageContext<
            UserType, FileMetadata::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FileMetadata::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return FileMetadata::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FileMetadata_UnserializedMessageContext<
            UserType, FileMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FileMetadata::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string name;
  
  FileMetadata::Type type;
  
  int64_t payload_id;
  
  uint64_t size;
  
  std::string mime_type;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FileMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FileMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FileMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FileMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class  PairedKeyEncryptionFrame {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PairedKeyEncryptionFrame, T>::value>;
  using DataView = PairedKeyEncryptionFrameDataView;
  using Data_ = internal::PairedKeyEncryptionFrame_Data;

  template <typename... Args>
  static PairedKeyEncryptionFramePtr New(Args&&... args) {
    return PairedKeyEncryptionFramePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PairedKeyEncryptionFramePtr From(const U& u) {
    return mojo::TypeConverter<PairedKeyEncryptionFramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PairedKeyEncryptionFrame>::Convert(*this);
  }


  PairedKeyEncryptionFrame();

  PairedKeyEncryptionFrame(
      std::vector<uint8_t> signed_data,
      std::vector<uint8_t> secret_id_hash);

  ~PairedKeyEncryptionFrame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PairedKeyEncryptionFramePtr>
  PairedKeyEncryptionFramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PairedKeyEncryptionFrame::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PairedKeyEncryptionFrame::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PairedKeyEncryptionFrame_UnserializedMessageContext<
            UserType, PairedKeyEncryptionFrame::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PairedKeyEncryptionFrame::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PairedKeyEncryptionFrame::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PairedKeyEncryptionFrame_UnserializedMessageContext<
            UserType, PairedKeyEncryptionFrame::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PairedKeyEncryptionFrame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<uint8_t> signed_data;
  
  std::vector<uint8_t> secret_id_hash;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  CertificateInfoFrame {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<CertificateInfoFrame, T>::value>;
  using DataView = CertificateInfoFrameDataView;
  using Data_ = internal::CertificateInfoFrame_Data;

  template <typename... Args>
  static CertificateInfoFramePtr New(Args&&... args) {
    return CertificateInfoFramePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static CertificateInfoFramePtr From(const U& u) {
    return mojo::TypeConverter<CertificateInfoFramePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, CertificateInfoFrame>::Convert(*this);
  }


  CertificateInfoFrame();

  explicit CertificateInfoFrame(
      std::vector<PublicCertificatePtr> public_certificate);

  ~CertificateInfoFrame();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = CertificateInfoFramePtr>
  CertificateInfoFramePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, CertificateInfoFrame::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        CertificateInfoFrame::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        CertificateInfoFrame::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::CertificateInfoFrame_UnserializedMessageContext<
            UserType, CertificateInfoFrame::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<CertificateInfoFrame::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return CertificateInfoFrame::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::CertificateInfoFrame_UnserializedMessageContext<
            UserType, CertificateInfoFrame::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<CertificateInfoFrame::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<PublicCertificatePtr> public_certificate;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(CertificateInfoFrame);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, CertificateInfoFrame::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, CertificateInfoFrame::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, CertificateInfoFrame::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, CertificateInfoFrame::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  PublicCertificate {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PublicCertificate, T>::value>;
  using DataView = PublicCertificateDataView;
  using Data_ = internal::PublicCertificate_Data;

  template <typename... Args>
  static PublicCertificatePtr New(Args&&... args) {
    return PublicCertificatePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PublicCertificatePtr From(const U& u) {
    return mojo::TypeConverter<PublicCertificatePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PublicCertificate>::Convert(*this);
  }


  PublicCertificate();

  PublicCertificate(
      std::vector<uint8_t> secret_id,
      std::vector<uint8_t> authenticity_key,
      std::vector<uint8_t> public_key,
      ::base::Time start_time,
      ::base::Time end_time,
      std::vector<uint8_t> encrypted_metadata_bytes,
      std::vector<uint8_t> metadata_encryption_key_tag);

  ~PublicCertificate();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PublicCertificatePtr>
  PublicCertificatePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PublicCertificate::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PublicCertificate::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PublicCertificate::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PublicCertificate_UnserializedMessageContext<
            UserType, PublicCertificate::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PublicCertificate::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PublicCertificate::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PublicCertificate_UnserializedMessageContext<
            UserType, PublicCertificate::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PublicCertificate::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<uint8_t> secret_id;
  
  std::vector<uint8_t> authenticity_key;
  
  std::vector<uint8_t> public_key;
  
  ::base::Time start_time;
  
  ::base::Time end_time;
  
  std::vector<uint8_t> encrypted_metadata_bytes;
  
  std::vector<uint8_t> metadata_encryption_key_tag;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PublicCertificate::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PublicCertificate::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PublicCertificate::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PublicCertificate::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename UnionPtrType>
FramePtr Frame::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::V1:
      rv->set_v1(mojo::Clone(*data_.v1));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, Frame>::value>::type*>
bool Frame::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::V1:
      return mojo::Equals(*(data_.v1), *(other.data_.v1));
  }

  return false;
}
template <typename UnionPtrType>
V1FramePtr V1Frame::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::INTRODUCTION:
      rv->set_introduction(mojo::Clone(*data_.introduction));
      break;
    case Tag::CONNECTION_RESPONSE:
      rv->set_connection_response(mojo::Clone(*data_.connection_response));
      break;
    case Tag::PAIRED_KEY_ENCRYPTION:
      rv->set_paired_key_encryption(mojo::Clone(*data_.paired_key_encryption));
      break;
    case Tag::PAIRED_KEY_RESULT:
      rv->set_paired_key_result(mojo::Clone(*data_.paired_key_result));
      break;
    case Tag::CERTIFICATE_INFO:
      rv->set_certificate_info(mojo::Clone(*data_.certificate_info));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, V1Frame>::value>::type*>
bool V1Frame::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::INTRODUCTION:
      return mojo::Equals(*(data_.introduction), *(other.data_.introduction));
    case Tag::CONNECTION_RESPONSE:
      return mojo::Equals(*(data_.connection_response), *(other.data_.connection_response));
    case Tag::PAIRED_KEY_ENCRYPTION:
      return mojo::Equals(*(data_.paired_key_encryption), *(other.data_.paired_key_encryption));
    case Tag::PAIRED_KEY_RESULT:
      return mojo::Equals(*(data_.paired_key_result), *(other.data_.paired_key_result));
    case Tag::CERTIFICATE_INFO:
      return mojo::Equals(*(data_.certificate_info), *(other.data_.certificate_info));
  }

  return false;
}
template <typename StructPtrType>
AdvertisementPtr Advertisement::Clone() const {
  return New(
      mojo::Clone(salt),
      mojo::Clone(encrypted_metadata),
      mojo::Clone(device_name)
  );
}

template <typename T, Advertisement::EnableIfSame<T>*>
bool Advertisement::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->salt, other_struct.salt))
    return false;
  if (!mojo::Equals(this->encrypted_metadata, other_struct.encrypted_metadata))
    return false;
  if (!mojo::Equals(this->device_name, other_struct.device_name))
    return false;
  return true;
}

template <typename T, Advertisement::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.salt < rhs.salt)
    return true;
  if (rhs.salt < lhs.salt)
    return false;
  if (lhs.encrypted_metadata < rhs.encrypted_metadata)
    return true;
  if (rhs.encrypted_metadata < lhs.encrypted_metadata)
    return false;
  if (lhs.device_name < rhs.device_name)
    return true;
  if (rhs.device_name < lhs.device_name)
    return false;
  return false;
}
template <typename StructPtrType>
IntroductionFramePtr IntroductionFrame::Clone() const {
  return New(
      mojo::Clone(file_metadata),
      mojo::Clone(text_metadata),
      mojo::Clone(required_package),
      mojo::Clone(wifi_credentials_metadata)
  );
}

template <typename T, IntroductionFrame::EnableIfSame<T>*>
bool IntroductionFrame::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->file_metadata, other_struct.file_metadata))
    return false;
  if (!mojo::Equals(this->text_metadata, other_struct.text_metadata))
    return false;
  if (!mojo::Equals(this->required_package, other_struct.required_package))
    return false;
  if (!mojo::Equals(this->wifi_credentials_metadata, other_struct.wifi_credentials_metadata))
    return false;
  return true;
}

template <typename T, IntroductionFrame::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.file_metadata < rhs.file_metadata)
    return true;
  if (rhs.file_metadata < lhs.file_metadata)
    return false;
  if (lhs.text_metadata < rhs.text_metadata)
    return true;
  if (rhs.text_metadata < lhs.text_metadata)
    return false;
  if (lhs.required_package < rhs.required_package)
    return true;
  if (rhs.required_package < lhs.required_package)
    return false;
  if (lhs.wifi_credentials_metadata < rhs.wifi_credentials_metadata)
    return true;
  if (rhs.wifi_credentials_metadata < lhs.wifi_credentials_metadata)
    return false;
  return false;
}
template <typename StructPtrType>
FileMetadataPtr FileMetadata::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(type),
      mojo::Clone(payload_id),
      mojo::Clone(size),
      mojo::Clone(mime_type)
  );
}

template <typename T, FileMetadata::EnableIfSame<T>*>
bool FileMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->payload_id, other_struct.payload_id))
    return false;
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  if (!mojo::Equals(this->mime_type, other_struct.mime_type))
    return false;
  return true;
}

template <typename T, FileMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.name < rhs.name)
    return true;
  if (rhs.name < lhs.name)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.payload_id < rhs.payload_id)
    return true;
  if (rhs.payload_id < lhs.payload_id)
    return false;
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  if (lhs.mime_type < rhs.mime_type)
    return true;
  if (rhs.mime_type < lhs.mime_type)
    return false;
  return false;
}
template <typename StructPtrType>
TextMetadataPtr TextMetadata::Clone() const {
  return New(
      mojo::Clone(text_title),
      mojo::Clone(type),
      mojo::Clone(payload_id),
      mojo::Clone(size)
  );
}

template <typename T, TextMetadata::EnableIfSame<T>*>
bool TextMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->text_title, other_struct.text_title))
    return false;
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->payload_id, other_struct.payload_id))
    return false;
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  return true;
}

template <typename T, TextMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.text_title < rhs.text_title)
    return true;
  if (rhs.text_title < lhs.text_title)
    return false;
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.payload_id < rhs.payload_id)
    return true;
  if (rhs.payload_id < lhs.payload_id)
    return false;
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  return false;
}
template <typename StructPtrType>
WifiCredentialsMetadataPtr WifiCredentialsMetadata::Clone() const {
  return New(
      mojo::Clone(ssid),
      mojo::Clone(security_type),
      mojo::Clone(payload_id)
  );
}

template <typename T, WifiCredentialsMetadata::EnableIfSame<T>*>
bool WifiCredentialsMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->ssid, other_struct.ssid))
    return false;
  if (!mojo::Equals(this->security_type, other_struct.security_type))
    return false;
  if (!mojo::Equals(this->payload_id, other_struct.payload_id))
    return false;
  return true;
}

template <typename T, WifiCredentialsMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.ssid < rhs.ssid)
    return true;
  if (rhs.ssid < lhs.ssid)
    return false;
  if (lhs.security_type < rhs.security_type)
    return true;
  if (rhs.security_type < lhs.security_type)
    return false;
  if (lhs.payload_id < rhs.payload_id)
    return true;
  if (rhs.payload_id < lhs.payload_id)
    return false;
  return false;
}
template <typename StructPtrType>
ConnectionResponseFramePtr ConnectionResponseFrame::Clone() const {
  return New(
      mojo::Clone(status)
  );
}

template <typename T, ConnectionResponseFrame::EnableIfSame<T>*>
bool ConnectionResponseFrame::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  return true;
}

template <typename T, ConnectionResponseFrame::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.status < rhs.status)
    return true;
  if (rhs.status < lhs.status)
    return false;
  return false;
}
template <typename StructPtrType>
PairedKeyEncryptionFramePtr PairedKeyEncryptionFrame::Clone() const {
  return New(
      mojo::Clone(signed_data),
      mojo::Clone(secret_id_hash)
  );
}

template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>*>
bool PairedKeyEncryptionFrame::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->signed_data, other_struct.signed_data))
    return false;
  if (!mojo::Equals(this->secret_id_hash, other_struct.secret_id_hash))
    return false;
  return true;
}

template <typename T, PairedKeyEncryptionFrame::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.signed_data < rhs.signed_data)
    return true;
  if (rhs.signed_data < lhs.signed_data)
    return false;
  if (lhs.secret_id_hash < rhs.secret_id_hash)
    return true;
  if (rhs.secret_id_hash < lhs.secret_id_hash)
    return false;
  return false;
}
template <typename StructPtrType>
PairedKeyResultFramePtr PairedKeyResultFrame::Clone() const {
  return New(
      mojo::Clone(status)
  );
}

template <typename T, PairedKeyResultFrame::EnableIfSame<T>*>
bool PairedKeyResultFrame::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  return true;
}

template <typename T, PairedKeyResultFrame::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.status < rhs.status)
    return true;
  if (rhs.status < lhs.status)
    return false;
  return false;
}
template <typename StructPtrType>
CertificateInfoFramePtr CertificateInfoFrame::Clone() const {
  return New(
      mojo::Clone(public_certificate)
  );
}

template <typename T, CertificateInfoFrame::EnableIfSame<T>*>
bool CertificateInfoFrame::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->public_certificate, other_struct.public_certificate))
    return false;
  return true;
}

template <typename T, CertificateInfoFrame::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.public_certificate < rhs.public_certificate)
    return true;
  if (rhs.public_certificate < lhs.public_certificate)
    return false;
  return false;
}
template <typename StructPtrType>
PublicCertificatePtr PublicCertificate::Clone() const {
  return New(
      mojo::Clone(secret_id),
      mojo::Clone(authenticity_key),
      mojo::Clone(public_key),
      mojo::Clone(start_time),
      mojo::Clone(end_time),
      mojo::Clone(encrypted_metadata_bytes),
      mojo::Clone(metadata_encryption_key_tag)
  );
}

template <typename T, PublicCertificate::EnableIfSame<T>*>
bool PublicCertificate::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->secret_id, other_struct.secret_id))
    return false;
  if (!mojo::Equals(this->authenticity_key, other_struct.authenticity_key))
    return false;
  if (!mojo::Equals(this->public_key, other_struct.public_key))
    return false;
  if (!mojo::Equals(this->start_time, other_struct.start_time))
    return false;
  if (!mojo::Equals(this->end_time, other_struct.end_time))
    return false;
  if (!mojo::Equals(this->encrypted_metadata_bytes, other_struct.encrypted_metadata_bytes))
    return false;
  if (!mojo::Equals(this->metadata_encryption_key_tag, other_struct.metadata_encryption_key_tag))
    return false;
  return true;
}

template <typename T, PublicCertificate::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.secret_id < rhs.secret_id)
    return true;
  if (rhs.secret_id < lhs.secret_id)
    return false;
  if (lhs.authenticity_key < rhs.authenticity_key)
    return true;
  if (rhs.authenticity_key < lhs.authenticity_key)
    return false;
  if (lhs.public_key < rhs.public_key)
    return true;
  if (rhs.public_key < lhs.public_key)
    return false;
  if (lhs.start_time < rhs.start_time)
    return true;
  if (rhs.start_time < lhs.start_time)
    return false;
  if (lhs.end_time < rhs.end_time)
    return true;
  if (rhs.end_time < lhs.end_time)
    return false;
  if (lhs.encrypted_metadata_bytes < rhs.encrypted_metadata_bytes)
    return true;
  if (rhs.encrypted_metadata_bytes < lhs.encrypted_metadata_bytes)
    return false;
  if (lhs.metadata_encryption_key_tag < rhs.metadata_encryption_key_tag)
    return true;
  if (rhs.metadata_encryption_key_tag < lhs.metadata_encryption_key_tag)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace sharing

namespace mojo {


template <>
struct  StructTraits<::sharing::mojom::Advertisement::DataView,
                                         ::sharing::mojom::AdvertisementPtr> {
  static bool IsNull(const ::sharing::mojom::AdvertisementPtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::AdvertisementPtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::Advertisement::salt)& salt(
      const ::sharing::mojom::AdvertisementPtr& input) {
    return input->salt;
  }

  static const decltype(::sharing::mojom::Advertisement::encrypted_metadata)& encrypted_metadata(
      const ::sharing::mojom::AdvertisementPtr& input) {
    return input->encrypted_metadata;
  }

  static const decltype(::sharing::mojom::Advertisement::device_name)& device_name(
      const ::sharing::mojom::AdvertisementPtr& input) {
    return input->device_name;
  }

  static bool Read(::sharing::mojom::Advertisement::DataView input, ::sharing::mojom::AdvertisementPtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::IntroductionFrame::DataView,
                                         ::sharing::mojom::IntroductionFramePtr> {
  static bool IsNull(const ::sharing::mojom::IntroductionFramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::IntroductionFramePtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::IntroductionFrame::file_metadata)& file_metadata(
      const ::sharing::mojom::IntroductionFramePtr& input) {
    return input->file_metadata;
  }

  static const decltype(::sharing::mojom::IntroductionFrame::text_metadata)& text_metadata(
      const ::sharing::mojom::IntroductionFramePtr& input) {
    return input->text_metadata;
  }

  static const decltype(::sharing::mojom::IntroductionFrame::required_package)& required_package(
      const ::sharing::mojom::IntroductionFramePtr& input) {
    return input->required_package;
  }

  static const decltype(::sharing::mojom::IntroductionFrame::wifi_credentials_metadata)& wifi_credentials_metadata(
      const ::sharing::mojom::IntroductionFramePtr& input) {
    return input->wifi_credentials_metadata;
  }

  static bool Read(::sharing::mojom::IntroductionFrame::DataView input, ::sharing::mojom::IntroductionFramePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::FileMetadata::DataView,
                                         ::sharing::mojom::FileMetadataPtr> {
  static bool IsNull(const ::sharing::mojom::FileMetadataPtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::FileMetadataPtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::FileMetadata::name)& name(
      const ::sharing::mojom::FileMetadataPtr& input) {
    return input->name;
  }

  static decltype(::sharing::mojom::FileMetadata::type) type(
      const ::sharing::mojom::FileMetadataPtr& input) {
    return input->type;
  }

  static decltype(::sharing::mojom::FileMetadata::payload_id) payload_id(
      const ::sharing::mojom::FileMetadataPtr& input) {
    return input->payload_id;
  }

  static decltype(::sharing::mojom::FileMetadata::size) size(
      const ::sharing::mojom::FileMetadataPtr& input) {
    return input->size;
  }

  static const decltype(::sharing::mojom::FileMetadata::mime_type)& mime_type(
      const ::sharing::mojom::FileMetadataPtr& input) {
    return input->mime_type;
  }

  static bool Read(::sharing::mojom::FileMetadata::DataView input, ::sharing::mojom::FileMetadataPtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::TextMetadata::DataView,
                                         ::sharing::mojom::TextMetadataPtr> {
  static bool IsNull(const ::sharing::mojom::TextMetadataPtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::TextMetadataPtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::TextMetadata::text_title)& text_title(
      const ::sharing::mojom::TextMetadataPtr& input) {
    return input->text_title;
  }

  static decltype(::sharing::mojom::TextMetadata::type) type(
      const ::sharing::mojom::TextMetadataPtr& input) {
    return input->type;
  }

  static decltype(::sharing::mojom::TextMetadata::payload_id) payload_id(
      const ::sharing::mojom::TextMetadataPtr& input) {
    return input->payload_id;
  }

  static decltype(::sharing::mojom::TextMetadata::size) size(
      const ::sharing::mojom::TextMetadataPtr& input) {
    return input->size;
  }

  static bool Read(::sharing::mojom::TextMetadata::DataView input, ::sharing::mojom::TextMetadataPtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::WifiCredentialsMetadata::DataView,
                                         ::sharing::mojom::WifiCredentialsMetadataPtr> {
  static bool IsNull(const ::sharing::mojom::WifiCredentialsMetadataPtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::WifiCredentialsMetadataPtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::WifiCredentialsMetadata::ssid)& ssid(
      const ::sharing::mojom::WifiCredentialsMetadataPtr& input) {
    return input->ssid;
  }

  static decltype(::sharing::mojom::WifiCredentialsMetadata::security_type) security_type(
      const ::sharing::mojom::WifiCredentialsMetadataPtr& input) {
    return input->security_type;
  }

  static decltype(::sharing::mojom::WifiCredentialsMetadata::payload_id) payload_id(
      const ::sharing::mojom::WifiCredentialsMetadataPtr& input) {
    return input->payload_id;
  }

  static bool Read(::sharing::mojom::WifiCredentialsMetadata::DataView input, ::sharing::mojom::WifiCredentialsMetadataPtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::ConnectionResponseFrame::DataView,
                                         ::sharing::mojom::ConnectionResponseFramePtr> {
  static bool IsNull(const ::sharing::mojom::ConnectionResponseFramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::ConnectionResponseFramePtr* output) { output->reset(); }

  static decltype(::sharing::mojom::ConnectionResponseFrame::status) status(
      const ::sharing::mojom::ConnectionResponseFramePtr& input) {
    return input->status;
  }

  static bool Read(::sharing::mojom::ConnectionResponseFrame::DataView input, ::sharing::mojom::ConnectionResponseFramePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::PairedKeyEncryptionFrame::DataView,
                                         ::sharing::mojom::PairedKeyEncryptionFramePtr> {
  static bool IsNull(const ::sharing::mojom::PairedKeyEncryptionFramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::PairedKeyEncryptionFramePtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::PairedKeyEncryptionFrame::signed_data)& signed_data(
      const ::sharing::mojom::PairedKeyEncryptionFramePtr& input) {
    return input->signed_data;
  }

  static const decltype(::sharing::mojom::PairedKeyEncryptionFrame::secret_id_hash)& secret_id_hash(
      const ::sharing::mojom::PairedKeyEncryptionFramePtr& input) {
    return input->secret_id_hash;
  }

  static bool Read(::sharing::mojom::PairedKeyEncryptionFrame::DataView input, ::sharing::mojom::PairedKeyEncryptionFramePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::PairedKeyResultFrame::DataView,
                                         ::sharing::mojom::PairedKeyResultFramePtr> {
  static bool IsNull(const ::sharing::mojom::PairedKeyResultFramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::PairedKeyResultFramePtr* output) { output->reset(); }

  static decltype(::sharing::mojom::PairedKeyResultFrame::status) status(
      const ::sharing::mojom::PairedKeyResultFramePtr& input) {
    return input->status;
  }

  static bool Read(::sharing::mojom::PairedKeyResultFrame::DataView input, ::sharing::mojom::PairedKeyResultFramePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::CertificateInfoFrame::DataView,
                                         ::sharing::mojom::CertificateInfoFramePtr> {
  static bool IsNull(const ::sharing::mojom::CertificateInfoFramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::CertificateInfoFramePtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::CertificateInfoFrame::public_certificate)& public_certificate(
      const ::sharing::mojom::CertificateInfoFramePtr& input) {
    return input->public_certificate;
  }

  static bool Read(::sharing::mojom::CertificateInfoFrame::DataView input, ::sharing::mojom::CertificateInfoFramePtr* output);
};


template <>
struct  StructTraits<::sharing::mojom::PublicCertificate::DataView,
                                         ::sharing::mojom::PublicCertificatePtr> {
  static bool IsNull(const ::sharing::mojom::PublicCertificatePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::PublicCertificatePtr* output) { output->reset(); }

  static const decltype(::sharing::mojom::PublicCertificate::secret_id)& secret_id(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->secret_id;
  }

  static const decltype(::sharing::mojom::PublicCertificate::authenticity_key)& authenticity_key(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->authenticity_key;
  }

  static const decltype(::sharing::mojom::PublicCertificate::public_key)& public_key(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->public_key;
  }

  static const decltype(::sharing::mojom::PublicCertificate::start_time)& start_time(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->start_time;
  }

  static const decltype(::sharing::mojom::PublicCertificate::end_time)& end_time(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->end_time;
  }

  static const decltype(::sharing::mojom::PublicCertificate::encrypted_metadata_bytes)& encrypted_metadata_bytes(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->encrypted_metadata_bytes;
  }

  static const decltype(::sharing::mojom::PublicCertificate::metadata_encryption_key_tag)& metadata_encryption_key_tag(
      const ::sharing::mojom::PublicCertificatePtr& input) {
    return input->metadata_encryption_key_tag;
  }

  static bool Read(::sharing::mojom::PublicCertificate::DataView input, ::sharing::mojom::PublicCertificatePtr* output);
};


template <>
struct  UnionTraits<::sharing::mojom::Frame::DataView,
                                        ::sharing::mojom::FramePtr> {
  static bool IsNull(const ::sharing::mojom::FramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::FramePtr* output) { output->reset(); }

  static ::sharing::mojom::Frame::Tag GetTag(const ::sharing::mojom::FramePtr& input) {
    return input->which();
  }

  static const ::sharing::mojom::V1FramePtr& v1(const ::sharing::mojom::FramePtr& input) {
    return input->get_v1();
  }

  static bool Read(::sharing::mojom::Frame::DataView input, ::sharing::mojom::FramePtr* output);
};


template <>
struct  UnionTraits<::sharing::mojom::V1Frame::DataView,
                                        ::sharing::mojom::V1FramePtr> {
  static bool IsNull(const ::sharing::mojom::V1FramePtr& input) { return !input; }
  static void SetToNull(::sharing::mojom::V1FramePtr* output) { output->reset(); }

  static ::sharing::mojom::V1Frame::Tag GetTag(const ::sharing::mojom::V1FramePtr& input) {
    return input->which();
  }

  static const ::sharing::mojom::IntroductionFramePtr& introduction(const ::sharing::mojom::V1FramePtr& input) {
    return input->get_introduction();
  }

  static const ::sharing::mojom::ConnectionResponseFramePtr& connection_response(const ::sharing::mojom::V1FramePtr& input) {
    return input->get_connection_response();
  }

  static const ::sharing::mojom::PairedKeyEncryptionFramePtr& paired_key_encryption(const ::sharing::mojom::V1FramePtr& input) {
    return input->get_paired_key_encryption();
  }

  static const ::sharing::mojom::PairedKeyResultFramePtr& paired_key_result(const ::sharing::mojom::V1FramePtr& input) {
    return input->get_paired_key_result();
  }

  static const ::sharing::mojom::CertificateInfoFramePtr& certificate_info(const ::sharing::mojom::V1FramePtr& input) {
    return input->get_certificate_info();
  }

  static bool Read(::sharing::mojom::V1Frame::DataView input, ::sharing::mojom::V1FramePtr* output);
};

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_NEARBY_DECODER_TYPES_MOJOM_H_