// Copyright 2020 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated by running //components/schema_org/generate_schema_org_code.py.
// Do not edit.

#include "base/hash/hash.h"
#include "components/schema_org/schema_org_enums.h"

namespace schema_org {
namespace enums {

base::Optional<int> CheckValidEnumString(const std::string& name,
                                         const GURL& value) {
  if (!value.SchemeIsHTTPOrHTTPS() ||
      value.host() != "schema.org" ||
      value.path().empty()) {
    return base::nullopt;
  }
  auto path = value.path().substr(1);

  const auto path_hash = base::PersistentHash(path);

  switch (base::PersistentHash(name)) {
      case 0xa0b124b1:
        // http://schema.org/GenderType
        switch (path_hash) {
            // Male
            case 0xc5d9788d:
              return 1;
            // Female
            case 0xc28107b2:
              return 2;
        }

        break;
      case 0xb346980c:
        // http://schema.org/MapCategoryType
        switch (path_hash) {
            // ParkingMap
            case 0x88d27ae1:
              return 1;
            // SeatingMap
            case 0x7ec5dab1:
              return 2;
            // VenueMap
            case 0xa00bb51a:
              return 3;
            // TransitMap
            case 0xa5ca5824:
              return 4;
        }

        break;
      case 0xc4c70c4f:
        // http://schema.org/ContactPointOption
        switch (path_hash) {
            // HearingImpairedSupported
            case 0x657e6d60:
              return 1;
            // TollFree
            case 0x72586976:
              return 2;
        }

        break;
      case 0x1acc721b:
        // http://schema.org/DigitalDocumentPermissionType
        switch (path_hash) {
            // ReadPermission
            case 0x50b484e9:
              return 1;
            // WritePermission
            case 0x34a38ee4:
              return 2;
            // CommentPermission
            case 0x8eaf825e:
              return 3;
        }

        break;
      case 0xeafdc382:
        // http://schema.org/PaymentStatusType
        switch (path_hash) {
            // PaymentComplete
            case 0x26d9ab41:
              return 1;
            // PaymentPastDue
            case 0xc8c7bcf9:
              return 2;
            // PaymentDue
            case 0x75b1a2c5:
              return 3;
            // PaymentDeclined
            case 0x4dd90ba1:
              return 4;
            // PaymentAutomaticallyApplied
            case 0xd584a07a:
              return 5;
        }

        break;
      case 0xc06cd882:
        // http://schema.org/MusicAlbumReleaseType
        switch (path_hash) {
            // AlbumRelease
            case 0x35d0560b:
              return 1;
            // EPRelease
            case 0x8c4882da:
              return 2;
            // BroadcastRelease
            case 0xb355c40a:
              return 3;
            // SingleRelease
            case 0x6aefb18f:
              return 4;
        }

        break;
      case 0x5a89d209:
        // http://schema.org/GameServerStatus
        switch (path_hash) {
            // OfflinePermanently
            case 0x61d35ae4:
              return 1;
            // OfflineTemporarily
            case 0xfa59e7f:
              return 2;
            // Online
            case 0x5f370550:
              return 3;
            // OnlineFull
            case 0x64268b67:
              return 4;
        }

        break;
      case 0x186ac30b:
        // http://schema.org/OfferItemCondition
        switch (path_hash) {
            // DamagedCondition
            case 0x5e066faa:
              return 1;
            // RefurbishedCondition
            case 0x7e1a0041:
              return 2;
            // UsedCondition
            case 0x63f75bee:
              return 3;
            // NewCondition
            case 0xb214dce8:
              return 4;
        }

        break;
      case 0xc28a5f90:
        // http://schema.org/RestrictedDiet
        switch (path_hash) {
            // KosherDiet
            case 0x67721260:
              return 1;
            // VeganDiet
            case 0x30e9ac1d:
              return 2;
            // DiabeticDiet
            case 0x474a5cd3:
              return 3;
            // HinduDiet
            case 0xc3e804e1:
              return 4;
            // GlutenFreeDiet
            case 0xf33abdc1:
              return 5;
            // HalalDiet
            case 0xfff1c6ef:
              return 6;
            // LowLactoseDiet
            case 0xb233c33c:
              return 7;
            // VegetarianDiet
            case 0xeea849b2:
              return 8;
            // LowCalorieDiet
            case 0xa767865d:
              return 9;
            // LowFatDiet
            case 0x46142fb5:
              return 10;
            // LowSaltDiet
            case 0x9449b293:
              return 11;
        }

        break;
      case 0x212b4e4:
        // http://schema.org/QualitativeValue
        switch (path_hash) {
        }

        break;
      case 0xdeeb1406:
        // http://schema.org/PaymentMethod
        switch (path_hash) {
        }

        break;
      case 0x27590845:
        // http://schema.org/ActionStatusType
        switch (path_hash) {
            // PotentialActionStatus
            case 0xf1fa462f:
              return 1;
            // FailedActionStatus
            case 0x3df766ae:
              return 2;
            // CompletedActionStatus
            case 0x480f097c:
              return 3;
            // ActiveActionStatus
            case 0xd4c6a40:
              return 4;
        }

        break;
      case 0xa8bf8d02:
        // http://schema.org/OrderStatus
        switch (path_hash) {
            // OrderReturned
            case 0xeb21d5f2:
              return 1;
            // OrderProcessing
            case 0xf140383e:
              return 2;
            // OrderPickupAvailable
            case 0x15ca5c6f:
              return 3;
            // OrderProblem
            case 0x221fcf28:
              return 4;
            // OrderDelivered
            case 0xe7433732:
              return 5;
            // OrderInTransit
            case 0x3c9c5dca:
              return 6;
            // OrderCancelled
            case 0x6dc16f4a:
              return 7;
            // OrderPaymentDue
            case 0xeab67623:
              return 8;
        }

        break;
      case 0xe339aa1d:
        // http://schema.org/BookFormatType
        switch (path_hash) {
            // EBook
            case 0x6eac651a:
              return 1;
            // AudiobookFormat
            case 0x901f0f68:
              return 2;
            // Hardcover
            case 0x7478ed3a:
              return 3;
            // Paperback
            case 0xeae259e9:
              return 4;
        }

        break;
      case 0xca319e8d:
        // http://schema.org/ItemListOrderType
        switch (path_hash) {
            // ItemListOrderDescending
            case 0x72ab0345:
              return 1;
            // ItemListUnordered
            case 0x191c7c02:
              return 2;
            // ItemListOrderAscending
            case 0x88e256a0:
              return 3;
        }

        break;
      case 0xf5b4a360:
        // http://schema.org/WarrantyScope
        switch (path_hash) {
        }

        break;
      case 0x73d5057c:
        // http://schema.org/DeliveryMethod
        switch (path_hash) {
            // OnSitePickup
            case 0xa3e6dae8:
              return 1;
        }

        break;
      case 0xb9e7573f:
        // http://schema.org/MusicAlbumProductionType
        switch (path_hash) {
            // SoundtrackAlbum
            case 0x1aba99ec:
              return 1;
            // RemixAlbum
            case 0xbcb0b924:
              return 2;
            // DJMixAlbum
            case 0x48d4909:
              return 3;
            // LiveAlbum
            case 0x71b6e3cf:
              return 4;
            // DemoAlbum
            case 0x309419d2:
              return 5;
            // SpokenWordAlbum
            case 0xf8146ed7:
              return 6;
            // CompilationAlbum
            case 0x98c87051:
              return 7;
            // StudioAlbum
            case 0x5d394f5:
              return 8;
            // MixtapeAlbum
            case 0xb97c7c95:
              return 9;
        }

        break;
      case 0x12a13ab8:
        // http://schema.org/Specialty
        switch (path_hash) {
        }

        break;
      case 0x6b687bbf:
        // http://schema.org/ItemAvailability
        switch (path_hash) {
            // SoldOut
            case 0x745404e5:
              return 1;
            // PreOrder
            case 0x10b40b30:
              return 2;
            // OutOfStock
            case 0xba868fe6:
              return 3;
            // PreSale
            case 0x6a95fd50:
              return 4;
            // InStock
            case 0xd03680e6:
              return 5;
            // LimitedAvailability
            case 0x84bc29fd:
              return 6;
            // Discontinued
            case 0x108e06a1:
              return 7;
            // OnlineOnly
            case 0x16222779:
              return 8;
            // InStoreOnly
            case 0x2bfd3300:
              return 9;
        }

        break;
      case 0xa86b7fde:
        // http://schema.org/BusinessFunction
        switch (path_hash) {
        }

        break;
      case 0x25bf0af8:
        // http://schema.org/RsvpResponseType
        switch (path_hash) {
            // RsvpResponseYes
            case 0xa7dc8ff4:
              return 1;
            // RsvpResponseNo
            case 0x21730668:
              return 2;
            // RsvpResponseMaybe
            case 0xbc928868:
              return 3;
        }

        break;
      case 0x86525220:
        // http://schema.org/BusinessEntityType
        switch (path_hash) {
        }

        break;
      case 0x8dc5a5a3:
        // http://schema.org/ReservationStatusType
        switch (path_hash) {
            // ReservationConfirmed
            case 0xd266e483:
              return 1;
            // ReservationPending
            case 0x2fa4119a:
              return 2;
            // ReservationCancelled
            case 0xe70fc4f5:
              return 3;
            // ReservationHold
            case 0x6565aef4:
              return 4;
        }

        break;
      case 0x341996d5:
        // http://schema.org/BoardingPolicyType
        switch (path_hash) {
            // ZoneBoardingPolicy
            case 0xbad2870f:
              return 1;
            // GroupBoardingPolicy
            case 0x35ad7bb8:
              return 2;
        }

        break;
      case 0x6c743f72:
        // http://schema.org/MusicReleaseFormatType
        switch (path_hash) {
            // DigitalAudioTapeFormat
            case 0xea93b6cb:
              return 1;
            // VinylFormat
            case 0xed3c338a:
              return 2;
            // CassetteFormat
            case 0xad6df0aa:
              return 3;
            // LaserDiscFormat
            case 0x3f5ed111:
              return 4;
            // DigitalFormat
            case 0x44c1ee41:
              return 5;
            // CDFormat
            case 0xbacdbdc3:
              return 6;
            // DVDFormat
            case 0xaf08a097:
              return 7;
        }

        break;
      case 0x5bf5e4bc:
        // http://schema.org/DayOfWeek
        switch (path_hash) {
            // Wednesday
            case 0x173da3cd:
              return 1;
            // Sunday
            case 0xc4b58630:
              return 2;
            // PublicHolidays
            case 0x28ef967b:
              return 3;
            // Monday
            case 0x26b87f75:
              return 4;
            // Friday
            case 0xe731ca37:
              return 5;
            // Tuesday
            case 0x6d6d7bea:
              return 6;
            // Saturday
            case 0x8f1c9ebc:
              return 7;
            // Thursday
            case 0x70414f57:
              return 8;
        }

        break;
      case 0x5a25b07e:
        // http://schema.org/EventStatusType
        switch (path_hash) {
            // EventPostponed
            case 0xef90a32c:
              return 1;
            // EventRescheduled
            case 0xa04eec1b:
              return 2;
            // EventScheduled
            case 0x7f42735e:
              return 3;
            // EventCancelled
            case 0xeae7f5cb:
              return 4;
        }

        break;
      case 0x2df88f28:
        // http://schema.org/GamePlayMode
        switch (path_hash) {
            // MultiPlayer
            case 0xe25da12a:
              return 1;
            // CoOp
            case 0x66d03c1e:
              return 2;
            // SinglePlayer
            case 0xbd95c143:
              return 3;
        }

        break;
  }

  return base::nullopt;
}


}  // property
}  // enums