// components/services/storage/public/mojom/service_worker_storage_control.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_TEST_UTILS_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_TEST_UTILS_H_

#include "components/services/storage/public/mojom/service_worker_storage_control.mojom.h"


namespace storage {
namespace mojom {


class  ServiceWorkerLiveVersionRefInterceptorForTesting : public ServiceWorkerLiveVersionRef {
  virtual ServiceWorkerLiveVersionRef* GetForwardingInterface() = 0;
};
class  ServiceWorkerLiveVersionRefAsyncWaiter {
 public:
  explicit ServiceWorkerLiveVersionRefAsyncWaiter(ServiceWorkerLiveVersionRef* proxy);
  ~ServiceWorkerLiveVersionRefAsyncWaiter();

 private:
  ServiceWorkerLiveVersionRef* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerLiveVersionRefAsyncWaiter);
};


class  ServiceWorkerResourceReaderInterceptorForTesting : public ServiceWorkerResourceReader {
  virtual ServiceWorkerResourceReader* GetForwardingInterface() = 0;
  void ReadResponseHead(ReadResponseHeadCallback callback) override;
  void ReadData(int64_t size, ReadDataCallback callback) override;
};
class  ServiceWorkerResourceReaderAsyncWaiter {
 public:
  explicit ServiceWorkerResourceReaderAsyncWaiter(ServiceWorkerResourceReader* proxy);
  ~ServiceWorkerResourceReaderAsyncWaiter();
  void ReadResponseHead(
      int32_t* out_status, ::network::mojom::URLResponseHeadPtr* out_response_head, base::Optional<::mojo_base::BigBuffer>* out_metadata);
  void ReadData(
      int64_t size, ::mojo::ScopedDataPipeConsumerHandle* out_pipe);

 private:
  ServiceWorkerResourceReader* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerResourceReaderAsyncWaiter);
};


class  ServiceWorkerResourceWriterInterceptorForTesting : public ServiceWorkerResourceWriter {
  virtual ServiceWorkerResourceWriter* GetForwardingInterface() = 0;
  void WriteResponseHead(::network::mojom::URLResponseHeadPtr response_head, WriteResponseHeadCallback callback) override;
  void WriteData(::mojo_base::BigBuffer data, WriteDataCallback callback) override;
};
class  ServiceWorkerResourceWriterAsyncWaiter {
 public:
  explicit ServiceWorkerResourceWriterAsyncWaiter(ServiceWorkerResourceWriter* proxy);
  ~ServiceWorkerResourceWriterAsyncWaiter();
  void WriteResponseHead(
      ::network::mojom::URLResponseHeadPtr response_head, int32_t* out_status);
  void WriteData(
      ::mojo_base::BigBuffer data, int32_t* out_status);

 private:
  ServiceWorkerResourceWriter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerResourceWriterAsyncWaiter);
};


class  ServiceWorkerResourceMetadataWriterInterceptorForTesting : public ServiceWorkerResourceMetadataWriter {
  virtual ServiceWorkerResourceMetadataWriter* GetForwardingInterface() = 0;
  void WriteMetadata(::mojo_base::BigBuffer data, WriteMetadataCallback callback) override;
};
class  ServiceWorkerResourceMetadataWriterAsyncWaiter {
 public:
  explicit ServiceWorkerResourceMetadataWriterAsyncWaiter(ServiceWorkerResourceMetadataWriter* proxy);
  ~ServiceWorkerResourceMetadataWriterAsyncWaiter();
  void WriteMetadata(
      ::mojo_base::BigBuffer data, int32_t* out_status);

 private:
  ServiceWorkerResourceMetadataWriter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerResourceMetadataWriterAsyncWaiter);
};


class  ServiceWorkerStorageControlInterceptorForTesting : public ServiceWorkerStorageControl {
  virtual ServiceWorkerStorageControl* GetForwardingInterface() = 0;
  void FindRegistrationForClientUrl(const ::GURL& client_url, FindRegistrationForClientUrlCallback callback) override;
  void FindRegistrationForScope(const ::GURL& scope, FindRegistrationForScopeCallback callback) override;
  void FindRegistrationForId(int64_t registration_id, const ::GURL& origin, FindRegistrationForIdCallback callback) override;
  void GetRegistrationsForOrigin(const ::GURL& origin, GetRegistrationsForOriginCallback callback) override;
  void StoreRegistration(::storage::mojom::ServiceWorkerRegistrationDataPtr registration, std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources, StoreRegistrationCallback callback) override;
  void DeleteRegistration(int64_t registration_id, const ::GURL& origin, DeleteRegistrationCallback callback) override;
  void UpdateToActiveState(int64_t registration_id, const ::GURL& origin, UpdateToActiveStateCallback callback) override;
  void UpdateLastUpdateCheckTime(int64_t registration_id, const ::GURL& origin, ::base::Time last_update_check_time, UpdateLastUpdateCheckTimeCallback callback) override;
  void UpdateNavigationPreloadEnabled(int64_t registration_id, const ::GURL& origin, bool enable, UpdateNavigationPreloadEnabledCallback callback) override;
  void UpdateNavigationPreloadHeader(int64_t registration_id, const ::GURL& origin, const std::string& value, UpdateNavigationPreloadHeaderCallback callback) override;
  void GetNewRegistrationId(GetNewRegistrationIdCallback callback) override;
  void GetNewVersionId(GetNewVersionIdCallback callback) override;
  void GetNewResourceId(GetNewResourceIdCallback callback) override;
  void CreateResourceReader(int64_t resource_id, ::mojo::PendingReceiver<ServiceWorkerResourceReader> reader) override;
  void CreateResourceWriter(int64_t resource_id, ::mojo::PendingReceiver<ServiceWorkerResourceWriter> writer) override;
  void CreateResourceMetadataWriter(int64_t resource_id, ::mojo::PendingReceiver<ServiceWorkerResourceMetadataWriter> writer) override;
  void StoreUncommittedResourceId(int64_t resource_id, const ::GURL& origin, StoreUncommittedResourceIdCallback callback) override;
  void DoomUncommittedResources(const std::vector<int64_t>& resource_ids, DoomUncommittedResourcesCallback callback) override;
  void GetUserData(int64_t registration_id, const std::vector<std::string>& keys, GetUserDataCallback callback) override;
  void StoreUserData(int64_t registration_id, const ::GURL& origin, std::vector<ServiceWorkerUserDataPtr> user_data, StoreUserDataCallback callback) override;
  void ClearUserData(int64_t registration_id, const std::vector<std::string>& keys, ClearUserDataCallback callback) override;
  void GetUserDataByKeyPrefix(int64_t registration_id, const std::string& key_prefix, GetUserDataByKeyPrefixCallback callback) override;
  void GetUserKeysAndDataByKeyPrefix(int64_t registration_id, const std::string& key_prefix, GetUserKeysAndDataByKeyPrefixCallback callback) override;
  void ClearUserDataByKeyPrefixes(int64_t registratation_id, const std::vector<std::string>& key_prefixes, ClearUserDataByKeyPrefixesCallback callback) override;
  void GetUserDataForAllRegistrations(const std::string& key, GetUserDataForAllRegistrationsCallback callback) override;
  void GetUserDataForAllRegistrationsByKeyPrefix(const std::string& key_prefix, GetUserDataForAllRegistrationsByKeyPrefixCallback callback) override;
  void ClearUserDataForAllRegistrationsByKeyPrefix(const std::string& key_prefix, ClearUserDataForAllRegistrationsByKeyPrefixCallback callback) override;
  void ApplyPolicyUpdates(std::vector<::storage::mojom::LocalStoragePolicyUpdatePtr> policy_updates) override;
};
class  ServiceWorkerStorageControlAsyncWaiter {
 public:
  explicit ServiceWorkerStorageControlAsyncWaiter(ServiceWorkerStorageControl* proxy);
  ~ServiceWorkerStorageControlAsyncWaiter();
  void FindRegistrationForClientUrl(
      const ::GURL& client_url, ServiceWorkerFindRegistrationResultPtr* out_result);
  void FindRegistrationForScope(
      const ::GURL& scope, ServiceWorkerFindRegistrationResultPtr* out_result);
  void FindRegistrationForId(
      int64_t registration_id, const ::GURL& origin, ServiceWorkerFindRegistrationResultPtr* out_result);
  void GetRegistrationsForOrigin(
      const ::GURL& origin, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, std::vector<SerializedServiceWorkerRegistrationPtr>* out_registrations);
  void StoreRegistration(
      ::storage::mojom::ServiceWorkerRegistrationDataPtr registration, std::vector<::storage::mojom::ServiceWorkerResourceRecordPtr> resources, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void DeleteRegistration(
      int64_t registration_id, const ::GURL& origin, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, ServiceWorkerStorageOriginState* out_origin_state);
  void UpdateToActiveState(
      int64_t registration_id, const ::GURL& origin, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void UpdateLastUpdateCheckTime(
      int64_t registration_id, const ::GURL& origin, ::base::Time last_update_check_time, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void UpdateNavigationPreloadEnabled(
      int64_t registration_id, const ::GURL& origin, bool enable, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void UpdateNavigationPreloadHeader(
      int64_t registration_id, const ::GURL& origin, const std::string& value, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void GetNewRegistrationId(
      int64_t* out_registration_id);
  void GetNewVersionId(
      int64_t* out_version_id, ::mojo::PendingRemote<ServiceWorkerLiveVersionRef>* out_version_reference);
  void GetNewResourceId(
      int64_t* out_resource_id);
  void StoreUncommittedResourceId(
      int64_t resource_id, const ::GURL& origin, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void DoomUncommittedResources(
      const std::vector<int64_t>& resource_ids, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void GetUserData(
      int64_t registration_id, const std::vector<std::string>& keys, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, std::vector<std::string>* out_values);
  void StoreUserData(
      int64_t registration_id, const ::GURL& origin, std::vector<ServiceWorkerUserDataPtr> user_data, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void ClearUserData(
      int64_t registration_id, const std::vector<std::string>& keys, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void GetUserDataByKeyPrefix(
      int64_t registration_id, const std::string& key_prefix, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, std::vector<std::string>* out_values);
  void GetUserKeysAndDataByKeyPrefix(
      int64_t registration_id, const std::string& key_prefix, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, base::flat_map<std::string, std::string>* out_user_data);
  void ClearUserDataByKeyPrefixes(
      int64_t registratation_id, const std::vector<std::string>& key_prefixes, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);
  void GetUserDataForAllRegistrations(
      const std::string& key, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, base::flat_map<int64_t, std::string>* out_values);
  void GetUserDataForAllRegistrationsByKeyPrefix(
      const std::string& key_prefix, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status, base::flat_map<int64_t, std::string>* out_values);
  void ClearUserDataForAllRegistrationsByKeyPrefix(
      const std::string& key_prefix, ::storage::mojom::ServiceWorkerDatabaseStatus* out_status);

 private:
  ServiceWorkerStorageControl* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceWorkerStorageControlAsyncWaiter);
};




}  // namespace mojom
}  // namespace storage

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_SERVICE_WORKER_STORAGE_CONTROL_MOJOM_TEST_UTILS_H_