// content/public/common/performance_manager/v8_per_frame_memory.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_PUBLIC_COMMON_PERFORMANCE_MANAGER_V8_PER_FRAME_MEMORY_MOJOM_H_
#define CONTENT_PUBLIC_COMMON_PERFORMANCE_MANAGER_V8_PER_FRAME_MEMORY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "content/public/common/performance_manager/v8_per_frame_memory.mojom-shared.h"
#include "content/public/common/performance_manager/v8_per_frame_memory.mojom-forward.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "content/common/content_export.h"




namespace performance_manager {
namespace mojom {

class V8PerFrameMemoryReporterProxy;

template <typename ImplRefTraits>
class V8PerFrameMemoryReporterStub;

class V8PerFrameMemoryReporterRequestValidator;
class V8PerFrameMemoryReporterResponseValidator;


class CONTENT_EXPORT V8PerFrameMemoryReporter
    : public V8PerFrameMemoryReporterInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = V8PerFrameMemoryReporterInterfaceBase;
  using Proxy_ = V8PerFrameMemoryReporterProxy;

  template <typename ImplRefTraits>
  using Stub_ = V8PerFrameMemoryReporterStub<ImplRefTraits>;

  using RequestValidator_ = V8PerFrameMemoryReporterRequestValidator;
  using ResponseValidator_ = V8PerFrameMemoryReporterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetPerFrameV8MemoryUsageDataMinVersion = 0,
  };
  virtual ~V8PerFrameMemoryReporter() {}


  using GetPerFrameV8MemoryUsageDataCallback = base::OnceCallback<void(PerProcessV8MemoryUsageDataPtr)>;
  
  virtual void GetPerFrameV8MemoryUsageData(GetPerFrameV8MemoryUsageDataCallback callback) = 0;
};



class CONTENT_EXPORT V8PerFrameMemoryReporterProxy
    : public V8PerFrameMemoryReporter {
 public:
  using InterfaceType = V8PerFrameMemoryReporter;

  explicit V8PerFrameMemoryReporterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetPerFrameV8MemoryUsageData(GetPerFrameV8MemoryUsageDataCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT V8PerFrameMemoryReporterStubDispatch {
 public:
  static bool Accept(V8PerFrameMemoryReporter* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      V8PerFrameMemoryReporter* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<V8PerFrameMemoryReporter>>
class V8PerFrameMemoryReporterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  V8PerFrameMemoryReporterStub() {}
  ~V8PerFrameMemoryReporterStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return V8PerFrameMemoryReporterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return V8PerFrameMemoryReporterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT V8PerFrameMemoryReporterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT V8PerFrameMemoryReporterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class CONTENT_EXPORT V8IsolatedWorldMemoryUsage {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<V8IsolatedWorldMemoryUsage, T>::value>;
  using DataView = V8IsolatedWorldMemoryUsageDataView;
  using Data_ = internal::V8IsolatedWorldMemoryUsage_Data;

  template <typename... Args>
  static V8IsolatedWorldMemoryUsagePtr New(Args&&... args) {
    return V8IsolatedWorldMemoryUsagePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static V8IsolatedWorldMemoryUsagePtr From(const U& u) {
    return mojo::TypeConverter<V8IsolatedWorldMemoryUsagePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, V8IsolatedWorldMemoryUsage>::Convert(*this);
  }


  V8IsolatedWorldMemoryUsage();

  V8IsolatedWorldMemoryUsage(
      uint64_t bytes_used,
      const std::string& stable_id,
      const std::string& human_readable_name);

  ~V8IsolatedWorldMemoryUsage();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = V8IsolatedWorldMemoryUsagePtr>
  V8IsolatedWorldMemoryUsagePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        V8IsolatedWorldMemoryUsage::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        V8IsolatedWorldMemoryUsage::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::V8IsolatedWorldMemoryUsage_UnserializedMessageContext<
            UserType, V8IsolatedWorldMemoryUsage::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<V8IsolatedWorldMemoryUsage::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return V8IsolatedWorldMemoryUsage::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::V8IsolatedWorldMemoryUsage_UnserializedMessageContext<
            UserType, V8IsolatedWorldMemoryUsage::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<V8IsolatedWorldMemoryUsage::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint64_t bytes_used;
  
  std::string stable_id;
  
  std::string human_readable_name;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}










class CONTENT_EXPORT PerFrameV8MemoryUsageData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PerFrameV8MemoryUsageData, T>::value>;
  using DataView = PerFrameV8MemoryUsageDataDataView;
  using Data_ = internal::PerFrameV8MemoryUsageData_Data;

  template <typename... Args>
  static PerFrameV8MemoryUsageDataPtr New(Args&&... args) {
    return PerFrameV8MemoryUsageDataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PerFrameV8MemoryUsageDataPtr From(const U& u) {
    return mojo::TypeConverter<PerFrameV8MemoryUsageDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PerFrameV8MemoryUsageData>::Convert(*this);
  }


  PerFrameV8MemoryUsageData();

  PerFrameV8MemoryUsageData(
      const ::base::UnguessableToken& frame_token,
      base::flat_map<int64_t, V8IsolatedWorldMemoryUsagePtr> associated_bytes);

  ~PerFrameV8MemoryUsageData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PerFrameV8MemoryUsageDataPtr>
  PerFrameV8MemoryUsageDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PerFrameV8MemoryUsageData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PerFrameV8MemoryUsageData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PerFrameV8MemoryUsageData_UnserializedMessageContext<
            UserType, PerFrameV8MemoryUsageData::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PerFrameV8MemoryUsageData::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PerFrameV8MemoryUsageData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PerFrameV8MemoryUsageData_UnserializedMessageContext<
            UserType, PerFrameV8MemoryUsageData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PerFrameV8MemoryUsageData::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::base::UnguessableToken frame_token;
  
  base::flat_map<int64_t, V8IsolatedWorldMemoryUsagePtr> associated_bytes;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PerFrameV8MemoryUsageData);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class CONTENT_EXPORT PerProcessV8MemoryUsageData {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PerProcessV8MemoryUsageData, T>::value>;
  using DataView = PerProcessV8MemoryUsageDataDataView;
  using Data_ = internal::PerProcessV8MemoryUsageData_Data;

  template <typename... Args>
  static PerProcessV8MemoryUsageDataPtr New(Args&&... args) {
    return PerProcessV8MemoryUsageDataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PerProcessV8MemoryUsageDataPtr From(const U& u) {
    return mojo::TypeConverter<PerProcessV8MemoryUsageDataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PerProcessV8MemoryUsageData>::Convert(*this);
  }


  PerProcessV8MemoryUsageData();

  PerProcessV8MemoryUsageData(
      uint64_t unassociated_bytes_used,
      uint64_t num_unassociated_contexts,
      uint64_t unassociated_context_bytes_used,
      std::vector<PerFrameV8MemoryUsageDataPtr> associated_memory);

  ~PerProcessV8MemoryUsageData();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PerProcessV8MemoryUsageDataPtr>
  PerProcessV8MemoryUsageDataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PerProcessV8MemoryUsageData::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PerProcessV8MemoryUsageData::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PerProcessV8MemoryUsageData_UnserializedMessageContext<
            UserType, PerProcessV8MemoryUsageData::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PerProcessV8MemoryUsageData::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return PerProcessV8MemoryUsageData::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PerProcessV8MemoryUsageData_UnserializedMessageContext<
            UserType, PerProcessV8MemoryUsageData::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PerProcessV8MemoryUsageData::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint64_t unassociated_bytes_used;
  
  uint64_t num_unassociated_contexts;
  
  uint64_t unassociated_context_bytes_used;
  
  std::vector<PerFrameV8MemoryUsageDataPtr> associated_memory;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(PerProcessV8MemoryUsageData);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
V8IsolatedWorldMemoryUsagePtr V8IsolatedWorldMemoryUsage::Clone() const {
  return New(
      mojo::Clone(bytes_used),
      mojo::Clone(stable_id),
      mojo::Clone(human_readable_name)
  );
}

template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>*>
bool V8IsolatedWorldMemoryUsage::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->bytes_used, other_struct.bytes_used))
    return false;
  if (!mojo::Equals(this->stable_id, other_struct.stable_id))
    return false;
  if (!mojo::Equals(this->human_readable_name, other_struct.human_readable_name))
    return false;
  return true;
}

template <typename T, V8IsolatedWorldMemoryUsage::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.bytes_used < rhs.bytes_used)
    return true;
  if (rhs.bytes_used < lhs.bytes_used)
    return false;
  if (lhs.stable_id < rhs.stable_id)
    return true;
  if (rhs.stable_id < lhs.stable_id)
    return false;
  if (lhs.human_readable_name < rhs.human_readable_name)
    return true;
  if (rhs.human_readable_name < lhs.human_readable_name)
    return false;
  return false;
}
template <typename StructPtrType>
PerFrameV8MemoryUsageDataPtr PerFrameV8MemoryUsageData::Clone() const {
  return New(
      mojo::Clone(frame_token),
      mojo::Clone(associated_bytes)
  );
}

template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>*>
bool PerFrameV8MemoryUsageData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->frame_token, other_struct.frame_token))
    return false;
  if (!mojo::Equals(this->associated_bytes, other_struct.associated_bytes))
    return false;
  return true;
}

template <typename T, PerFrameV8MemoryUsageData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.frame_token < rhs.frame_token)
    return true;
  if (rhs.frame_token < lhs.frame_token)
    return false;
  if (lhs.associated_bytes < rhs.associated_bytes)
    return true;
  if (rhs.associated_bytes < lhs.associated_bytes)
    return false;
  return false;
}
template <typename StructPtrType>
PerProcessV8MemoryUsageDataPtr PerProcessV8MemoryUsageData::Clone() const {
  return New(
      mojo::Clone(unassociated_bytes_used),
      mojo::Clone(num_unassociated_contexts),
      mojo::Clone(unassociated_context_bytes_used),
      mojo::Clone(associated_memory)
  );
}

template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>*>
bool PerProcessV8MemoryUsageData::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->unassociated_bytes_used, other_struct.unassociated_bytes_used))
    return false;
  if (!mojo::Equals(this->num_unassociated_contexts, other_struct.num_unassociated_contexts))
    return false;
  if (!mojo::Equals(this->unassociated_context_bytes_used, other_struct.unassociated_context_bytes_used))
    return false;
  if (!mojo::Equals(this->associated_memory, other_struct.associated_memory))
    return false;
  return true;
}

template <typename T, PerProcessV8MemoryUsageData::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.unassociated_bytes_used < rhs.unassociated_bytes_used)
    return true;
  if (rhs.unassociated_bytes_used < lhs.unassociated_bytes_used)
    return false;
  if (lhs.num_unassociated_contexts < rhs.num_unassociated_contexts)
    return true;
  if (rhs.num_unassociated_contexts < lhs.num_unassociated_contexts)
    return false;
  if (lhs.unassociated_context_bytes_used < rhs.unassociated_context_bytes_used)
    return true;
  if (rhs.unassociated_context_bytes_used < lhs.unassociated_context_bytes_used)
    return false;
  if (lhs.associated_memory < rhs.associated_memory)
    return true;
  if (rhs.associated_memory < lhs.associated_memory)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace performance_manager

namespace mojo {


template <>
struct CONTENT_EXPORT StructTraits<::performance_manager::mojom::V8IsolatedWorldMemoryUsage::DataView,
                                         ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr> {
  static bool IsNull(const ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr& input) { return !input; }
  static void SetToNull(::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr* output) { output->reset(); }

  static decltype(::performance_manager::mojom::V8IsolatedWorldMemoryUsage::bytes_used) bytes_used(
      const ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr& input) {
    return input->bytes_used;
  }

  static const decltype(::performance_manager::mojom::V8IsolatedWorldMemoryUsage::stable_id)& stable_id(
      const ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr& input) {
    return input->stable_id;
  }

  static const decltype(::performance_manager::mojom::V8IsolatedWorldMemoryUsage::human_readable_name)& human_readable_name(
      const ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr& input) {
    return input->human_readable_name;
  }

  static bool Read(::performance_manager::mojom::V8IsolatedWorldMemoryUsage::DataView input, ::performance_manager::mojom::V8IsolatedWorldMemoryUsagePtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::performance_manager::mojom::PerFrameV8MemoryUsageData::DataView,
                                         ::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr> {
  static bool IsNull(const ::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr& input) { return !input; }
  static void SetToNull(::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr* output) { output->reset(); }

  static const decltype(::performance_manager::mojom::PerFrameV8MemoryUsageData::frame_token)& frame_token(
      const ::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr& input) {
    return input->frame_token;
  }

  static const decltype(::performance_manager::mojom::PerFrameV8MemoryUsageData::associated_bytes)& associated_bytes(
      const ::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr& input) {
    return input->associated_bytes;
  }

  static bool Read(::performance_manager::mojom::PerFrameV8MemoryUsageData::DataView input, ::performance_manager::mojom::PerFrameV8MemoryUsageDataPtr* output);
};


template <>
struct CONTENT_EXPORT StructTraits<::performance_manager::mojom::PerProcessV8MemoryUsageData::DataView,
                                         ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr> {
  static bool IsNull(const ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr& input) { return !input; }
  static void SetToNull(::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr* output) { output->reset(); }

  static decltype(::performance_manager::mojom::PerProcessV8MemoryUsageData::unassociated_bytes_used) unassociated_bytes_used(
      const ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr& input) {
    return input->unassociated_bytes_used;
  }

  static decltype(::performance_manager::mojom::PerProcessV8MemoryUsageData::num_unassociated_contexts) num_unassociated_contexts(
      const ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr& input) {
    return input->num_unassociated_contexts;
  }

  static decltype(::performance_manager::mojom::PerProcessV8MemoryUsageData::unassociated_context_bytes_used) unassociated_context_bytes_used(
      const ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr& input) {
    return input->unassociated_context_bytes_used;
  }

  static const decltype(::performance_manager::mojom::PerProcessV8MemoryUsageData::associated_memory)& associated_memory(
      const ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr& input) {
    return input->associated_memory;
  }

  static bool Read(::performance_manager::mojom::PerProcessV8MemoryUsageData::DataView input, ::performance_manager::mojom::PerProcessV8MemoryUsageDataPtr* output);
};

}  // namespace mojo

#endif  // CONTENT_PUBLIC_COMMON_PERFORMANCE_MANAGER_V8_PER_FRAME_MEMORY_MOJOM_H_