// third_party/blink/public/mojom/digital_goods/digital_goods.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/digital_goods/digital_goods.mojom-shared.h"
#include "third_party/blink/public/mojom/digital_goods/digital_goods.mojom-forward.h"
#include "components/payments/mojom/payment_request_data.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/common_export.h"




namespace payments {
namespace mojom {







class BLINK_COMMON_EXPORT ConsumeParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConsumeParams, T>::value>;
  using DataView = ConsumeParamsDataView;
  using Data_ = internal::ConsumeParams_Data;

  template <typename... Args>
  static ConsumeParamsPtr New(Args&&... args) {
    return ConsumeParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConsumeParamsPtr From(const U& u) {
    return mojo::TypeConverter<ConsumeParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConsumeParams>::Convert(*this);
  }


  ConsumeParams();

  ConsumeParams(
      const std::string& purchase_token,
      bool make_available_again);

  ~ConsumeParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConsumeParamsPtr>
  ConsumeParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConsumeParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConsumeParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConsumeParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConsumeParams_UnserializedMessageContext<
            UserType, ConsumeParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ConsumeParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ConsumeParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConsumeParams_UnserializedMessageContext<
            UserType, ConsumeParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConsumeParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string purchase_token;
  
  bool make_available_again;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConsumeParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConsumeParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConsumeParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConsumeParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT ConsumeResponse {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConsumeResponse, T>::value>;
  using DataView = ConsumeResponseDataView;
  using Data_ = internal::ConsumeResponse_Data;

  template <typename... Args>
  static ConsumeResponsePtr New(Args&&... args) {
    return ConsumeResponsePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConsumeResponsePtr From(const U& u) {
    return mojo::TypeConverter<ConsumeResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConsumeResponse>::Convert(*this);
  }


  ConsumeResponse();

  explicit ConsumeResponse(
      BillingResponseCode code);

  ~ConsumeResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConsumeResponsePtr>
  ConsumeResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConsumeResponse::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConsumeResponse::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConsumeResponse::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConsumeResponse_UnserializedMessageContext<
            UserType, ConsumeResponse::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ConsumeResponse::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ConsumeResponse::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConsumeResponse_UnserializedMessageContext<
            UserType, ConsumeResponse::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConsumeResponse::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  BillingResponseCode code;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConsumeResponse::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConsumeResponse::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConsumeResponse::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConsumeResponse::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}








class BLINK_COMMON_EXPORT GetDetailsParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GetDetailsParams, T>::value>;
  using DataView = GetDetailsParamsDataView;
  using Data_ = internal::GetDetailsParams_Data;

  template <typename... Args>
  static GetDetailsParamsPtr New(Args&&... args) {
    return GetDetailsParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GetDetailsParamsPtr From(const U& u) {
    return mojo::TypeConverter<GetDetailsParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GetDetailsParams>::Convert(*this);
  }


  GetDetailsParams();

  explicit GetDetailsParams(
      std::vector<std::string> item_ids);

  ~GetDetailsParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GetDetailsParamsPtr>
  GetDetailsParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GetDetailsParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GetDetailsParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GetDetailsParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GetDetailsParams_UnserializedMessageContext<
            UserType, GetDetailsParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<GetDetailsParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GetDetailsParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GetDetailsParams_UnserializedMessageContext<
            UserType, GetDetailsParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GetDetailsParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::vector<std::string> item_ids;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GetDetailsParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GetDetailsParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GetDetailsParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GetDetailsParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_COMMON_EXPORT GetDetailsResponse {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GetDetailsResponse, T>::value>;
  using DataView = GetDetailsResponseDataView;
  using Data_ = internal::GetDetailsResponse_Data;

  template <typename... Args>
  static GetDetailsResponsePtr New(Args&&... args) {
    return GetDetailsResponsePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GetDetailsResponsePtr From(const U& u) {
    return mojo::TypeConverter<GetDetailsResponsePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GetDetailsResponse>::Convert(*this);
  }


  GetDetailsResponse();

  GetDetailsResponse(
      BillingResponseCode code,
      std::vector<ItemDetailsPtr> item_details_list);

  ~GetDetailsResponse();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GetDetailsResponsePtr>
  GetDetailsResponsePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GetDetailsResponse::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GetDetailsResponse::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GetDetailsResponse::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GetDetailsResponse_UnserializedMessageContext<
            UserType, GetDetailsResponse::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<GetDetailsResponse::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GetDetailsResponse::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GetDetailsResponse_UnserializedMessageContext<
            UserType, GetDetailsResponse::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GetDetailsResponse::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  BillingResponseCode code;
  
  std::vector<ItemDetailsPtr> item_details_list;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(GetDetailsResponse);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GetDetailsResponse::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GetDetailsResponse::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GetDetailsResponse::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GetDetailsResponse::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class BLINK_COMMON_EXPORT ItemDetails {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ItemDetails, T>::value>;
  using DataView = ItemDetailsDataView;
  using Data_ = internal::ItemDetails_Data;

  template <typename... Args>
  static ItemDetailsPtr New(Args&&... args) {
    return ItemDetailsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ItemDetailsPtr From(const U& u) {
    return mojo::TypeConverter<ItemDetailsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ItemDetails>::Convert(*this);
  }


  ItemDetails();

  ItemDetails(
      const std::string& item_id,
      const std::string& title,
      const std::string& description,
      ::payments::mojom::PaymentCurrencyAmountPtr price);

  ~ItemDetails();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ItemDetailsPtr>
  ItemDetailsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ItemDetails::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ItemDetails::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ItemDetails_UnserializedMessageContext<
            UserType, ItemDetails::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ItemDetails::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ItemDetails::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ItemDetails_UnserializedMessageContext<
            UserType, ItemDetails::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ItemDetails::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string item_id;
  
  std::string title;
  
  std::string description;
  
  ::payments::mojom::PaymentCurrencyAmountPtr price;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ItemDetails);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ItemDetails::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
GetDetailsParamsPtr GetDetailsParams::Clone() const {
  return New(
      mojo::Clone(item_ids)
  );
}

template <typename T, GetDetailsParams::EnableIfSame<T>*>
bool GetDetailsParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->item_ids, other_struct.item_ids))
    return false;
  return true;
}

template <typename T, GetDetailsParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.item_ids < rhs.item_ids)
    return true;
  if (rhs.item_ids < lhs.item_ids)
    return false;
  return false;
}
template <typename StructPtrType>
GetDetailsResponsePtr GetDetailsResponse::Clone() const {
  return New(
      mojo::Clone(code),
      mojo::Clone(item_details_list)
  );
}

template <typename T, GetDetailsResponse::EnableIfSame<T>*>
bool GetDetailsResponse::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code, other_struct.code))
    return false;
  if (!mojo::Equals(this->item_details_list, other_struct.item_details_list))
    return false;
  return true;
}

template <typename T, GetDetailsResponse::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.code < rhs.code)
    return true;
  if (rhs.code < lhs.code)
    return false;
  if (lhs.item_details_list < rhs.item_details_list)
    return true;
  if (rhs.item_details_list < lhs.item_details_list)
    return false;
  return false;
}
template <typename StructPtrType>
ConsumeParamsPtr ConsumeParams::Clone() const {
  return New(
      mojo::Clone(purchase_token),
      mojo::Clone(make_available_again)
  );
}

template <typename T, ConsumeParams::EnableIfSame<T>*>
bool ConsumeParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->purchase_token, other_struct.purchase_token))
    return false;
  if (!mojo::Equals(this->make_available_again, other_struct.make_available_again))
    return false;
  return true;
}

template <typename T, ConsumeParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.purchase_token < rhs.purchase_token)
    return true;
  if (rhs.purchase_token < lhs.purchase_token)
    return false;
  if (lhs.make_available_again < rhs.make_available_again)
    return true;
  if (rhs.make_available_again < lhs.make_available_again)
    return false;
  return false;
}
template <typename StructPtrType>
ConsumeResponsePtr ConsumeResponse::Clone() const {
  return New(
      mojo::Clone(code)
  );
}

template <typename T, ConsumeResponse::EnableIfSame<T>*>
bool ConsumeResponse::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->code, other_struct.code))
    return false;
  return true;
}

template <typename T, ConsumeResponse::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.code < rhs.code)
    return true;
  if (rhs.code < lhs.code)
    return false;
  return false;
}
template <typename StructPtrType>
ItemDetailsPtr ItemDetails::Clone() const {
  return New(
      mojo::Clone(item_id),
      mojo::Clone(title),
      mojo::Clone(description),
      mojo::Clone(price)
  );
}

template <typename T, ItemDetails::EnableIfSame<T>*>
bool ItemDetails::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->item_id, other_struct.item_id))
    return false;
  if (!mojo::Equals(this->title, other_struct.title))
    return false;
  if (!mojo::Equals(this->description, other_struct.description))
    return false;
  if (!mojo::Equals(this->price, other_struct.price))
    return false;
  return true;
}

template <typename T, ItemDetails::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.item_id < rhs.item_id)
    return true;
  if (rhs.item_id < lhs.item_id)
    return false;
  if (lhs.title < rhs.title)
    return true;
  if (rhs.title < lhs.title)
    return false;
  if (lhs.description < rhs.description)
    return true;
  if (rhs.description < lhs.description)
    return false;
  if (lhs.price < rhs.price)
    return true;
  if (rhs.price < lhs.price)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace payments

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::GetDetailsParams::DataView,
                                         ::payments::mojom::GetDetailsParamsPtr> {
  static bool IsNull(const ::payments::mojom::GetDetailsParamsPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::GetDetailsParamsPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::GetDetailsParams::item_ids)& item_ids(
      const ::payments::mojom::GetDetailsParamsPtr& input) {
    return input->item_ids;
  }

  static bool Read(::payments::mojom::GetDetailsParams::DataView input, ::payments::mojom::GetDetailsParamsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::GetDetailsResponse::DataView,
                                         ::payments::mojom::GetDetailsResponsePtr> {
  static bool IsNull(const ::payments::mojom::GetDetailsResponsePtr& input) { return !input; }
  static void SetToNull(::payments::mojom::GetDetailsResponsePtr* output) { output->reset(); }

  static decltype(::payments::mojom::GetDetailsResponse::code) code(
      const ::payments::mojom::GetDetailsResponsePtr& input) {
    return input->code;
  }

  static const decltype(::payments::mojom::GetDetailsResponse::item_details_list)& item_details_list(
      const ::payments::mojom::GetDetailsResponsePtr& input) {
    return input->item_details_list;
  }

  static bool Read(::payments::mojom::GetDetailsResponse::DataView input, ::payments::mojom::GetDetailsResponsePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::ConsumeParams::DataView,
                                         ::payments::mojom::ConsumeParamsPtr> {
  static bool IsNull(const ::payments::mojom::ConsumeParamsPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::ConsumeParamsPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::ConsumeParams::purchase_token)& purchase_token(
      const ::payments::mojom::ConsumeParamsPtr& input) {
    return input->purchase_token;
  }

  static decltype(::payments::mojom::ConsumeParams::make_available_again) make_available_again(
      const ::payments::mojom::ConsumeParamsPtr& input) {
    return input->make_available_again;
  }

  static bool Read(::payments::mojom::ConsumeParams::DataView input, ::payments::mojom::ConsumeParamsPtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::ConsumeResponse::DataView,
                                         ::payments::mojom::ConsumeResponsePtr> {
  static bool IsNull(const ::payments::mojom::ConsumeResponsePtr& input) { return !input; }
  static void SetToNull(::payments::mojom::ConsumeResponsePtr* output) { output->reset(); }

  static decltype(::payments::mojom::ConsumeResponse::code) code(
      const ::payments::mojom::ConsumeResponsePtr& input) {
    return input->code;
  }

  static bool Read(::payments::mojom::ConsumeResponse::DataView input, ::payments::mojom::ConsumeResponsePtr* output);
};


template <>
struct BLINK_COMMON_EXPORT StructTraits<::payments::mojom::ItemDetails::DataView,
                                         ::payments::mojom::ItemDetailsPtr> {
  static bool IsNull(const ::payments::mojom::ItemDetailsPtr& input) { return !input; }
  static void SetToNull(::payments::mojom::ItemDetailsPtr* output) { output->reset(); }

  static const decltype(::payments::mojom::ItemDetails::item_id)& item_id(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->item_id;
  }

  static const decltype(::payments::mojom::ItemDetails::title)& title(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->title;
  }

  static const decltype(::payments::mojom::ItemDetails::description)& description(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->description;
  }

  static const decltype(::payments::mojom::ItemDetails::price)& price(
      const ::payments::mojom::ItemDetailsPtr& input) {
    return input->price;
  }

  static bool Read(::payments::mojom::ItemDetails::DataView input, ::payments::mojom::ItemDetailsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIGITAL_GOODS_DIGITAL_GOODS_MOJOM_H_