// third_party/blink/public/mojom/page/widget.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_WIDGET_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_WIDGET_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/page/widget.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink {
namespace mojom {
namespace blink {


class PLATFORM_EXPORT FrameWidgetInterceptorForTesting : public FrameWidget {
  virtual FrameWidget* GetForwardingInterface() = 0;
  void DragTargetDragOver(const ::gfx::PointF& point_in_viewport, const ::gfx::PointF& screen_point, ::blink::WebDragOperationsMask operations_allowed, uint32_t key_modifiers, DragTargetDragOverCallback callback) override;
  void DragTargetDragLeave(const ::gfx::PointF& point_in_viewport, const ::gfx::PointF& screen_point) override;
  void DragSourceEndedAt(const ::gfx::PointF& point_in_viewport, const ::gfx::PointF& screen_point, ::blink::WebDragOperation drag_operation) override;
  void DragSourceSystemDragEnded() override;
  void SetBackgroundOpaque(bool opaque) override;
  void SetTextDirection(::base::i18n::TextDirection direction) override;
  void SetInheritedEffectiveTouchActionForSubFrame(::cc::TouchAction touch_action) override;
  void UpdateRenderThrottlingStatusForSubFrame(bool is_throttled, bool subtree_throttled) override;
  void SetIsInertForSubFrame(bool inert) override;
};
class PLATFORM_EXPORT FrameWidgetAsyncWaiter {
 public:
  explicit FrameWidgetAsyncWaiter(FrameWidget* proxy);
  ~FrameWidgetAsyncWaiter();
  void DragTargetDragOver(
      const ::gfx::PointF& point_in_viewport, const ::gfx::PointF& screen_point, ::blink::WebDragOperationsMask operations_allowed, uint32_t key_modifiers, ::blink::WebDragOperation* out_operation);

 private:
  FrameWidget* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameWidgetAsyncWaiter);
};


class PLATFORM_EXPORT FrameWidgetHostInterceptorForTesting : public FrameWidgetHost {
  virtual FrameWidgetHost* GetForwardingInterface() = 0;
  void AnimateDoubleTapZoomInMainFrame(const ::gfx::Point& tap_point, const ::gfx::Rect& rect_to_zoom) override;
  void ZoomToFindInPageRectInMainFrame(const ::gfx::Rect& rect_to_zoom) override;
  void SetHasTouchEventHandlers(bool has_handlers) override;
  void IntrinsicSizingInfoChanged(::blink::mojom::blink::IntrinsicSizingInfoPtr sizing_info) override;
  void AutoscrollStart(const ::gfx::PointF& position) override;
  void AutoscrollFling(const ::gfx::Vector2dF& velocity) override;
  void AutoscrollEnd() override;
  void DidFirstVisuallyNonEmptyPaint() override;
};
class PLATFORM_EXPORT FrameWidgetHostAsyncWaiter {
 public:
  explicit FrameWidgetHostAsyncWaiter(FrameWidgetHost* proxy);
  ~FrameWidgetHostAsyncWaiter();

 private:
  FrameWidgetHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameWidgetHostAsyncWaiter);
};


class PLATFORM_EXPORT WidgetInterceptorForTesting : public Widget {
  virtual Widget* GetForwardingInterface() = 0;
  void ForceRedraw(ForceRedrawCallback callback) override;
  void GetWidgetInputHandler(::mojo::PendingReceiver<::blink::mojom::blink::WidgetInputHandler> request, ::mojo::PendingRemote<::blink::mojom::blink::WidgetInputHandlerHost> host) override;
};
class PLATFORM_EXPORT WidgetAsyncWaiter {
 public:
  explicit WidgetAsyncWaiter(Widget* proxy);
  ~WidgetAsyncWaiter();
  void ForceRedraw(
      );

 private:
  Widget* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WidgetAsyncWaiter);
};


class PLATFORM_EXPORT WidgetHostInterceptorForTesting : public WidgetHost {
  virtual WidgetHost* GetForwardingInterface() = 0;
  void SetCursor(const ::ui::Cursor& cursor) override;
  void SetToolTipText(const ::WTF::String& tooltip_text, ::base::i18n::TextDirection text_direction_hint) override;
  void TextInputStateChanged(::ui::mojom::blink::TextInputStatePtr state) override;
  void SelectionBoundsChanged(const ::gfx::Rect& anchor_rect, ::base::i18n::TextDirection anchor_dir, const ::gfx::Rect& focus_rect, ::base::i18n::TextDirection focus_dir, bool is_anchor_first) override;
};
class PLATFORM_EXPORT WidgetHostAsyncWaiter {
 public:
  explicit WidgetHostAsyncWaiter(WidgetHost* proxy);
  ~WidgetHostAsyncWaiter();

 private:
  WidgetHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WidgetHostAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PAGE_WIDGET_MOJOM_BLINK_TEST_UTILS_H_