// Copyright 2020 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated by running //components/schema_org/generate_schema_org_code.py.
// Do not edit.

#include "base/hash/hash.h"
#include "components/schema_org/schema_org_property_configurations.h"

namespace schema_org {
namespace property {

PropertyConfiguration GetPropertyConfiguration(const std::string& name) {
  switch (base::PersistentHash(name)) {
    case 0x962c1b6:
      // about
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xec118bc4:
      // acceptedAnswer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Answer",
          "http://schema.org/ItemList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7a6c2592:
      // acceptedOffer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Offer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x85d2722c:
      // acceptedPaymentMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/LoanOrCredit",
        },
        /* .enum_types = */ {
          "http://schema.org/PaymentMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb4b342c2:
      // acceptsReservations
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x362a367c:
      // accessCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x51c036de:
      // accessMode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8c4f2cb9:
      // accessModeSufficient
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ItemList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x190862c8:
      // accessibilityAPI
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x50f4ca9c:
      // accessibilityControl
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf5a28e2f:
      // accessibilityFeature
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4dd6f516:
      // accessibilityHazard
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf6620586:
      // accessibilitySummary
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb07aebe1:
      // accountId
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x503c28dd:
      // accountablePerson
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd4e2b5ea:
      // acquiredFrom
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfc1e8e1c:
      // actionAccessibilityRequirement
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ActionAccessSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x55f90ac0:
      // actionApplication
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SoftwareApplication",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1dd454ae:
      // actionOption
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xccbeb873:
      // actionPlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xccd463eb:
      // actionStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/ActionStatusType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe831b699:
      // actor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8dbbde3:
      // actors
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x248c0cb:
      // addOn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Offer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xff9c0336:
      // additionalName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe08982c0:
      // additionalNumberOfGuests
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3e1fc202:
      // additionalProperty
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PropertyValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8fcbff0a:
      // additionalType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x835e7f7c:
      // address
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8bf3e26:
      // addressCountry
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Country",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x98cf9b59:
      // addressLocality
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6e3c4ec9:
      // addressRegion
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4e42d4c5:
      // advanceBookingRequirement
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdd7d2e6d:
      // affiliation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc4c8fe5a:
      // afterMedia
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2db76102:
      // agent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdc7c4890:
      // aggregateRating
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AggregateRating",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6f341b76:
      // aircraft
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Vehicle",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5a90571f:
      // album
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicAlbum",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x78d481d:
      // albumProductionType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/MusicAlbumProductionType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1d929b20:
      // albumRelease
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicRelease",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbd3e1c50:
      // albumReleaseType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/MusicAlbumReleaseType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x18420948:
      // albums
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicAlbum",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6d12fee9:
      // alignmentType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9d5238dc:
      // alternateName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdab8c9ae:
      // alternativeHeadline
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x53b54e48:
      // alumni
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xeefa1502:
      // alumniOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/EducationalOrganization",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x425f0c26:
      // amenityFeature
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/LocationFeatureSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfdfc8536:
      // amount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmount",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2a37baef:
      // amountOfThisGood
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4e9c1ea8:
      // annualPercentageRate
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xab67dccb:
      // answerCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf4f085ba:
      // application
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SoftwareApplication",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xda6b3a7:
      // applicationCategory
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x64217352:
      // applicationSubCategory
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9763beb1:
      // applicationSuite
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x35c3381:
      // appliesToDeliveryMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DeliveryMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2db22f9e:
      // appliesToPaymentMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/PaymentMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2b605891:
      // area
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa2e7b4c3:
      // areaServed
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/GeoShape",
          "http://schema.org/AdministrativeArea",
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf28a06d9:
      // arrivalAirport
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Airport",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x791ac49:
      // arrivalBusStop
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BusStop",
          "http://schema.org/BusStation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3266cb87:
      // arrivalGate
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2516b291:
      // arrivalPlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x44b0ec0:
      // arrivalStation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/TrainStation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xad7f7f81:
      // arrivalTerminal
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x21d307a2:
      // arrivalTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x66fe933c:
      // artEdition
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x32455e2c:
      // artMedium
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x47c3020b:
      // artform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x16681243:
      // articleBody
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc79d610:
      // articleSection
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8ca4fbdf:
      // artworkSurface
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x89a3179d:
      // assembly
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x89cb32ee:
      // assemblyVersion
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9a9eb9ea:
      // associatedArticle
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/NewsArticle",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x72cba0ac:
      // associatedMedia
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x27f68deb:
      // athlete
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x56e7186b:
      // attendee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb77730d8:
      // attendees
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1ffe8ccd:
      // audience
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6636d63e:
      // audienceType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf8ab2117:
      // audio
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AudioObject",
          "http://schema.org/Clip",
          "http://schema.org/MusicRecording",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x860f41d1:
      // authenticator
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7adba7eb:
      // author
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcbc02b4d:
      // availability
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/ItemAvailability",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf8e6ecf7:
      // availabilityEnds
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8309c8fa:
      // availabilityStarts
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd0ec0be2:
      // availableAtOrFrom
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x423c2a63:
      // availableChannel
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ServiceChannel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4564e3e1:
      // availableDeliveryMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DeliveryMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7f4f80f7:
      // availableFrom
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9d913bd:
      // availableLanguage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Language",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd82fc262:
      // availableOnDevice
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xab135944:
      // availableThrough
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1458d078:
      // award
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb2bd2944:
      // awards
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5feef653:
      // awayTeam
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SportsTeam",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe0acf0a0:
      // baseSalary
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PriceSpecification",
          "http://schema.org/MonetaryAmount",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x628f1e4d:
      // bccRecipient
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x131d9400:
      // bed
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BedDetails",
        },
        /* .enum_types = */ {
          "http://schema.org/BedType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x94032789:
      // beforeMedia
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1271f5b7:
      // benefits
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xde7a20c4:
      // bestRating
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbb21f62a:
      // billingAddress
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfac5e1a9:
      // billingIncrement
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xde3b267f:
      // billingPeriod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6016531a:
      // birthDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xde1e414e:
      // birthPlace
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6dfd249b:
      // bitrate
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x215d179a:
      // blogPost
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BlogPosting",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x71193c23:
      // blogPosts
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BlogPosting",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x67e739fe:
      // boardingGroup
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x70ec4a61:
      // boardingPolicy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/BoardingPolicyType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3e18ce80:
      // bookEdition
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x163d2ef5:
      // bookFormat
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/BookFormatType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5b9c8ade:
      // bookingAgent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x28081b10:
      // bookingTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbac3c914:
      // borrower
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbe2e8480:
      // box
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7d66016:
      // branchCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf06ec027:
      // branchOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xafa4a1b0:
      // brand
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Brand",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2162f2ec:
      // breadcrumb
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BreadcrumbList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb5d3f803:
      // broadcastAffiliateOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xeb7299f9:
      // broadcastChannelId
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x78273cb7:
      // broadcastDisplayName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbe987c63:
      // broadcastFrequency
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BroadcastFrequencySpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf6d22db2:
      // broadcastFrequencyValue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5aae1ce2:
      // broadcastOfEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7f838630:
      // broadcastServiceTier
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf4bd6736:
      // broadcastTimezone
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa9497156:
      // broadcaster
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6d948fe7:
      // broker
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8d77a084:
      // browserRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2aa09e50:
      // busName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x264f0f1b:
      // busNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x89011222:
      // businessFunction
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/BusinessFunction",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfacb7499:
      // buyer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x23c6b81e:
      // byArtist
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/MusicGroup",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2b751045:
      // calories
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Energy",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa0acab18:
      // candidate
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2161ae3a:
      // caption
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6ebfb35e:
      // carbohydrateContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x16b081c2:
      // cargoVolume
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b46252c:
      // carrier
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5a7dad6a:
      // carrierRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbc48d55:
      // catalog
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DataCatalog",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc90ebb51:
      // catalogNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x74d6a505:
      // category
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc694c7c1:
      // ccRecipient
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/ContactPoint",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfca1c950:
      // character
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x63fcf04a:
      // characterAttribute
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xedc2424c:
      // characterName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x309519:
      // cheatCode
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc7b9d63d:
      // checkinTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x88e51c01:
      // checkoutTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe4b6ca2a:
      // childMaxAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc0ce385c:
      // childMinAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x27ef1c61:
      // children
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x10848849:
      // cholesterolContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x97f78140:
      // circle
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6ef08d8b:
      // citation
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcd73164d:
      // claimReviewed
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5aa89110:
      // clipNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x32697cd8:
      // closes
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb69ae175:
      // coach
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xba26f60:
      // codeRepository
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdbfcbef2:
      // codeSampleType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4d3acbf5:
      // colleague
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd6af6ff8:
      // colleagues
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7a0af1a8:
      // collection
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4abde0ea:
      // color
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9ec6f279:
      // comment
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Comment",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x97570ddd:
      // commentCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xad1f563f:
      // commentText
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xee54d79a:
      // commentTime
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9288805f:
      // competitor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/SportsTeam",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe72e8856:
      // composer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x58b9afff:
      // confirmationNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdb3ac1f5:
      // contactOption
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/ContactPointOption",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4ead3eb:
      // contactPoint
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc57d9eed:
      // contactPoints
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x45c25f8c:
      // contactType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x91414c1f:
      // containedIn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xda0a6ab6:
      // containedInPlace
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x48abc668:
      // containsPlace
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xab1c6146:
      // containsSeason
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWorkSeason",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2074d305:
      // contentLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd95d6227:
      // contentRating
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Rating",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6742b4d0:
      // contentSize
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x803b651a:
      // contentType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfd2ce44c:
      // contentUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf496b066:
      // contributor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x472c968:
      // cookTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9723dc6c:
      // cookingMethod
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xecdc84:
      // copyrightHolder
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x57e0bcb3:
      // copyrightYear
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5b4bed72:
      // countriesNotSupported
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xefa14e73:
      // countriesSupported
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd43153f8:
      // countryOfOrigin
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Country",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x308c6471:
      // course
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x72121558:
      // courseCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdcadb15a:
      // courseMode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x950f842:
      // coursePrerequisites
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AlignmentObject",
          "http://schema.org/Course",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd45d8e5a:
      // coverageEndTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe50fb9f1:
      // coverageStartTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x405f5bd7:
      // creator
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x946504dc:
      // creditedTo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbb33bfc0:
      // cssSelector
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfe4c7c61:
      // currenciesAccepted
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4c3bc04b:
      // currency
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x338de1da:
      // customer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x17774cb1:
      // dataFeedElement
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
          "http://schema.org/DataFeedItem",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x700bb2ab:
      // dataset
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Dataset",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5411481a:
      // datasetTimeInterval
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x566e9822:
      // dateCreated
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7dfca5bf:
      // dateDeleted
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7e828c2f:
      // dateIssued
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x937681e2:
      // dateModified
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3165825a:
      // datePosted
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4c01506b:
      // datePublished
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3dac3a18:
      // dateRead
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x32a94d26:
      // dateReceived
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7f191690:
      // dateSent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x82579d53:
      // dateVehicleFirstRegistered
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9a832641:
      // dateline
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1947cbf3:
      // dayOfWeek
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DayOfWeek",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd1d9fa19:
      // deathDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6c80143c:
      // deathPlace
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc149cd29:
      // defaultValue
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x60c00448:
      // deliveryAddress
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd4ae6662:
      // deliveryLeadTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf8c104eb:
      // deliveryMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DeliveryMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x62e86eeb:
      // deliveryStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DeliveryEvent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcc8d4de4:
      // department
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4939ad7b:
      // departureAirport
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Airport",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x20b97fa6:
      // departureBusStop
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BusStation",
          "http://schema.org/BusStop",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe786aa61:
      // departureGate
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6fbe2eef:
      // departurePlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xafd753de:
      // departureStation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/TrainStation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2fbe0397:
      // departureTerminal
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x710c386e:
      // departureTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x839633c4:
      // dependencies
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb767b54a:
      // depth
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
          "http://schema.org/Distance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xebcc4f32:
      // description
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xae90e217:
      // device
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc5350498:
      // director
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe404551c:
      // directors
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x494da2f1:
      // disambiguatingDescription
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd4d0e225:
      // discount
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa54d293b:
      // discountCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x33dbc6f:
      // discountCurrency
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x686bf3e0:
      // discusses
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb4c7bb50:
      // discussionUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8655551:
      // dissolutionDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xff902d96:
      // distance
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Distance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2d011af8:
      // distribution
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DataDownload",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x181a0efc:
      // doorTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x94c1abfd:
      // downloadUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xea87cf8d:
      // downvoteCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc53b099a:
      // driveWheelConfiguration
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DriveWheelConfigurationValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x745a8f70:
      // dropoffLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe5a905d5:
      // dropoffTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd9482ad0:
      // duns
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xab728e50:
      // duration
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa49ac1dd:
      // durationOfWarranty
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1497c701:
      // duringMedia
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc4ccf27b:
      // editor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa249ca4f:
      // educationalAlignment
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AlignmentObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa69d720f:
      // educationalCredentialAwarded
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdb24faa3:
      // educationalFramework
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x961cdce9:
      // educationalRole
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd2d3c009:
      // educationalUse
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x19628b7c:
      // elevation
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x167b7dc1:
      // eligibleCustomerType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/BusinessEntityType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x21dbe5e7:
      // eligibleDuration
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xce6b9bd5:
      // eligibleQuantity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x22d8398:
      // eligibleRegion
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
          "http://schema.org/GeoShape",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc0a453cd:
      // eligibleTransactionVolume
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb6dead17:
      // email
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9ad61a6c:
      // embedUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x14976ea:
      // employee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfc62e552:
      // employees
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4522974c:
      // employmentType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6862480b:
      // encodesCreativeWork
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x374d1d78:
      // encoding
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf55cb3:
      // encodingFormat
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4d6f2c1e:
      // encodingType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcbeaf519:
      // encodings
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MediaObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbe3e432e:
      // endDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7800cc2:
      // endTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1285cc11:
      // endorsee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x93771ba9:
      // entertainmentBusiness
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/EntertainmentBusiness",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf5e7233d:
      // episode
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Episode",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4884e837:
      // episodeNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x221c68a4:
      // episodes
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Episode",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2ecfc34:
      // equal
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa206bc84:
      // error
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x63633e12:
      // estimatedCost
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmount",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xef2c1823:
      // estimatedFlightDuration
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xaca0d3d0:
      // estimatedSalary
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmountDistribution",
          "http://schema.org/MonetaryAmount",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x16d5a505:
      // event
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6335a938:
      // eventStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/EventStatusType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x68d32684:
      // events
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb1ee1438:
      // exampleOfWork
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xaf9f5e44:
      // executableLibraryName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8a671e1d:
      // exerciseCourse
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x50b69640:
      // exifData
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PropertyValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x72f4527f:
      // expectedArrivalFrom
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x87b7e052:
      // expectedArrivalUntil
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5857cce4:
      // expectsAcceptanceOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Offer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x85f18ea1:
      // experienceRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa619886e:
      // expires
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x287b85c:
      // familyName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb0e7a071:
      // fatContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf9feb3f7:
      // faxNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x146010f5:
      // featureList
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x381b5fe4:
      // feesAndCommissionsSpecification
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5485194:
      // fiberContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x400dbcc5:
      // fileFormat
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7cd82a12:
      // fileSize
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1fa18c26:
      // firstPerformance
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb3fc8459:
      // flightDistance
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Distance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x700bd1c5:
      // flightNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x467d7031:
      // floorSize
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2732d776:
      // followee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x73936c8:
      // follows
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6fbd64b6:
      // foodEstablishment
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/FoodEstablishment",
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd5d74453:
      // foodEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/FoodEvent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbf918bb8:
      // founder
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf1fd0e55:
      // founders
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcb3baca:
      // foundingDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x15519dc3:
      // foundingLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcd05aed4:
      // free
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x94109dcd:
      // fromLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9fd36df9:
      // fuelConsumption
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x313b28ef:
      // fuelEfficiency
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x607f2924:
      // fuelType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd9ef16eb:
      // funder
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa748577b:
      // game
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/VideoGame",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb034fb1:
      // gameItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7ce3b5d7:
      // gameLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x400d76c5:
      // gamePlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x61c64aff:
      // gameServer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/GameServer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcc313978:
      // gameTip
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x694de4aa:
      // genre
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3eae31df:
      // geo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/GeoShape",
          "http://schema.org/GeoCoordinates",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa66d6a02:
      // geoContains
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7b3a694e:
      // geoCoveredBy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbb8b4037:
      // geoCovers
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc089c474:
      // geoCrosses
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x70e30d62:
      // geoDisjoint
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4a602ba0:
      // geoEquals
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc6f1566f:
      // geoIntersects
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x903c07bc:
      // geoMidpoint
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/GeoCoordinates",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x161bc2cf:
      // geoOverlaps
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x87d2060:
      // geoRadius
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Distance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc83b5e29:
      // geoTouches
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x42d3a66a:
      // geoWithin
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3b283628:
      // geographicArea
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AdministrativeArea",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3d8daf77:
      // givenName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x582b6c54:
      // globalLocationNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3f87fe7:
      // grantee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Audience",
          "http://schema.org/Organization",
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x96f49a63:
      // greater
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3aea790e:
      // greaterOrEqual
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb3e1476d:
      // gtin12
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x81ab1893:
      // gtin13
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x114d725:
      // gtin14
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb5eb5340:
      // gtin8
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf8ee3e25:
      // hasBroadcastChannel
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BroadcastChannel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xed65d808:
      // hasCourseInstance
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CourseInstance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x31917b59:
      // hasDeliveryMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DeliveryMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x866325c2:
      // hasDigitalDocumentPermission
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DigitalDocumentPermission",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8e02fa14:
      // hasMap
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Map",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8fed8a9f:
      // hasMenu
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Menu",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x85ee89f2:
      // hasMenuItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MenuItem",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9a06102a:
      // hasMenuSection
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MenuSection",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf6003b01:
      // hasOccupation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Occupation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x42ab62ae:
      // hasOfferCatalog
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/OfferCatalog",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x405ed08b:
      // hasPOS
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2689eb4:
      // hasPart
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8fcfe25d:
      // headline
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2926274:
      // height
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
          "http://schema.org/Distance",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x53f3dcbf:
      // highPrice
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3bba92ea:
      // hiringOrganization
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x208cc109:
      // homeLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x96af7442:
      // homeTeam
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SportsTeam",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9978b9fb:
      // honorificPrefix
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf67dc377:
      // honorificSuffix
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2bc3c20a:
      // hostingOrganization
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b178eea:
      // hoursAvailable
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/OpeningHoursSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa76cf999:
      // httpMethod
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd5b3d12f:
      // iataCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6fd34845:
      // icaoCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x21c1149d:
      // identifier
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PropertyValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x10753069:
      // illustrator
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb8128f08:
      // image
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd856bb37:
      // inAlbum
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicAlbum",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4ff1c4b3:
      // inBroadcastLineup
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CableOrSatelliteService",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x207838b:
      // inLanguage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Language",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1a313217:
      // inPlaylist
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicPlaylist",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4babddac:
      // incentiveCompensation
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x41755d22:
      // incentives
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2a70f2b7:
      // includedComposition
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicComposition",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9bc5c6d3:
      // includedDataCatalog
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DataCatalog",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6924145b:
      // includedInDataCatalog
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DataCatalog",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4af0d091:
      // includesObject
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/TypeAndQuantityNode",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd62a746d:
      // industry
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2d6a967a:
      // ingredients
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xab1e2a63:
      // installUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x44b41874:
      // instructor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x33cac667:
      // instrument
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6dbaf8d1:
      // interactionCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf72009c:
      // interactionService
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/WebSite",
          "http://schema.org/SoftwareApplication",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd48c6bc2:
      // interactionStatistic
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/InteractionCounter",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3d3ac718:
      // interactionType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Action",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa0835ea9:
      // interactivityType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa2a600ea:
      // interestRate
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9a1638fe:
      // inventoryLevel
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x651f5176:
      // isAccessibleForFree
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6813cfa2:
      // isAccessoryOrSparePartFor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4f9552b5:
      // isBasedOn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3f2b7e46:
      // isBasedOnUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa6260de8:
      // isConsumableFor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9e51c60c:
      // isFamilyFriendly
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3e15a24a:
      // isGift
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x55cce40:
      // isLiveBroadcast
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5cedd703:
      // isPartOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc3057553:
      // isRelatedTo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x749c1ad3:
      // isSimilarTo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x482e3dda:
      // isVariantOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ProductModel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x62c99412:
      // isbn
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb3e0da25:
      // isicV4
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf1192128:
      // isrcCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3c795549:
      // issn
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7c942989:
      // issueNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x344f3756:
      // issuedBy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc5d9ba74:
      // issuedThrough
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x68186937:
      // iswcCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdeffa2ab:
      // item
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe49a5fdb:
      // itemCondition
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/OfferItemCondition",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x146439c3:
      // itemListElement
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
          "http://schema.org/ListItem",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2ecd41a5:
      // itemListOrder
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/ItemListOrderType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1ab660b9:
      // itemOffered
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Trip",
          "http://schema.org/AggregateOffer",
          "http://schema.org/MenuItem",
          "http://schema.org/Product",
          "http://schema.org/Event",
          "http://schema.org/CreativeWork",
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4449b740:
      // itemReviewed
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb1b5867d:
      // itemShipped
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2bcb410f:
      // jobBenefits
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3905f533:
      // jobLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b433a3b:
      // keywords
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf1fd0ae6:
      // knownVehicleDamages
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf3c99d7b:
      // knows
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa05bb3f:
      // landlord
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfb8e09fc:
      // language
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Language",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x70b0c058:
      // lastReviewed
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb8ec7dac:
      // latitude
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x72bcc323:
      // learningResourceType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf0b89f7d:
      // legalName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x17ab4758:
      // leiCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc1e61812:
      // lender
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x806eefe6:
      // lesser
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4e9dba77:
      // lesserOrEqual
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdea4cfd8:
      // license
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x44cc9afc:
      // line
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe16bc689:
      // liveBlogUpdate
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BlogPosting",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x71570938:
      // loanTerm
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4a4f24a9:
      // location
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5498c3a0:
      // locationCreated
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x714da6eb:
      // lodgingUnitDescription
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe41acde1:
      // lodgingUnitType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x115aa71b:
      // logo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x451361b0:
      // longitude
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6803ea93:
      // loser
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbdfc53a:
      // lowPrice
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7d979d17:
      // lyricist
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf68c4535:
      // lyrics
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7165c366:
      // mainContentOfPage
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/WebPageElement",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x75241127:
      // mainEntity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x45caa0f0:
      // mainEntityOfPage
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x976ca3f5:
      // makesOffer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Offer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x59669873:
      // manufacturer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc93f86bf:
      // map
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x73694545:
      // mapType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/MapCategoryType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x990f92e:
      // maps
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x63f9463b:
      // material
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x34230912:
      // maxPrice
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x51224fa6:
      // maxValue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x852ebe2e:
      // maximumAttendeeCapacity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xda870123:
      // mealService
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x364b6df9:
      // median
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x33946321:
      // member
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa414c86f:
      // memberOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/ProgramMembership",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9c03b236:
      // members
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa6bc7afa:
      // membershipNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4984e639:
      // memoryRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x38aaa9ed:
      // mentions
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9cc9971f:
      // menu
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Menu",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x788ebfde:
      // menuAddOn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MenuItem",
          "http://schema.org/MenuSection",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf18bca12:
      // merchant
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1af9ba0d:
      // messageAttachment
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x43582b86:
      // mileageFromOdometer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x221247a8:
      // minPrice
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x381b5bb8:
      // minValue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9d23fe2f:
      // minimumPaymentDue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmount",
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3c504f93:
      // model
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ProductModel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x14a2a7fc:
      // modifiedTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc3b2122c:
      // mpn
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5a771152:
      // multipleValues
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf7ec9076:
      // musicArrangement
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicComposition",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x70ada09f:
      // musicBy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicGroup",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6011302e:
      // musicCompositionForm
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd9c5adc3:
      // musicGroupMember
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb49588c9:
      // musicReleaseFormat
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/MusicReleaseFormatType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa46beeae:
      // musicalKey
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe4350965:
      // naics
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xceaaa6c8:
      // name
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x991a0e86:
      // namedPosition
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1bed452a:
      // nationality
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Country",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x60179ca6:
      // netWorth
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmount",
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8c1fbfd7:
      // nextItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ListItem",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc5777007:
      // nonEqual
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x90a67242:
      // numAdults
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6e236897:
      // numChildren
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb86ca3d1:
      // numTracks
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x997b5203:
      // numberOfAirbags
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3cf9cec8:
      // numberOfAxles
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x54968f88:
      // numberOfBeds
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7430d071:
      // numberOfDoors
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3bbfc165:
      // numberOfEmployees
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x12b29b47:
      // numberOfEpisodes
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8fee5f5:
      // numberOfForwardGears
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x88815d64:
      // numberOfItems
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4e3a9754:
      // numberOfPages
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcc940d86:
      // numberOfPlayers
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5bc488ca:
      // numberOfPreviousOwners
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7115f:
      // numberOfRooms
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x46bfd89:
      // numberOfSeasons
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xabe220e3:
      // numberedPosition
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb24be58d:
      // nutrition
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/NutritionInformation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb00a3c95:
      // object
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf57310c6:
      // occupancy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb2e6f145:
      // occupationLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AdministrativeArea",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6338c1ec:
      // occupationalCategory
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7eea1a3:
      // offerCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x683e49b2:
      // offeredBy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x21bda411:
      // offers
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Demand",
          "http://schema.org/Offer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7482eee0:
      // openingHours
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1005e5c1:
      // openingHoursSpecification
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/OpeningHoursSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd67d2e07:
      // opens
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x500186a0:
      // operatingSystem
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x164f2443:
      // opponent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfb9aa686:
      // option
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2fef8d96:
      // orderDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7ff3c8f9:
      // orderDelivery
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ParcelDelivery",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6c6cdbf7:
      // orderItemNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd4b228d2:
      // orderItemStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/OrderStatus",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x64216ce2:
      // orderNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7da85870:
      // orderQuantity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf742bb7c:
      // orderStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/OrderStatus",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x84db4586:
      // orderedItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
          "http://schema.org/OrderItem",
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x514dafe5:
      // organizer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6ba7fbea:
      // originAddress
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8d2885a9:
      // ownedFrom
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3eb1786d:
      // ownedThrough
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5f8028af:
      // owns
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/OwnershipInfo",
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3d407c90:
      // pageEnd
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x93198642:
      // pageStart
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc2dbde60:
      // pagination
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x21b81c7b:
      // parent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc118a9b1:
      // parentItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Question",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x674b099f:
      // parentOrganization
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5841bb36:
      // parentService
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BroadcastService",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd21a4479:
      // parents
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x315ce6b7:
      // partOfEpisode
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Episode",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x433bc253:
      // partOfInvoice
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Invoice",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x48319aa8:
      // partOfOrder
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Order",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdecc44c:
      // partOfSeason
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWorkSeason",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1cb29c63:
      // partOfSeries
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWorkSeries",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x54d970bf:
      // partOfTVSeries
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/TVSeries",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x69300786:
      // participant
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x58af8621:
      // partySize
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xffd4c470:
      // passengerPriorityStatus
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc73628a8:
      // passengerSequenceNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xae7fc5d3:
      // paymentAccepted
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc2c7876c:
      // paymentDue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x550cf391:
      // paymentDueDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x489ad660:
      // paymentMethod
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/PaymentMethod",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2c9aa067:
      // paymentMethodId
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x26fb9e93:
      // paymentStatus
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/PaymentStatusType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7894b57e:
      // paymentUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7c3bd13e:
      // percentile10
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9c985967:
      // percentile25
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xeba789f6:
      // percentile75
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x146149a1:
      // percentile90
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1a1574a3:
      // performTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x59806d7b:
      // performer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x15d21199:
      // performerIn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x423e87be:
      // performers
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x488f4ca0:
      // permissionType
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/DigitalDocumentPermissionType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x34ab7471:
      // permissions
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2c671653:
      // permitAudience
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x164ded61:
      // permittedUsage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6d1b68:
      // petsAllowed
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x221e7628:
      // photo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Photograph",
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b40db26:
      // photos
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
          "http://schema.org/Photograph",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2fa0e2e9:
      // pickupLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8d160640:
      // pickupTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x641c1ed:
      // playMode
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/GamePlayMode",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd603458d:
      // playerType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc14a5f53:
      // playersOnline
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x49c200d3:
      // polygon
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbb7f0d29:
      // position
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf25c2bf0:
      // postOfficeBoxNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x613d6424:
      // postalCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe2f655b2:
      // potentialAction
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Action",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5f336d3b:
      // predecessorOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ProductModel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5cf57f90:
      // prepTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc12ae741:
      // previousItem
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ListItem",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x712b5fd6:
      // previousStartDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x62655f33:
      // price
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xad63aab7:
      // priceComponent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/UnitPriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x95fa6190:
      // priceCurrency
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5a425c33:
      // priceRange
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x83fd1897:
      // priceSpecification
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9d1a85d2:
      // priceType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x69bcca17:
      // priceValidUntil
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x409af558:
      // primaryImageOfPage
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1410f67c:
      // printColumn
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3dd95d31:
      // printEdition
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb6764483:
      // printPage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x91485ae6:
      // printSection
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x82c3a55b:
      // processingTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1081fde5:
      // processorRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x88572c16:
      // producer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x449dc649:
      // produces
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9c8a9d81:
      // productID
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x22a621:
      // productSupported
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa9df3fa3:
      // productionCompany
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfd27ae0b:
      // productionDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc5c0d69a:
      // proficiencyLevel
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcf9212c:
      // programMembershipUsed
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ProgramMembership",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x444684c2:
      // programName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe0e2e2bf:
      // programmingLanguage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ComputerLanguage",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xadebd36:
      // programmingModel
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa62f0c9:
      // propertyID
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x16ae2f58:
      // proteinContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa168235c:
      // provider
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x95baf550:
      // providerMobility
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x58a263c9:
      // providesBroadcastService
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BroadcastService",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x35d6a18:
      // providesService
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x123b11cd:
      // publicAccess
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2f3e18a9:
      // publication
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PublicationEvent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe4c10140:
      // publishedOn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/BroadcastService",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc2e4da5b:
      // publisher
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6ba37924:
      // publishingPrinciples
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b77085c:
      // purchaseDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc652a73a:
      // query
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9afcd1c0:
      // quest
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9100d5e8:
      // question
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Question",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd2b30e1d:
      // ratingCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa96df859:
      // ratingValue
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x47805960:
      // readonlyValue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x52c47fe4:
      // realEstateAgent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/RealEstateAgent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9242cc12:
      // recipe
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Recipe",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5effdebc:
      // recipeCategory
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x515c6b2e:
      // recipeCuisine
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe2e94daf:
      // recipeIngredient
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2eb380f8:
      // recipeInstructions
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
          "http://schema.org/ItemList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6b67ccc5:
      // recipeYield
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x776fec19:
      // recipient
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
          "http://schema.org/Organization",
          "http://schema.org/Person",
          "http://schema.org/Audience",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbef41c12:
      // recordLabel
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x35b58e68:
      // recordedAs
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicRecording",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x130fb7f3:
      // recordedAt
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x554659f2:
      // recordedIn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xace9ca44:
      // recordingOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicComposition",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc024e7d1:
      // referenceQuantity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc45c3152:
      // referencesOrder
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Order",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x113302:
      // regionsAllowed
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x679ebf2:
      // relatedLink
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x503458aa:
      // relatedTo
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x14bd2069:
      // releaseDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x74d0e77d:
      // releaseNotes
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9e7364cf:
      // releaseOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicAlbum",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3719b4ab:
      // releasedEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PublicationEvent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4c1cfac3:
      // relevantOccupation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Occupation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4c9d0a95:
      // remainingAttendeeCapacity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfb8fb7af:
      // replacee
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x67afce4d:
      // replacer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x81aae7da:
      // replyToUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4ecebf95:
      // reportNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x603de52b:
      // representativeOfPage
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1090ed7d:
      // requiredCollateral
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf7e5a46c:
      // requiredGender
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbaffdf17:
      // requiredMaxAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc476b601:
      // requiredMinAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x94c71191:
      // requiredQuantity
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x759ff319:
      // requirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2a88eb3c:
      // requiresSubscription
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
          "http://schema.org/MediaSubscription",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1f64f057:
      // reservationFor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3133dd57:
      // reservationId
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x399af69:
      // reservationStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/ReservationStatusType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3b5e018a:
      // reservedTicket
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Ticket",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb6def299:
      // responsibilities
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xeb00ce35:
      // result
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x77db9901:
      // resultComment
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Comment",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbbfd2a6:
      // resultReview
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Review",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa10f72ff:
      // review
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Review",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x17ca4baf:
      // reviewAspect
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcc918922:
      // reviewBody
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x84e6989f:
      // reviewCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc04107d8:
      // reviewRating
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Rating",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf5987c3c:
      // reviewedBy
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x734ad62b:
      // reviews
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Review",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6f13f7f6:
      // roleName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x39f04ba4:
      // rsvpResponse
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/RsvpResponseType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x32331731:
      // runtime
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8a36e4e7:
      // runtimePlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe5c9f03e:
      // salaryCurrency
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x50a6217a:
      // sameAs
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xde0b1acf:
      // sampleType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x653b8832:
      // saturatedFatContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x84ec37c6:
      // scheduledPaymentDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x95a56078:
      // scheduledTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x328506b:
      // schemaVersion
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x99c6f989:
      // screenCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9dbc2780:
      // screenshot
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x712d45ae:
      // season
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWorkSeason",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc5b261c3:
      // seasonNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf70f94e:
      // seasons
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWorkSeason",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x568cd07a:
      // seatNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc1a54d3e:
      // seatRow
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbbe34251:
      // seatSection
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x442a3dc0:
      // seatingType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3c2c20b5:
      // securityScreening
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x861728a6:
      // seeks
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Demand",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x607efa90:
      // seller
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x80c899e9:
      // sender
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xffd01b36:
      // serialNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5abbede4:
      // serverStatus
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/GameServerStatus",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd3313578:
      // servesCuisine
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3b3776fe:
      // serviceArea
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/GeoShape",
          "http://schema.org/AdministrativeArea",
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x176df3d4:
      // serviceAudience
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x56b91f0:
      // serviceLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xaced91a1:
      // serviceOperator
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3d88d096:
      // serviceOutput
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf868fc98:
      // servicePhone
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6de75cb3:
      // servicePostalAddress
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PostalAddress",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbbc15871:
      // serviceSmsNumber
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2ae21fc4:
      // serviceType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5aa18792:
      // serviceUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfe1a7285:
      // servingSize
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3841672:
      // sharedContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbe218db0:
      // sibling
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf9d0cb4f:
      // siblings
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x13b3fc69:
      // significantLink
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x79a27fab:
      // significantLinks
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x60e6d7d0:
      // skills
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x95299456:
      // sku
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf24cad48:
      // slogan
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x927e02dd:
      // smokingAllowed
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2e709e81:
      // sodiumContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x706c1153:
      // softwareAddOn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SoftwareApplication",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x46f69a65:
      // softwareHelp
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1242f562:
      // softwareRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x48c2d419:
      // softwareVersion
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4a50c260:
      // sourceOrganization
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7801d402:
      // spatial
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5f0db3:
      // spatialCoverage
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa0247d0c:
      // speakable
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SpeakableSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc7b41999:
      // specialCommitments
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x70029856:
      // specialOpeningHoursSpecification
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/OpeningHoursSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x34589e2c:
      // specialty
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/Specialty",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb7a31db9:
      // sponsor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf2f3f571:
      // sportsActivityLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SportsActivityLocation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa03c67b5:
      // sportsEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SportsEvent",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3188a1ae:
      // sportsTeam
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SportsTeam",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe11bc586:
      // spouse
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb427d14a:
      // starRating
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Rating",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcf24871c:
      // startDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9fc9aece:
      // startTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ true,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4f983a31:
      // steeringPosition
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/SteeringPositionValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf648e980:
      // step
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
          "http://schema.org/HowToSection",
          "http://schema.org/HowToStep",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xedabea26:
      // stepValue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8cbfc1c7:
      // steps
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
          "http://schema.org/ItemList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x140b0517:
      // storageRequirements
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2bded1ce:
      // streetAddress
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x12994b1:
      // subEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7201b0f:
      // subEvents
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9e9f4b90:
      // subOrganization
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8356492b:
      // subReservation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Reservation",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5e59f10c:
      // subjectOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd9b18bfb:
      // successorOf
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ProductModel",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9dac4f36:
      // sugarContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xeda6eb61:
      // suggestedAnswer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ItemList",
          "http://schema.org/Answer",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcf197989:
      // suggestedGender
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdfe8e4ed:
      // suggestedMaxAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9036764f:
      // suggestedMinAge
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xed2e5145:
      // suitableForDiet
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/RestrictedDiet",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb41f503:
      // superEvent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Event",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc52a95d5:
      // supply
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/HowToSupply",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbf587abd:
      // supportingData
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/DataFeed",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x119b8886:
      // surface
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc581c8bd:
      // target
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/EntryPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x648b3632:
      // targetCollection
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Thing",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xf240fec3:
      // targetDescription
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x10d7773a:
      // targetName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd2c94b1f:
      // targetPlatform
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9e496cc1:
      // targetProduct
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/SoftwareApplication",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x894fc65f:
      // targetUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc6483658:
      // taxID
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xaa2d6156:
      // telephone
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2e33bba2:
      // temporal
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8944a52f:
      // temporalCoverage
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x222e00a7:
      // text
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe630a8c:
      // thumbnail
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ImageObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x11556796:
      // thumbnailUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xccdf1ad5:
      // tickerSymbol
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4c455bd9:
      // ticketNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcd0f2b37:
      // ticketToken
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x24374570:
      // ticketedSeat
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Seat",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3599a898:
      // timeRequired
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd8401fe:
      // title
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9bc63aee:
      // toLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1f9191a9:
      // toRecipient
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
          "http://schema.org/Person",
          "http://schema.org/Organization",
          "http://schema.org/ContactPoint",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x92f067e4:
      // tool
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/HowToTool",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6bb36c1b:
      // totalPaymentDue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MonetaryAmount",
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xef8d2c78:
      // totalPrice
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/PriceSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6f6d3fd0:
      // totalTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5b94346c:
      // touristType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Audience",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe06d46f2:
      // track
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicRecording",
          "http://schema.org/ItemList",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9be3f4cb:
      // trackingNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8b3babad:
      // trackingUrl
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x804cd822:
      // tracks
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/MusicRecording",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x348be388:
      // trailer
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/VideoObject",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xfbcdad53:
      // trainName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc02c66dc:
      // trainNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcd6f04ad:
      // transFatContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x59e14e1:
      // transcript
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x183356a1:
      // translator
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9c309bae:
      // typeOfBed
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/BedType",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x594bab01:
      // typeOfGood
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Product",
          "http://schema.org/Service",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd515fad8:
      // typicalAgeRange
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7d5fe630:
      // underName
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5c02afcb:
      // unitCode
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x470cdff4:
      // unitText
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x97f4e495:
      // unsaturatedFatContent
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Mass",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xaf33ac47:
      // uploadDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4bd9b12b:
      // upvoteCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3ef8f1fc:
      // url
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6021a68:
      // urlTemplate
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xcc160560:
      // userInteractionCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5a7649ab:
      // validFor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Duration",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xd2a4278e:
      // validFrom
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x314c594e:
      // validIn
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/AdministrativeArea",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2b13f194:
      // validThrough
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x555bb73d:
      // validUntil
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc562359f:
      // value
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ true,
        /* .boolean = */ true,
        /* .thing_types = */ {
          "http://schema.org/StructuredValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8f82d494:
      // valueAddedTaxIncluded
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xa2dcab43:
      // valueMaxLength
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x8081aa8d:
      // valueMinLength
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x3dd1632c:
      // valueName
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x100cd32:
      // valuePattern
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x896b9290:
      // valueReference
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/StructuredValue",
          "http://schema.org/Enumeration",
          "http://schema.org/QuantitativeValue",
          "http://schema.org/PropertyValue",
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xed0c6929:
      // valueRequired
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ true,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1f305e7:
      // vatID
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x18028d4:
      // vehicleConfiguration
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x968ebcaa:
      // vehicleEngine
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/EngineSpecification",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6f9d231a:
      // vehicleIdentificationNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9c31f4d7:
      // vehicleInteriorColor
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x42ab695d:
      // vehicleInteriorType
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9b933a9e:
      // vehicleModelDate
      return {
        /* .text = */ false,
        /* .date = */ true,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x5716941d:
      // vehicleSeatingCapacity
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7e2650c1:
      // vehicleTransmission
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ true,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/QualitativeValue",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4296baf5:
      // vendor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1d2aaf5c:
      // version
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbab72c1:
      // video
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/VideoObject",
          "http://schema.org/Clip",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc9ccb8af:
      // videoFormat
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xdf42eb39:
      // videoFrameSize
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x90e9a9df:
      // videoQuality
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2440e3d3:
      // volumeNumber
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x71c2678a:
      // warranty
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/WarrantyPromise",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x9257fd6e:
      // warrantyPromise
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/WarrantyPromise",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x79c51946:
      // warrantyScope
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
          "http://schema.org/WarrantyScope",
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x20fe0cc9:
      // webCheckinTime
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ true,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x32d6132b:
      // weight
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x796bda38:
      // width
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Distance",
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1cd01b49:
      // winner
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Person",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x1f44adb4:
      // wordCount
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6609d2b1:
      // workExample
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x2bcead6:
      // workFeatured
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4794b50c:
      // workHours
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x69c2d9dd:
      // workLocation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/ContactPoint",
          "http://schema.org/Place",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x6b0853d9:
      // workPerformed
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/CreativeWork",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xe8cee718:
      // workPresented
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Movie",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x7f50750b:
      // worksFor
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/Organization",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xc41e0723:
      // worstRating
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ true,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x25fec08d:
      // xpath
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0x4f53d067:
      // yearlyRevenue
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xbdaac6eb:
      // yearsInOperation
      return {
        /* .text = */ false,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  switch (base::PersistentHash(name)) {
    case 0xb1a06ab7:
      // yield
      return {
        /* .text = */ true,
        /* .date = */ false,
        /* .time = */ false,
        /* .date_time = */ false,
        /* .number = */ false,
        /* .url = */ false,
        /* .boolean = */ false,
        /* .thing_types = */ {
          "http://schema.org/QuantitativeValue",
        },
        /* .enum_types = */ {
        }
      };
  }
  return { };
}


}  // property
}  // schema_org